This archive contains the distribution OpenMP-Environment,
version 1.4.0:

  manage OpenMP and GNU libgomp environment variables from Perl

This software is copyright (c) 2023 by oodler577.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.


This README file was generated by Dist::Zilla::Plugin::Readme v6.032.

Demonstration of C<OpenMP::Environment>'s ability to
serve as a benchmark driver.

NPB benchmarks is a Public Domain paid for by US Citizens'
tax dollars and converted into source code by NASA. Thanks.

https://www.nas.nasa.gov/publications/npb.html

The OpenMP implementation of NPB 3.4.1 (NPB3.4-OMP)
----------------------------------------------------

For problem reports and suggestions on the implementation, 
please contact:

   NAS Parallel Benchmark Team
   npb@nas.nasa.gov


This directory contains the OpenMP implementation of the NAS
Parallel Benchmarks, Version 3.4.1 (NPB3.4-OMP).  A brief
summary of the new features introduced in this version is
given below.

For changes from different versions, see the Changes.log file
included in the upper directory of this distribution.

For explanation of compilation and running of the benchmarks,
please refer to README.install.


New features in NPB3.4-OMP of NPB 3.4.1:
  * Changed Fortran sources from fixed form to free form

  * The blocking factor for FT can now be set via make option
    "VERSION=blk<n>"

  * Minor bug fix in reporting Fortran compiler used (F77->FC)

  * Changed the reference of "INTEGER*8" to "INTEGER(8)" in randi8.f

  * The proper data type for CG is set via setparams based problem size
    so that the [-i8] flag for building Class E or F is no longer required.


New features in NPB3.4-OMP:
  * Added the class E problem size for IS, and the class F problem 
    size for BT, LU, SP, CG, EP, FT, and MG.

  * Improves loop-level parallelism with the use of the OpenMP
    COLLAPSE clause available since OpenMP 3.0.  This version 
    requires an OpenMP compiler that supports this feature.

  * Re-introduced the hyperplane implementation of LU in the 
    distribution, which is accessible via the VERSION=HP make
    option during compilation. Included a third version of LU
    that uses the DOACROSS feature in OpenMP 4.0.  This version
    requires an OpenMP compiler that supports this feature.

  * Included versions of BT and SP with blocking factor to improve 
    cache performance, and selectable via the VERSION=BLK make
    option during compilation. These versions supersede the "vector"
    version introduced in version 3.3.

  * Included a version of UA that uses array reduction for atomic
    updates.  This version is selectable via the VERSION=rd make
    option during compilation.

  * The version uses Fortran modules and allocatable arrays to define 
    and manage global data (to replace common blocks) and Fortran 2003 
    IEEE arithmetic function to catch the NaN condition during verification.

    The version requires a compiler that supports features available
    in Fortran 90 and 2003. Because of these changes, the F77 flag 
    in make.def is renamed to FC.

  * The environment variable NPB_TIMER_FLAG is now used to enable 
    additional timers.


New features in NPB3.3-OMP:
   * NPB3.3-OMP introduces a new problem size (class E) to seven of 
     the benchmarks (BT, SP, LU, CG, MG, FT, and EP). The version 
     also includes a new problem size (class D) for the IS benchmark, 
     which was not present in the previous releases.

   * The release is merged with the vector codes for the BT and LU 
     benchmarks, which can be selected with the VERSION=VEC option 
     during compilation.  However, successful vectorization highly 
     depends on the compiler used.  Some changes to compiler directives 
     for vectorization in the current codes (see *_vec.f files)
     may be required.

1. Compilation
   DC benchmark uses the same directory tree as NPB3.0 (and NPB2.x) does.
   Before compilation, one needs to check the configuration file
   'make.def' in the config directory and modify the file if necessary
   (an example of make.def provided in DC directory). 
   Then
      make dc CLASS=S

   If a compiler complains about type 'int64' already defined, add
   "-DHAS_INT64" to the CFLAGS list in make.def.

2. OpenMP environment needs to be set before program can be executed.
   First set the number of the threads:
   setenv OMP_NUM_THREADS 4
   Then to fix OpenMP implemantations on some machines:
   limit stacksize unlimit
   If running on Altix 
   setenv KMP_MONITOR_STACKSIZE 50m

3. Run
   A text file ADC.par is used to set DC parameters when the class 
   is undefined (U). 
   The file has 5 lines. The lines with 'key' words attrNum, measuresNum, 
   and tuplesNum define the number of dimensions, measures,
   and input tuples respectively. There a special parameter INVERSE_ENDIAN
   allows us to create data in non-native endian format (INVERSE_ENDIAN=1). 
   The last parameter(fileName) specifies a DC file set name, including
   (optionally) a full path to a directory which will contain all
   DC related files.

   An example of the DC parameter file is as follows:

   attrNum=9
   measuresNum=1
   tuplesNum=125000
   class=U
   INVERSE_ENDIAN=0
   fileName=ADC
   
   After parameter are set run benchmark
   bin/dc.S 100000000 DC/ADC.par 
   where 100000000 is the memory size allowed to be allocated for 
   the in-core data.
   
4. DC processing modes
   The DC benchmark can be run in two modes (in-core and out-of-core).
   A desirable mode should be set before compilation in the file adc.h.
   If a flag IN_CORE is on, the benchmark will calculate all views in main
   memory. In this case we can use an additional flag VIEW_FILE_OUTPUT to
   allow writing all views into disk files.
                
   If the flag IN_CORE is off, the DC benchmark will run in a regular mode
   using disks to store interim and result data which may not fit in main
   memory.

   _FILE_OFFSET_BITS=64 _LARGEFILE64_SOURCE -are standard compiler flags
   which allow DC to work with files larger than 2GB. 

   OPTIMIZATION turns on some nonstandard DC optimizations such as obtaining
   a view by scanning existing views. These optimizations do not always 
   guarantee reduction in the computing time.

5. Tested architectures:
   SUN Ultrasparc 60
   SUNFire 880
   Origin 2000, 3000, 3800
   MAC G4 
   Xeon + Mandrake Linux
   SGI Altix

6. setparams utility is used for generation of the npbparams.h file only 
   for compatibility with the existing make facility of NPB. By the same
   reason CLASS is appended to the DC executable name. It does not limit 
   the sizes the executable can perform. The class is an input value
   specified in ADC.par file. Providing ADC.par overrides compiled 
   defaults in npbparams.h file.

7. Known issues
   If the benchmark runs out of disk space, a message like
   "Write error from WriteToFile()" may not be printed. Instead,
   the benchmark returns with UNSUCCESSFUL verification. In this case 
   users are advised to check whether the file system is full before 
   reporting a problem with the benchmark.

This directory contains two versions of the BT implementation:

- the standard version that has better cache utilization
- the "blocking" version that contains codes for better vectorization

For most platforms, the standard version gives reasonable performance. 
To access the blocking version, use the VERSION=BLK make flag, such as,
   make CLASS=A VERSION=BLK

Since there is no standard way of performing vectorization, the mileage
you get from the vector version depends very much on compilers.  Often
additional compiler directives (or flags) may be necessary for optimal
results.  The current version is intended to only serve as a baseline.

This directory contains utilities and files used by the 
build process. You should not need to change anything
in this directory. 

Original Files
--------------
setparams.c:
        Source for the setparams program. This program is used internally
        in the build process to create the file "npbparams.h" for each 
        benchmark. npbparams.h contains Fortran or C parameters to build a 
        benchmark for a specific class. The setparams program is never run 
        directly by a user. Its invocation syntax is 

            "setparams benchmark-name class". 

        It examines the file "npbparams.h" in the current directory. If 
        the specified parameters are the same as those in the npbparams.h 
        file, nothing it changed. If the file does not exist or corresponds 
        to a different class/number of nodes, it is (re)built. 
	One of the more complicated things in npbparams.h is that it 
        contains, in a Fortran string, the compiler flags used to build a 
        benchmark, so that a benchmark can print out how it was compiled. 

make.common
        A makefile segment that is included in each individual benchmark
        program makefile. It sets up some standard macros (COMPILE, etc) 
        and makes sure everything is configured correctly (npbparams.h)

Makefile
        Builds  setparams

README
        This file. 


Created files
-------------

setparams
	See descriptions above

Note on the parallelization of transfer.f
-----------------------------------------

The file contains three major loops that update sparsely overlapped
mortar points.  Parallelization of these loops requires atomic update
of memory references by mortar points.  The first implementation
uses the ATOMIC directive to perform the job.  However, in some systems
where atomic update of memory references is not available, the ATOMIC
directive could be implemented as a critical section, which would be 
very expensive.

The second approach is to use thread-local arrays to perform local updates,
followed by a global reduction. This implementation uses array reduction 
to achieve the goal. The disadvantage of this version is the increased use 
of memory, which could have a negative impact on performance.

The third approach is to use locks to guard atomic updates.  This 
implementation scales reasonably well.  However, the overhead associated 
with calling lock routines deep inside loop nests could be large.

Three implementations:
   - transfer_au.f: use ATOMIC directive for atomic updates
   - transfer_rd.f: use array reduction for atomic updates
   - transfer.f: use locks for atomic updates, as the default

To use different approaches, one can use the suboption "VERSION"
for make:

   % make CLASS=<class>                # default version
   % make CLASS=<class> VERSION=au     # ATOMIC directive
   % make CLASS=<class> VERSION=rd     # array reduction

where <class> is one of [S,W,A,B,C,D].

This code implements the time integration of a three-dimensional
partial differential equation using the Fast Fourier Transform.

The code uses Fortran 90 module to specify data fields. So, a compiler
supports Fortran 90 is required.

This directory contains two versions of the SP implementation:

- the standard version that has better cache utilization
- the "blocking" version that contains codes for better vectorization

For most platforms, the standard version gives reasonable performance. 
To access the blocking version, use the VERSION=BLK make flag, such as,
   make CLASS=A VERSION=BLK

Since there is no standard way of performing vectorization, the mileage
you get from the vector version depends very much on compilers.  Often
additional compiler directives (or flags) may be necessary for optimal
results.  The current version is intended to only serve as a baseline.

This code implements the random-number generator described in the
NAS Parallel Benchmark document RNR Technical Report RNR-94-007.
The code is "embarrassingly" parallel in that no communication is
required for the generation of the random numbers itself. 

Some info about the MG benchmark
(Note: this info applies to the parallel version and mostly concerns
the processor decomposition.  Info not concerning the decomposition
still applies to the serial version.)
================================
    
'mg_demo' demonstrates the capabilities of a very simple multigrid
solver in computing a three dimensional potential field.  This is
a simplified multigrid solver in two important respects:

  (1) it solves only a constant coefficient equation,
  and that only on a uniform cubical grid,
    
  (2) it solves only a single equation, representing
  a scalar field rather than a vector field.

We chose it for its portability and simplicity, and expect that a
supercomputer which can run it effectively will also be able to
run more complex multigrid programs at least as well.
     
     Eric Barszcz                         Paul Frederickson
     RIACS
     NASA Ames Research Center            NASA Ames Research Center

========================================================================
Running the program:  (Note: also see parameter lm information in the
                       two sections immediately below this section)

The program may be run with or without an input deck (called "mg.input"). 
The following describes a few things about the input deck if you want to 
use one. 

The four lines below are the "mg.input" file required to run a
problem of total size 256x256x256, for 4 iterations (Class "A"),
and presumes the use of 8 processors:

   8 = top level
   256 256 256 = nx ny nz
   4 = nit
   0 0 0 0 0 0 0 0 = debug_vec

The first line of input indicates how many levels of multi-grid
cycle will be applied to a particular subpartition.  Presuming that
8 processors are solving this problem (recall that the number of 
processors is specified to MPI as a run parameter, and MPI subsequently
determines this for the code via an MPI subroutine call), a 2x2x2 
processor grid is  formed, and thus each partition on a processor is 
of size 128x128x128.  Therefore, a maximum of 8 multi-grid levels may 
be used.  These are of size 128,64,32,16,8,4,2,1, with the coarsest 
level being a single point on a given processor.


Next, consider the same size problem but running on 1 processor.  The
following "mg.input" file is appropriate:

    9 = top level
    256 256 256 = nx ny nz
    4 = nit
    0 0 0 0 0 0 0 0 = debug_vec

Since this processor must solve the full 256x256x256 problem, this
permits 9 multi-grid levels (256,128,64,32,16,8,4,2,1), resulting in 
a coarsest multi-grid level of a single point on the processor


Next, consider the same size problem but running on 2 processors.  The
following "mg.input" file is required:

    8 = top level
    256 256 256 = nx ny nz
    4 = nit
    0 0 0 0 0 0 0 0 = debug_vec

The algorithm for partitioning the full grid onto some power of 2 number 
of processors is to start by splitting the last dimension of the grid
(z dimension) in 2: the problem is now partitioned onto 2 processors.
Next the middle dimension (y dimension) is split in 2: the problem is now
partitioned onto 4 processors.  Next, first dimension (x dimension) is
split in 2: the problem is now partitioned onto 8 processors.  Next, the
last dimension (z dimension) is split again in 2: the problem is now
partitioned onto 16 processors.  This partitioning is repeated until all 
of the power of 2 processors have been allocated.

Thus to run the above problem on 2 processors, the grid partitioning 
algorithm will allocate the two processors across the last dimension, 
creating two partitions each of size 256x256x128. The coarsest level of 
multi-grid must be a single point surrounded by a cubic number of grid 
points.  Therefore, each of the two processor partitions will contain 4 
coarsest multi-grid level points, each surrounded by a cube of grid points 
of size 128x128x128, indicated by a top level of 8.


Next, consider the same size problem but running on 4 processors.  The
following "mg.input" file is required:

    8 = top level
    256 256 256 = nx ny nz
    4 = nit
    0 0 0 0 0 0 0 0 = debug_vec

The partitioning algorithm will create 4 partitions, each of size
256x128x128.  Each partition will contain 2 coarsest multi-grid level
points each surrounded by a cube of grid points of size 128x128x128, 
indicated by a top level of 8.


Next, consider the same size problem but running on 16 processors.  The
following "mg.input" file is required:

    7 = top level
    256 256 256 = nx ny nz
    4 = nit
    0 0 0 0 0 0 0 0 = debug_vec

On each node a partition of size 128x128x64 will be created.  A maximum
of 7 multi-grid levels (64,32,16,8,4,2,1) may be used, resulting in each 
partions containing 4 coarsest multi-grid level points, each surrounded 
by a cube of grid points of size 64x64x64, indicated by a top level of 7.




Note that non-cubic problem sizes may also be considered:

The four lines below are the "mg.input" file appropriate for running a
problem of total size 256x512x512, for 20 iterations and presumes the 
use of 32 processors (note: this is NOT a class C problem):

    8 = top level
    256 512 512 = nx ny nz
    20 = nit
    0 0 0 0 0 0 0 0 = debug_vec

The first line of input indicates how many levels of multi-grid
cycle will be applied to a particular subpartition.  Presuming that
32 processors are solving this problem, a 2x4x4 processor grid is
formed, and thus each partition on a processor is of size 128x128x128.
Therefore, a maximum of 8 multi-grid levels may be used.  These are of
size 128,64,32,16,8,4,2,1, with the coarsest level being a single 
point on a given processor.

This directory contains the OpenMP version of the LU benchmark.
The benchmark solves a lower-upper tridiagonal system of equations using 
the SSOR scheme. The directory includes three approaches in parallelizing
the SSOR scheme, selectable via the make option VERSION:

   VERSION=          the pipelined version (the default)
   VERSION=hp        the hyperplane version
   VERSION=doac      the hyperplane version using OpenMP DOACROSS

Special note on feature requirements:
   the pipelined version - ATOMIC read/write from OpenMP 3.0
   the "doac" version - DOACROSS feature from OpenMP 4.0.

To select different approaches, use the option VERSION for make:

   % make CLASS=<class>               # build the pipelined version
   % make CLASS=<class> VERSION=hp    # build the hyperplane version
   % make CLASS=<class> VERSION=doac  # build the doacross version

where <class> is one of [S,W,A,B,C,D,E,F].

This directory contains examples of make.def files that were used 
by the NPB team in testing the benchmarks on different platforms. 
They can be used as starting points for make.def files for your 
own platform, but you may need to taylor them for best performance 
on your installation. A clean template can be found in directory 
`config'.
Some examples of suite.def files are also provided.

!-------------------------------------------------------------------------!
!                                                                         !
!        N  A  S     P A R A L L E L     B E N C H M A R K S  3.4         !
!                                                                         !
!                       O p e n M P     V E R S I O N                     !
!                                                                         !
!                                   B T                                   !
!                                                                         !
!-------------------------------------------------------------------------!
!                                                                         !
!    This benchmark is an OpenMP version of the NPB BT code.              !
!    It is described in NAS Technical Report 99-011.                      !
!                                                                         !
!    Permission to use, copy, distribute and modify this software         !
!    for any purpose with or without fee is hereby granted.  We           !
!    request, however, that all derived work reference the NAS            !
!    Parallel Benchmarks 3.4. This software is provided "as is"           !
!    without express or implied warranty.                                 !
!                                                                         !
!    Information on NPB 3.4, including the technical report, the          !
!    original specifications, source code, results and information        !
!    on how to submit new results, is available at:                       !
!                                                                         !
!           http://www.nas.nasa.gov/Software/NPB/                         !
!                                                                         !
!    Send comments or suggestions to  npb@nas.nasa.gov                    !
!                                                                         !
!          NAS Parallel Benchmarks Group                                  !
!          NASA Ames Research Center                                      !
!          Mail Stop: T27A-1                                              !
!          Moffett Field, CA   94035-1000                                 !
!                                                                         !
!          E-mail:  npb@nas.nasa.gov                                      !
!          Fax:     (650) 604-3957                                        !
!                                                                         !
!-------------------------------------------------------------------------!

!---------------------------------------------------------------------
!
! Authors: R. Van der Wijngaart
!          T. Harris
!          M. Yarrow
!          H. Jin
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
       program BT
!---------------------------------------------------------------------

       use bt_data
       implicit none

       include 'blk_par.h'

       integer i, niter, step, fstatus
       double precision navg, mflops, n3

       external timer_read
       double precision tmax, timer_read, t, trecs(t_last)
       logical verified
       character class
       character t_names(t_last)*8
!$     integer  omp_get_max_threads
!$     external omp_get_max_threads

!---------------------------------------------------------------------
!      Root node reads input file (if it exists) else takes
!      defaults from parameters
!---------------------------------------------------------------------

       call check_timer_flag( timeron )
       if (timeron) then
         t_names(t_total) = 'total'
         t_names(t_rhsx) = 'rhsx'
         t_names(t_rhsy) = 'rhsy'
         t_names(t_rhsz) = 'rhsz'
         t_names(t_rhs) = 'rhs'
         t_names(t_xsolve) = 'xsolve'
         t_names(t_ysolve) = 'ysolve'
         t_names(t_zsolve) = 'zsolve'
         t_names(t_rdis1) = 'redist1'
         t_names(t_solsub) = 'solsubs'
         t_names(t_add) = 'add'
       endif

       write(*, 1000)
       open (unit=2,file='inputbt.data',status='old', iostat=fstatus)

       if (fstatus .eq. 0) then
         write(*,233) 
 233     format(' Reading from input file inputbt.data')
         read (2,*) niter
         read (2,*) dt
         read (2,*) grid_points(1), grid_points(2), grid_points(3)
         close(2)
       else
         write(*,234) 
         niter = niter_default
         dt    = dt_default
         grid_points(1) = problem_size
         grid_points(2) = problem_size
         grid_points(3) = problem_size
       endif
 234   format(' No input file inputbt.data. Using compiled defaults')

       write(*, 1001) grid_points(1), grid_points(2), grid_points(3)
       write(*, 1002) niter, dt
       if (blkdim .gt. 0) write(*, 1004) blkdim
!$     write(*, 1003) omp_get_max_threads()
       write(*, *)

 1000  format(//, ' NAS Parallel Benchmarks (NPB3.4-OMP)', &
     &            ' - BT Benchmark', /)
 1001  format(' Size: ', i4, 'x', i4, 'x', i4)
 1002  format(' Iterations: ', i4, '       dt: ', f11.7)
 1003  format(' Number of available threads: ', i5)
 1004  format(' Dimension blocking size: ', i5)

       if ( (grid_points(1) .gt. IMAX) .or.  &
     &      (grid_points(2) .gt. JMAX) .or.  &
     &      (grid_points(3) .gt. KMAX) ) then
             print *, (grid_points(i),i=1,3)
             print *,' Problem size too big for compiled array sizes'
             goto 999
       endif

       do i = 1, t_last
          call timer_clear(i)
       end do

       call alloc_space

       call set_constants

       call initialize

       call exact_rhs

!---------------------------------------------------------------------
!      do one time step to touch all code, and reinitialize
!---------------------------------------------------------------------
       call adi
       call initialize

       do i = 1, t_last
          call timer_clear(i)
       end do
       call timer_start(1)

       do  step = 1, niter

          if (mod(step, 20) .eq. 0 .or.  &
     &        step .eq. 1) then
             write(*, 200) step
 200         format(' Time step ', i4)
          endif

          call adi

       end do

       call timer_stop(1)
       tmax = timer_read(1)
       
       call verify(niter, class, verified)

       n3 = dble(grid_points(1))*grid_points(2)*grid_points(3)
       navg = (grid_points(1)+grid_points(2)+grid_points(3))/3.d0
       if( tmax .ne. 0. ) then
          mflops = 1.0d-6*dble(niter)*  &
     &            (3478.8*n3-17655.7*navg**2+28023.7*navg)  &
     &            / tmax
       else
          mflops = 0.d0
       endif
       call print_results('BT', class, grid_points(1),  &
     &  grid_points(2), grid_points(3), niter,          &
     &  tmax, mflops, '          floating point',       &
     &  verified, npbversion,compiletime, cs1, cs2, cs3, cs4, cs5, &
     &  cs6, '(none)')

!---------------------------------------------------------------------
!      More timers
!---------------------------------------------------------------------
       if (.not.timeron) goto 999

       do i=1, t_last
          trecs(i) = timer_read(i)
       end do
       if (tmax .eq. 0.0) tmax = 1.0

       write(*,800)
 800   format('  SECTION   Time (secs)')
       do i=1, t_last
          write(*,810) t_names(i), trecs(i), trecs(i)*100./tmax
          if (i.eq.t_rhs) then
             t = trecs(t_rhsx) + trecs(t_rhsy) + trecs(t_rhsz)
             write(*,820) 'sub-rhs', t, t*100./tmax
             t = trecs(t_rhs) - t
             write(*,820) 'rest-rhs', t, t*100./tmax
          elseif (i.eq.t_solsub) then
             t = trecs(t_xsolve) + trecs(t_ysolve) + trecs(t_zsolve) &
     &           - trecs(t_rdis1) - trecs(t_solsub)
             write(*,820) 'rest-sol', t, t*100./tmax
          endif
 810      format(2x,a8,':',f9.3,'  (',f6.2,'%)')
 820      format('    --> ',a8,':',f9.3,'  (',f6.2,'%)')
       end do

 999   continue

       end

!------------------------------------------------------------------
      subroutine setuppc
!------------------------------------------------------------------
!     Generate diagonal preconditioner for CG.
!     Preconditioner computed in this subroutine is correct only
!     for collocation point in element interior, on conforming face
!     interior and conforming edge.
!------------------------------------------------------------------

      use ua_data
      implicit none

      double precision dxtm1_2(lx1,lx1), rdtime
      integer ie,k,i,j,q,isize

      do j=1,lx1
        do i=1,lx1
          dxtm1_2(i,j)=dxtm1(i,j)**2
        end do
      end do

      rdtime=1.d0/dtime

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ie,isize,i,j,k,q) 
      do ie = 1, nelt
        call r_init(dpcelm(1,1,1,ie),nxyz,0.d0)
        isize=size_e(ie)
        do k = 1, lx1
          do j = 1, lx1
            do i = 1, lx1
              do q = 1, lx1
                dpcelm(i,j,k,ie) = dpcelm(i,j,k,ie) +  &
     &                        g1m1_s(q,j,k,isize) * dxtm1_2(i,q) +  &
     &                        g1m1_s(i,q,k,isize) * dxtm1_2(j,q) +  &
     &                        g1m1_s(i,j,q,isize) * dxtm1_2(k,q)
              end do
              dpcelm(i,j,k,ie)=visc*dpcelm(i,j,k,ie)+  &
     &                      rdtime*bm1_s(i,j,k,isize)
            end do
          end do
        end do
      end do
!$OMP END PARALLEL DO

!.....do the stiffness summation
      call dssum

!.....take inverse.

      call reciprocal(dpcelm,ntot)

!.....compute preconditioner on mortar points. NOTE:  dpcmor for 
!     nonconforming cases will be corrected in subroutine setpcmo 
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(I)
      do i=1,nmor
        dpcmor(i)=1.d0/dpcmor(i)
      end do
!$OMP END PARALLEL DO

      return
      end


!--------------------------------------------------------------
      subroutine setpcmo_pre
!--------------------------------------------------------------
!     pre-compute elemental contribution to preconditioner  
!     for all situations
!--------------------------------------------------------------
      
      use ua_data
      implicit none

      integer element_size, i, j, ii, jj, col
      double precision  &
     &       p(lx1,lx1,lx1), p0(lx1,lx1,lx1), mtemp(lx1,lx1),  &
     &       temp(lx1,lx1,lx1), temp1(lx1,lx1), tmp(lx1,lx1),tig(lx1)

!.....corners on face of type 3 

      call r_init(tcpre,lx1*lx1,0.d0)
      call r_init(tmp,lx1*lx1,0.d0)
      call r_init(tig,5,0.d0)
      tig(1)   =1.d0
      tmp(1,1) =1.d0 

!.....tcpre results from mapping a unit spike field (unity at 
!     collocation point (1,1), zero elsewhere) on an entire element
!     face to the (1,1) segment of a nonconforming face
      do i=2,lx1-1
        do j=1,lx1
          tmp(i,1) = tmp(i,1)+ qbnew(i-1,j,1)*tig(j)
        end do
      end do
 
      do col=1,lx1
        tcpre(col,1)=tmp(col,1)

        do j=2,lx1-1
          do i=1,lx1
            tcpre(col,j) = tcpre(col,j) + qbnew(j-1,i,1)*  &
     &                                     tmp(col,i)
          end do
        end do
      end do

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(element_size,i,j,p,temp,  &
!$OMP& mtemp,temp1,p0,ii,jj)
      do element_size=1,refine_max

!.......for conforming cases

!.......pcmor_c (i,j,element_size) records the intermediate value 
!       (preconditioner=1/pcmor_c) of the preconditor on collocation 
!       point (i,j) on a conforming face of an element of size 
!       element_size.

        do j=1,lx1/2+1
          do i=j,lx1/2+1
            call r_init(p,nxyz,0.d0)
            p(i,j,1)=1.d0
            call laplacian(temp,p,element_size)
            pcmor_c(i,j,element_size)=temp(i,j,1)
            pcmor_c(lx1+1-i,j,element_size)=temp(i,j,1)
            pcmor_c(j,i,element_size)=temp(i,j,1)
            pcmor_c(lx1+1-j,i,element_size)=temp(i,j,1)
            pcmor_c(j,lx1+1-i,element_size)=temp(i,j,1)
            pcmor_c(lx1+1-j,lx1+1-i,element_size)=temp(i,j,1)
            pcmor_c(i,lx1+1-j,element_size)=temp(i,j,1)
            pcmor_c(lx1+1-i,lx1+1-j,element_size)=temp(i,j,1)
          end do
        end do

!.......for nonconforming cases 

!.......nonconforming face interior

!.......pcmor_nc1(i,j,ii,jj,element_size) records the intermediate 
!       preconditioner value on collocation point (i,j) on mortar 
!       (ii,jj)  on a nonconforming face of an element of size element_
!       size
        do j=2,lx1
          do i=j,lx1
            call r_init(mtemp,lx1*lx1,0.d0)
            call r_init(p,nxyz,0.d0)
            mtemp(i,j)=1.d0
!...........when i, j=lx1, mortar points are duplicated, so mtemp needs
!           to be doubled.
            if(i.eq.lx1)mtemp(i,j)=mtemp(i,j)*2.d0
            if(j.eq.lx1)mtemp(i,j)=mtemp(i,j)*2.d0
            call transf_nc(mtemp,p)
            call laplacian(temp,p,element_size)
            call transfb_nc1(temp1,temp)

!...........values at points (i,j) and (j,i) are the same
            pcmor_nc1(i,j,1,1,element_size)=temp1(i,j)
            pcmor_nc1(j,i,1,1,element_size)=temp1(i,j)
          end do

!.........when i, j=lx1, mortar points are duplicated. so pcmor_nc1 needs
!         to be doubled on those points
          pcmor_nc1(lx1,j,1,1,element_size)=  &
     &          pcmor_nc1(lx1,j,1,1,element_size)*2.d0
          pcmor_nc1(j,lx1,1,1,element_size)=  &
     &          pcmor_nc1(lx1,j,1,1,element_size)

        end do
        pcmor_nc1(lx1,lx1,1,1,element_size)=  &
     &      pcmor_nc1(lx1,lx1,1,1,element_size)*2.d0

!.......nonconforming edges
        j=1
        do i=2,lx1
          call r_init(mtemp,lx1*lx1,0.d0)
          call r_init(p,nxyz,0.d0)
          call r_init(p0,nxyz,0.d0)
          mtemp(i,j)=1.d0
          if(i.eq.lx1)mtemp(i,j)=2.d0
          call transf_nc(mtemp,p)
          call laplacian(temp,p,element_size)                          
          call transfb_nc1(temp1,temp)                   
          pcmor_nc1(i,j,1,1,element_size)=temp1(i,j)      
          pcmor_nc1(j,i,1,1,element_size)=temp1(i,j)                              
          do ii=1,lx1
!...........p0 is for the case that a nonconforming edge is shared by
!           two conforming faces
            p0(ii,1,1)=p(ii,1,1)
            do jj=1,lx1 
!.............now p is for the case that a nonconforming edge is shared
!             by nonconforming faces
              p(ii,1,jj)=p(ii,jj,1)
            end do
          end do

          call laplacian(temp,p,element_size)
          call transfb_nc2(temp1,temp)                

!.........pcmor_nc2(i,j,ii,jj,element_size) gives the intermediate
!         preconditioner value on collocation point (i,j) on a 
!         nonconforming face of an element with size size_element

          pcmor_nc2(i,j,1,1,element_size)=temp1(i,j)*2.d0 
          pcmor_nc2(j,i,1,1,element_size)=  &
     &          pcmor_nc2(i,j,1,1,element_size)

          call laplacian(temp,p0,element_size) 
          call transfb_nc0(temp1,temp)                  

!.........pcmor_nc0(i,j,ii,jj,element_size) gives the intermediate
!         preconditioner value on collocation point (i,j) on a 
!         conforming face of an element, which shares a nonconforming 
!         edge with another conforming face
          pcmor_nc0(i,j,1,1,element_size)=temp1(i,j)
          pcmor_nc0(j,i,1,1,element_size)=temp1(i,j)
        end do
        pcmor_nc1(lx1,j,1,1,element_size)=  &
     &        pcmor_nc1(lx1,j,1,1,element_size)*2.d0
        pcmor_nc1(j,lx1,1,1,element_size)=  &
     &        pcmor_nc1(lx1,j,1,1,element_size)
        pcmor_nc2(lx1,j,1,1,element_size)=  &
     &        pcmor_nc2(lx1,j,1,1,element_size)*2.d0
        pcmor_nc2(j,lx1,1,1,element_size)=  &
     &        pcmor_nc2(lx1,j,1,1,element_size)
        pcmor_nc0(lx1,j,1,1,element_size)=  &
     &        pcmor_nc0(lx1,j,1,1,element_size)*2.d0
        pcmor_nc0(j,lx1,1,1,element_size)=  &
     &        pcmor_nc0(lx1,j,1,1,element_size)

!.......symmetrical copy
        do i=1,lx1-1
          pcmor_nc1(i,j,1,2,element_size)=  &
     &          pcmor_nc1(lx1+1-i,j,1,1,element_size)
          pcmor_nc0(i,j,1,2,element_size)=                                           &
     &          pcmor_nc0(lx1+1-i,j,1,1,element_size)                                      
          pcmor_nc2(i,j,1,2,element_size)=                                           &
     &          pcmor_nc2(lx1+1-i,j,1,1,element_size)                                      
        end do

        do j=2,lx1                                            
          do i=1,lx1-1
            pcmor_nc1(i,j,1,2,element_size)=  &
     &            pcmor_nc1(lx1+1-i,j,1,1,element_size)
          end do
          i=lx1
          pcmor_nc1(i,j,1,2,element_size)=  &
     &          pcmor_nc1(lx1+1-i,j,1,1,element_size)
          pcmor_nc0(i,j,1,2,element_size)=                                           &
     &          pcmor_nc0(lx1+1-i,j,1,1,element_size)                                      
          pcmor_nc2(i,j,1,2,element_size)=                                           &
     &          pcmor_nc2(lx1+1-i,j,1,1,element_size)                                      
        end do                                                

        j=1
        i=1
        pcmor_nc1(i,j,2,1,element_size)=  &
     &        pcmor_nc1(i,lx1+1-j,1,1,element_size)
        pcmor_nc0(i,j,2,1,element_size)=  &
     &        pcmor_nc0(i,lx1+1-j,1,1,element_size)
        pcmor_nc2(i,j,2,1,element_size)=  &
     &        pcmor_nc2(i,lx1+1-j,1,1,element_size)
        do j=2,lx1-1
          i=1
          pcmor_nc1(i,j,2,1,element_size)=  &
     &          pcmor_nc1(i,lx1+1-j,1,1,element_size)
          pcmor_nc0(i,j,2,1,element_size)=  &
     &          pcmor_nc0(i,lx1+1-j,1,1,element_size)
          pcmor_nc2(i,j,2,1,element_size)=  &
     &          pcmor_nc2(i,lx1+1-j,1,1,element_size)
          do i=2,lx1
            pcmor_nc1(i,j,2,1,element_size)=  &
     &            pcmor_nc1(i,lx1+1-j,1,1,element_size)
          end do
        end do

        j=lx1
        do i=2,lx1
          pcmor_nc1(i,j,2,1,element_size)=  &
     &          pcmor_nc1(i,lx1+1-j,1,1,element_size)
          pcmor_nc0(i,j,2,1,element_size)=  &
     &          pcmor_nc0(i,lx1+1-j,1,1,element_size)
          pcmor_nc2(i,j,2,1,element_size)=  &
     &          pcmor_nc2(i,lx1+1-j,1,1,element_size)
        end do

        j=1
        i=lx1
        pcmor_nc1(i,j,2,2,element_size)=  &
     &        pcmor_nc1(lx1+1-i,lx1+1-j,1,1,element_size)
        pcmor_nc0(i,j,2,2,element_size)=  &
     &        pcmor_nc0(lx1+1-i,lx1+1-j,1,1,element_size)
        pcmor_nc2(i,j,2,2,element_size)=  &
     &        pcmor_nc2(lx1+1-i,lx1+1-j,1,1,element_size)
          
        do j=2,lx1-1                                            
          do i=2,lx1-1
            pcmor_nc1(i,j,2,2,element_size)=  &
     &            pcmor_nc1(lx1+1-i,lx1+1-j,1,1,element_size)
          end do
          i=lx1
          pcmor_nc1(i,j,2,2,element_size)=                                       &
     &          pcmor_nc1(lx1+1-i,lx1+1-j,1,1,element_size)                               
          pcmor_nc0(i,j,2,2,element_size)=                                       &
     &          pcmor_nc0(lx1+1-i,lx1+1-j,1,1,element_size)   
          pcmor_nc2(i,j,2,2,element_size)=                                       &
     &          pcmor_nc2(lx1+1-i,lx1+1-j,1,1,element_size)                     
        end do                                                
        j=lx1
        do i=2,lx1-1
          pcmor_nc1(i,j,2,2,element_size)=                                       &
     &          pcmor_nc1(lx1+1-i,lx1+1-j,1,1,element_size)          
          pcmor_nc0(i,j,2,2,element_size)=  &
     &          pcmor_nc0(lx1+1-i,lx1+1-j,1,1,element_size)          
          pcmor_nc2(i,j,2,2,element_size)=                                       &
     &          pcmor_nc2(lx1+1-i,lx1+1-j,1,1,element_size)    
        end do


!.......vertices shared by at least one nonconforming face or edge

!.......Among three edges and three faces sharing a vertex on an element
!       situation 1: only one edge is nonconforming
!       situation 2: two edges are nonconforming
!       situation 3: three edges are nonconforming
!       situation 4: one face is nonconforming 
!       situation 5: one face and one edge are nonconforming 
!       situation 6: two faces are nonconforming
!       situation 7: three faces are nonconforming

        call r_init(p0,nxyz,0.d0)
        p0(1,1,1)=1.d0
        call laplacian(temp,p0,element_size)
        pcmor_cor(8,element_size)=temp(1,1,1)

!.......situation 1
        call r_init(p0,nxyz,0.d0)
        do i=1,lx1
           p0(i,1,1)=tcpre(i,1)
        end do
        call laplacian(temp,p0,element_size) 
        call transfb_cor_e(1,pcmor_cor(1,element_size),temp)                  

!.......situation 2
        call r_init(p0,nxyz,0.d0)
        do i=1,lx1
           p0(i,1,1)=tcpre(i,1)
           p0(1,i,1)=tcpre(i,1)
        end do
        call laplacian(temp,p0,element_size)
        call transfb_cor_e(2,pcmor_cor(2,element_size),temp)                  

!.......situation 3
        call r_init(p0,nxyz,0.d0)
        do i=1,lx1
           p0(i,1,1)=tcpre(i,1)
           p0(1,i,1)=tcpre(i,1)
           p0(1,1,i)=tcpre(i,1)
        end do
        call laplacian(temp,p0,element_size)
        call transfb_cor_e(3,pcmor_cor(3,element_size),temp)                  

!.......situation 4
        call r_init(p0,nxyz,0.d0)
        do j=1,lx1
          do i=1,lx1
            p0(i,j,1)=tcpre(i,j)
          end do
        end do
        call laplacian(temp,p0,element_size)
        call transfb_cor_f(4,pcmor_cor(4,element_size),temp)

!.......situation 5
        call r_init(p0,nxyz,0.d0)
        do j=1,lx1
          do i=1,lx1
            p0(i,j,1)=tcpre(i,j)
          end do
        end do
        do i=1,lx1
           p0(1,1,i)=tcpre(i,1)
        end do
        call laplacian(temp,p0,element_size)
        call transfb_cor_f(5,pcmor_cor(5,element_size),temp)
 
!.......situation 6
        call r_init(p0,nxyz,0.d0)
        do j=1,lx1
          do i=1,lx1
            p0(i,j,1)=tcpre(i,j)
            p0(i,1,j)=tcpre(i,j)
          end do
        end do
        call laplacian(temp,p0,element_size)
        call transfb_cor_f(6,pcmor_cor(6,element_size),temp)

!.......situation 7
        do j=1,lx1
          do i=1,lx1
            p0(i,j,1)=tcpre(i,j)
            p0(i,1,j)=tcpre(i,j)
            p0(1,i,j)=tcpre(i,j)
          end do
        end do
        call laplacian(temp,p0,element_size)
        call transfb_cor_f(7,pcmor_cor(7,element_size),temp)

      end do    
!$OMP END PARALLEL DO     
      return
      end 


!------------------------------------------------------------------------
      subroutine setpcmo
!------------------------------------------------------------------------
!     compute the preconditioner by identifying its geometry configuration
!     and sum the values from the precomputed elemental contributions
!------------------------------------------------------------------------
      
      use ua_data
      implicit none

      integer face2, nb1, nb2, sizei, imor, enum, i,j,  &
     &        iel, iside, nn1, nn2

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(IMOR,IEL,ISIDE,I) 
!$OMP DO
      do imor=1,nvertex
       ifpcmor(imor)=.false.
      end do
!$OMP END DO nowait
   
!$OMP DO 
      do iel=1,nelt
        do iside=1,nsides
          do i=1,4
            edgevis(i,iside,iel)=.false.
          end do 
        end do 
      end do 
!$OMP END DO 
!$OMP END PARALLEL

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(IEL,iside,sizei,  &
!$OMP& imor,enum,face2,nb1,nb2,i,j,nn1,nn2) 

      do iel=1,nelt
        do iside=1,nsides
!.........for nonconforming faces
          if(cbc(iside,iel).eq.3)then
            sizei=size_e(iel)

!...........vertices

!...........ifpcmor(imor)=.true. indicates that mortar point imor has 
!           been visited
            imor=idmo(1,1,1,1,iside,iel)
            if(.not.ifpcmor(imor))then
!.............compute the preconditioner on mortar point imor
              call pc_corner(imor)
              ifpcmor(imor)=.true.
            end if

            imor=idmo(lx1,1,1,2,iside,iel)
            if(.not.ifpcmor(imor))then
              call pc_corner(imor)
              ifpcmor(imor)=.true.
            end if

            imor=idmo(1,lx1,2,1,iside,iel)
            if(.not.ifpcmor(imor))then
              call pc_corner(imor)
              ifpcmor(imor)=.true.
            end if

            imor=idmo(lx1,lx1,2,2,iside,iel)
            if(.not.ifpcmor(imor))then
              call pc_corner(imor)
              ifpcmor(imor)=.true.
            end if

!...........edges on nonconforming faces, enum is local edge number
            do enum=1,4

!.............edgevis(enum,iside,iel)=.true. indicates that local edge 
!             enum of face iside of iel has been visited
              if(.not.edgevis(enum,iside,iel))then
                edgevis(enum,iside,iel)=.true.

!...............Examing neighbor element information,
!               calculateing the preconditioner value.
                face2= f_e_ef(enum,iside)
                if(cbc(face2,iel).eq.2)then
                  nb1=sje(1,1,face2,iel)
                  if(cbc(iside,nb1).eq.2)then

!...................Compute the preconditioner on local edge enum on face
!                   iside of element iel, 1 is neighborhood information got
!                   by examing neighbors(nb1). For detailed meaning of 1, 
!                   see subroutine com_dpc.

                    call com_dpc(iside,iel,enum,1,sizei)
                    nb2=sje(1,1,iside,nb1)
                    edgevis(op(e_face2(enum,iside)),  &
     &                      jjface(face2),nb2)=.true.

                  elseif(cbc(iside,nb1).eq.3)then
                    call com_dpc(iside,iel,enum,2,sizei)
                    edgevis(op(enum),iside,nb1)=.true.
                  end if

                elseif(cbc(face2,iel).eq.3)then
                  edgevis(e_face2(enum,iside),face2,iel)=.true.
                  nb1=sje(1,2,face2,iel)
                  if(cbc(iside,nb1).eq.1)then
                    call com_dpc(iside,iel,enum,3,sizei)
                    nb2=sje(1,1,iside,nb1)
                    edgevis(op(enum),jjface(iside),nb2)=.true.
                    edgevis(op(e_face2(enum,iside)),  &
     &                      jjface(face2),nb2)=.true.
                  elseif(cbc(iside,nb1).eq.2)then
                    call com_dpc(iside,iel,enum,4,sizei)
                  end if
                else if (cbc(face2,iel).eq.0)then
                  call com_dpc(iside,iel,enum,0,sizei)
                end if
              end if
            end do

!...........mortar element interior (not edge of mortar) 

            do nn1=1,2
              do nn2=1,2
                do j=2,lx1-1
                  do i=2,lx1-1
                    imor=idmo(i,j,nn1,nn2,iside,iel) 
                    dpcmor(imor) = 1.d0/(pcmor_nc1(i,j,nn1,nn2,sizei)+  &
     &                                pcmor_c(i,j,sizei+1))
                  end do
                end do
              end do
            end do

!...........for i,j=lx1 there are duplicated mortar points, so 
!           pcmor_c needs to be doubled or quadrupled
            i=lx1
            do j=2,lx1-1
              imor=idmo(i,j,1,1,iside,iel)            
              dpcmor(imor) = 1.d0/(pcmor_nc1(i,j,1,1,sizei)+  &
     &                          pcmor_c(i,j,sizei+1)*2.d0)
              imor=idmo(i,j,2,1,iside,iel)                
              dpcmor(imor) = 1.d0/(pcmor_nc1(i,j,2,1,sizei)+  &
     &                          pcmor_c(i,j,sizei+1)*2.d0)
            end do      

            j=lx1
            imor=idmo(i,j,1,1,iside,iel)                                         
            dpcmor(imor) = 1.d0/(pcmor_nc1(i,j,1,1,sizei)+  &
     &                        pcmor_c(i,j,sizei+1)*4.d0)
            do i=2,lx1-1
              imor=idmo(i,j,1,1,iside,iel)  
              dpcmor(imor) = 1.d0/(pcmor_nc1(i,j,1,1,sizei)+  &
     &                          pcmor_c(i,j,sizei+1)*2.d0)
              imor=idmo(i,j,1,2,iside,iel) 
              dpcmor(imor) = 1.d0/(pcmor_nc1(i,j,1,2,sizei)+  &
     &                          pcmor_c(i,j,sizei+1)*2.d0)
            end do

          end if 
        end do
      end do
!$OMP END PARALLEL DO

      return
      end

!--------------------------------------------------------------------------
      subroutine pc_corner(imor)
!------------------------------------------------------------------------
!     calculate preconditioner value for vertex with mortar index imor
!------------------------------------------------------------------------

      use ua_data
      implicit none

      double precision tmortemp
      integer imor, inemo,ie, sizei,cornernumber,  &
     &        sface,sedge,iiface,iface,iiedge,iedge,n

      tmortemp=0.d0
!.....loop over all elements sharing this vertex
      do inemo=1,nemo(imor)
        ie=emo(1,inemo,imor)
        sizei=size_e(ie)
        cornernumber=emo(2,inemo,imor)
        sface=0
        sedge=0
        do iiface=1,3
          iface=f_c(iiface,cornernumber)
!.........sface sums the number of nonconforming faces sharing this vertex on
!         one element
          if(cbc(iface,ie).eq.3)then
            sface=sface+1
          end if
        end do
!.......sedge sums the number of nonconforming edges sharing this vertex on
!       one element
        do iiedge=1,3
          iedge=e_c(iiedge,cornernumber)
          if(ncon_edge(iedge,ie))sedge=sedge+1
        end do

!.......each n indicates how many nonconforming faces and nonconforming
!       edges share this vertex on an element, 

        if(sface.eq.0)then
          if(sedge.eq.0)then
             n=8
          elseif(sedge.eq.1)then
             n=1
          elseif(sedge.eq.2)then
             n=2
          elseif(sedge.eq.3)then
             n=3
          end if 
        elseif (sface.eq.1)then
          if (sedge.eq.1)then
           n=5
          else
           n=4
          end if
        else if (sface.eq.2)then
           n=6
        else if(sface.eq.3)then
           n=7
        end if
          
!.......sum the intermediate pre-computed preconditioner values for 
!       all elements
        tmortemp=tmortemp+pcmor_cor(n,sizei)

      end do

!.....dpcmor(imor) is the value of the preconditioner on mortar point imor
      dpcmor(imor)=1.d0/tmortemp

      return
      end 

!------------------------------------------------------------------------
      subroutine com_dpc(iside,iel,enumber,n,isize)
!------------------------------------------------------------------------
!     Compute preconditioner for local edge enumber of face iside 
!     on element iel.
!     isize is element size,
!     n is one of five different configurations
!     anc1, ac, anc2, anc0 are coefficients for different edges. 
!     nc0 refers to nonconforming edge shared by two conforming faces
!     nc1 refers to nonconforming edge shared by one nonconforming face
!     nc2 refers to nonconforming edges shared by two nonconforming faces
!     c refers to conforming edge
!------------------------------------------------------------------------

      use ua_data
      implicit none

      integer n, isize,iside,iel, enumber, nn1start, nn1end, nn2start,  &
     &        nn2end, jstart, jend, istart, iend, i, j, nn1, nn2, imor
      double precision anc1,ac,anc2,anc0,temp

!.....different local edges have different loop ranges 
      if(enumber.eq.1)then
        nn1start=1
        nn1end=1
        nn2start=1
        nn2end=2
        jstart=1
        jend=1
        istart=2
        iend=lx1-1
      elseif (enumber.eq.2) then
        nn1start=1
        nn1end=2
        nn2start=2
        nn2end=2
        jstart=2
        jend=lx1-1
        istart=lx1
        iend=lx1
      elseif (enumber.eq.3) then
        nn1start=2
        nn1end=2
        nn2start=1
        nn2end=2
        jstart=lx1
        jend=lx1
        istart=2
        iend=lx1-1
      elseif (enumber.eq.4) then
        nn1start=1
        nn1end=2
        nn2start=1
        nn2end=1
        jstart=2
        jend=lx1-1
        istart=1
        iend=1
      end if

!.....among the four elements sharing this edge

!.....one has a smaller size
      if(n.eq.1)then
        anc1=2.d0
        ac=1.d0
        anc0=1.d0
        anc2=0.d0

!.....two (neighbored by a face) are of  smaller size
      else if (n.eq.2)then
        anc1=2.d0
        ac=2.d0
        anc0=0.d0
        anc2=0.d0

!.....two (neighbored by an edge) are of smaller size
      else if (n.eq.3)then
        anc2=2.d0
        ac=2.d0
        anc1=0.d0
        anc0=0.d0

!.....three are of smaller size
      else if (n.eq.4)then
        anc1=0.d0
        ac=3.d0
        anc2=1.d0
        anc0=0.d0

!.....on the boundary
      else if (n.eq.0)then
        anc1=1.d0
        ac=1.d0
        anc2=0.d0
        anc0=0.d0
      end if

!.....edge interior
      do nn2=nn2start,nn2end
        do nn1=nn1start,nn1end
          do j=jstart,jend
            do i=istart,iend
              imor=idmo(i,j,nn1,nn2,iside,iel)
              temp=anc1* pcmor_nc1(i,j,nn1,nn2,isize) +  &
     &             ac*  pcmor_c(i,j,isize+1)+  &
     &             anc0*  pcmor_nc0(i,j,nn1,nn2,isize)+  &
     &             anc2*pcmor_nc2(i,j,nn1,nn2,isize)
                dpcmor(imor)=1.d0/temp
              end do
            end do
          end do
        end do

!.......local edge 1
        if (enumber.eq.1) then
          imor=idmo(lx1,1,1,1,iside,iel)
          temp=anc1* pcmor_nc1(lx1,1,1,1,isize) +  &
     &         ac*  pcmor_c(lx1,1,isize+1)*2.d0+  &
     &         anc0*  pcmor_nc0(lx1,1,1,1,isize)+  &
     &         anc2*pcmor_nc2(lx1,1,1,1,isize)
!.......local edge 2
        elseif (enumber.eq.2) then
          imor=idmo(lx1,lx1,1,2,iside,iel)
          temp=anc1* pcmor_nc1(lx1,lx1,1,2,isize) +  &
     &         ac*  pcmor_c(lx1,lx1,isize+1)*2.d0+  &
     &         anc0*  pcmor_nc0(lx1,lx1,1,2,isize)+  &
     &         anc2*pcmor_nc2(lx1,lx1,1,2,isize)
!.......local edge 3
        elseif (enumber.eq.3) then
          imor=idmo(lx1,lx1,2,1,iside,iel)
          temp=anc1* pcmor_nc1(lx1,lx1,2,1,isize) +  &
     &         ac*  pcmor_c(lx1,lx1,isize+1)*2.d0+  &
     &         anc0*  pcmor_nc0(lx1,lx1,2,1,isize)+  &
     &         anc2*pcmor_nc2(lx1,lx1,2,1,isize)
!.......local edge 4
        elseif (enumber.eq.4) then
          imor=idmo(1,lx1,1,1,iside,iel)
          temp=anc1* pcmor_nc1(1,lx1,1,1,isize) +  &
     &         ac*  pcmor_c(1,lx1,isize+1)*2.d0+  &
     &         anc0*  pcmor_nc0(1,lx1,1,1,isize)+  &
     &         anc2*pcmor_nc2(1,lx1,1,1,isize)
        end if

        dpcmor(imor)=1.d0/temp

      return
      end 

!---------------------------------------------------------------------
!---------------------------------------------------------------------
!
!  ua_data module
!
!---------------------------------------------------------------------
!---------------------------------------------------------------------

      module ua_data

      include 'npbparams.h'

!.....Array dimensions     
      integer lx1, lnje, nsides, nxyz
      parameter(lx1=5, lnje=2, nsides=6,  nxyz=lx1*lx1*lx1)

      integer fre, niter, nmxh
      double precision alpha, dlmin, dtime

      integer nelt, ntot, nmor, nvertex

      double precision x0, y0, z0, time

      double precision velx, vely, velz, visc, x00, y00, z00
      parameter(velx=3.d0, vely=3.d0, velz=3.d0)
      parameter(visc=0.005d0)
      parameter(x00=3.d0/7.d0, y00=2.d0/7.d0, z00=2.d0/7.d0)

!.....double precision arrays associated with collocation points
      double precision, allocatable ::  &
     &       ta1  (:,:,:,:), ta2   (:,:,:,:),  &
     &       trhs (:,:,:,:), t     (:,:,:,:),  &
     &       tmult(:,:,:,:), dpcelm(:,:,:,:),  &
     &       pdiff(:,:,:,:), pdiffp(:,:,:,:)

!.....double precision arays associated with mortar points
      double precision, allocatable ::  &
     &       umor(:), tmmor (:),  &
     &       rmor(:), dpcmor(:), pmorx(:), ppmor(:) 
      double precision, allocatable, target ::  &
     &       mormult(:), tmort(:)

!.... integer arrays associated with element faces
      integer, allocatable ::  &
     &        idmo    (:,:,:,:,:,:),  &
     &        idel    (:,:,    :,:),  &
     &        sje     (:,:,    :,:),  &
     &        sje_new (:,:,    :,:),  &
     &        ijel    (:,      :,:),  &
     &        ijel_new(:,      :,:),  &
     &        cbc     (        :,:),  &
     &        cbc_new (        :,:) 

!.....integer array associated with vertices
      integer, allocatable :: vassign (:,:), emo(:,:,:),   &
     &        nemo (:)

!.....integer array associated with element edges
      integer, allocatable :: diagn  (:,:,:) 

!.... integer arrays associated with elements
      integer, allocatable ::  &
     &        tree (:), mt_to_id    (:),                   &
     &        newc (:), mt_to_id_old(:),  &
     &        newi (:), id_to_mt    (:),  &
     &        newe (:), ref_front_id(:),  &
     &        front(:), action      (:),  &
     &        ich  (:), size_e      (:),  &
     &        treenew(:)

!.....logical arrays associated with vertices
      logical, allocatable :: ifpcmor (:)

!.....logical arrays associated with edge
      logical, allocatable ::  &
     &        eassign  (:,:), if_1_edge(:,:),  &
     &        ncon_edge(:,:)

!.....logical arrays associated with elements
      logical, allocatable :: skip(:), ifcoa(:), ifcoa_id(:)

!.....logical arrays associated with element faces
      logical, allocatable :: fassign(:,:), edgevis(:,:,:)      

!.....small arrays
      double precision qbnew(lx1-2,lx1,2), bqnew(lx1-2,lx1-2,2)

      double precision  &
     &       pcmor_nc1(lx1,lx1,2,2,refine_max),  &
     &       pcmor_nc2(lx1,lx1,2,2,refine_max),  &
     &       pcmor_nc0(lx1,lx1,2,2,refine_max),  &
     &       pcmor_c(lx1,lx1,refine_max), tcpre(lx1,lx1),  &
     &       pcmor_cor(8,refine_max)

!.....gauss-labotto and gauss points
      double precision zgm1(lx1)

!.....weights
      double precision wxm1(lx1),w3m1(lx1,lx1,lx1)

!.....coordinate of element vertices
      double precision, allocatable ::  &
     &       xc(:,:),    yc(:,:),    zc(:,:),  &
     &       xc_new(:,:),yc_new(:,:),zc_new(:,:)

!.....dr/dx, dx/dr  and Jacobian
      double precision jacm1_s(lx1,lx1,lx1,refine_max),  &
     &       rxm1_s(lx1,lx1,lx1,refine_max),  &
     &       xrm1_s(lx1,lx1,lx1,refine_max)

!.....mass matrices (diagonal)
      double precision bm1_s(lx1,lx1,lx1,refine_max)

!.....dertivative matrices d/dr
      double precision dxm1(lx1,lx1), dxtm1(lx1,lx1), wdtdr(lx1,lx1)

!.....interpolation operators
      double precision  &
     &       ixm31(lx1,lx1*2-1), ixtm31(lx1*2-1,lx1), ixmc1(lx1,lx1),  &
     &       ixtmc1(lx1,lx1), ixmc2(lx1,lx1),  ixtmc2(lx1,lx1),  &
     &       map2(lx1),map4(lx1)

!.....collocation location within an element
      double precision xfrac(lx1)

!.....used in laplacian operator
      double precision g1m1_s(lx1,lx1,lx1,refine_max),  &
     &       g4m1_s(lx1,lx1,lx1,refine_max),  &
     &       g5m1_s(lx1,lx1,lx1,refine_max),  &
     &       g6m1_s(lx1,lx1,lx1,refine_max)
      
!.....We store some tables of useful topological constants
!     These constants are intialized as a block data below
      integer f_e_ef(4,6)
      integer e_c(3,8)
      integer local_corner(8,6)
      integer cal_nnb(3,8)
      integer oplc(4)
      integer cal_iijj(2,4)
      integer cal_intempx(4,6)
      integer c_f(4,6)
      integer le_arr(4,0:1,3)
      integer jjface(6)
      integer e_face2(4,6)
      integer op(4)
      integer localedgenumber(6,12)
      integer edgenumber(4,6)
      integer f_c(3,8)
      integer e1v1(6,6),e2v1(6,6),e1v2(6,6),e2v2(6,6)
      integer children(4,6)
      integer iijj(2,4)
      integer v_end(2)
      integer face_l1(3),face_l2(3),face_ld(3)

! ... Timer parameters
      integer t_total,t_init,t_convect,t_transfb_c,  &
     &        t_diffusion,t_transf,t_transfb,t_adaptation,  &
     &        t_transf2,t_add2,t_last
      parameter (t_total=1,t_init=2,t_convect=3,t_transfb_c=4,  &
     &        t_diffusion=5,t_transf=6,t_transfb=7,t_adaptation=8,  &
     &        t_transf2=9,t_add2=10,t_last=10)
      logical timeron

!.....Locks used for atomic updates
!c    integer (kind=omp_lock_kind) tlock(lmor)
!$    integer(8) tlock(lmor)


!------------------------------------------------------------------
!.....We store some tables of useful topological constants
!------------------------------------------------------------------

!     f_e_ef(e,f) returns the other face sharing the e'th local edge of face f.
      data f_e_ef/6,3,5,4, 6,3,5,4, 6,1,5,2, 6,1,5,2, 4,1,3,2, 4,1,3,2/

!.....e_c(n,j) returns n'th edge sharing the vertex j of an element
      data e_c /5,8,11, 1,4,11,  5,6,9, 1,2,9,  &
     &          7,8,12, 3,4,12, 6,7,10, 2,3,10/

!.....local_corner(n,i) returns the local corner index of vertex n on face i
      data local_corner /0,1,0,2,0,3,0,4, 1,0,2,0,3,0,4,0,  &
     &                   0,0,1,2,0,0,3,4, 1,2,0,0,3,4,0,0,  &
     &                   0,0,0,0,1,2,3,4, 1,2,3,4,0,0,0,0/

!.....cal_nnb(n,i) returns the neighbor elements neighbored by n'th edge
!     among the three edges sharing vertex i
!     the elements are the eight children elements ordered as 1 to 8.
      data cal_nnb/5,2,3, 6,1,4, 7,4,1, 8,3,2,  &
     &             1,6,7, 2,5,8, 3,8,5, 4,7,6/

!.....returns the opposite local corner index: 1-4,2-3
      data oplc /4,3,2,1/

!.....cal_iijj(i,n) returns the location of local corner number n on a face 
!     i =1  to get ii, i=2 to get jj
!     (ii,jj) is defined the same as in mortar location (ii,jj)
      data cal_iijj /1,1, 1,2, 2,1, 2,2/

!.....returns the adjacent(neighbored by a face) element's children,
!     assumming a vertex is shared by eight child elements 1-8. 
!     index n is local corner number on the face which is being 
!     assigned the mortar index number
      data cal_intempx /8,6,4,2, 7,5,3,1, 8,7,4,3,  &
     &                  6,5,2,1, 8,7,6,5, 4,3,2,1/

!.....c_f(i,f) returns the vertex number of i'th local corner on face f
      data c_f /2,4,6,8, 1,3,5,7, 3,4,7,8, 1,2,5,6, 5,6,7,8, 1,2,3,4/

!.....on each face of the parent element, there are four children element.
!     le_arr(i,j,n) returns the i'th elements among the four children elements 
!     n refers to the direction: 1 for x, 2 for y and 3 for z direction. 
!     j refers to positive(0) or negative(1) direction on x, y or z direction.
!     n=1,j=0 refers to face 1 and n=1, j=1 refers to face 2, n=2,j=0 refers to
!     face 3.... 
!     The current eight children are ordered as 8,1,2,3,4,5,6,7 
      data    le_arr/8,2,4,6, 1,3,5,7,  &
     &               8,1,4,5, 2,3,6,7,  &
     &               8,1,2,3, 4,5,6,7/

!.....jjface(n) returns the face opposite to face n
      data jjface /2,1,4,3,6,5/

!c.....edgeface(n,f) returns OTHER face which shares local edge n on face f
!      integer edgeface(4,6)
!      data edgeface /6,3,5,4, 6,3,5,4, 6,1,5,2, 
!     $               6,1,5,2, 4,1,3,2, 4,1,3,2/

!.....e_face2(n,f) returns the local edge number of edge n on the
!     other face sharing local edge n on face f
      data e_face2 /2,2,2,2, 4,4,4,4, 3,2,3,2,  &
     &              1,4,1,4, 3,3,3,3, 1,1,1,1/

!.....op(n) returns the local edge number of the edge which 
!     is opposite to local edge n on the same face
      data op /3,4,1,2/

!.....localedgenumber(f,e) returns the local edge number for edge e
!     on face f. A zero result value signifies illegal input
      data localedgenumber /1,0,0,0,0,2, 2,0,2,0,0,0, 3,0,0,0,2,0,  &
     &                      4,0,0,2,0,0, 0,1,0,0,0,4, 0,2,4,0,0,0,  &
     &                      0,3,0,0,4,0, 0,4,0,4,0,0, 0,0,1,0,0,3,  &
     &                      0,0,3,0,3,0, 0,0,0,1,0,1, 0,0,0,3,1,0/

!.....edgenumber(e,f) returns the edge index of local edge e on face f
      data edgenumber / 1,2, 3,4,  5,6, 7,8,  9,2,10,6,  &
     &                 11,4,12,8, 12,3,10,7, 11,1, 9,5/

!.....f_c(c,n) returns the face index of i'th face sharing vertex n 
      data f_c /2,4,6, 1,4,6, 2,3,6, 1,3,6,  &
     &          2,4,5, 1,4,5, 2,3,5, 1,3,5/

!.....if two elements are neighbor by one edge, 
!     e1v1(f1,f2) returns the smaller index of the two vertices on this 
!     edge on one element
!     e1v2 returns the larger index of the two vertices of this edge on 
!     on element. exfor a vertex on element 
!     e2v1 returns the smaller index of the two vertices on this edge on 
!     another element
!     e2v2 returns the larger index of the two vertiex on this edge on
!     another element
      data e1v1/0,0,4,2,6,2, 0,0,3,1,5,1, 4,3,0,0,7,3,  &
     &          2,1,0,0,5,1, 6,5,7,5,0,0, 2,1,3,1,0,0/
      data e2v1/0,0,1,3,1,5, 0,0,2,4,2,6, 1,2,0,0,1,5,  &
     &          3,4,0,0,3,7, 1,2,1,3,0,0, 5,6,5,7,0,0/
      data e1v2/0,0,8,6,8,4, 0,0,7,5,7,3, 8,7,0,0,8,4,  &
     &          6,5,0,0,6,2, 8,7,8,6,0,0, 4,3,4,2,0,0/
      data e2v2/0,0,5,7,3,7, 0,0,6,8,4,8, 5,6,0,0,2,6,  &
     &          7,8,0,0,4,8, 3,4,2,4,0,0, 7,8,6,8,0,0/

!.....children(n1,n)returns the four elements among the eight children 
!     elements to be merged on face n of the parent element
!     the IDs for the eight children are 1,2,3,4,5,6,7,8
      data children/2,4,6,8, 1,3,5,7, 3,4,7,8,  &
     &              1,2,5,6, 5,6,7,8, 1,2,3,4/

!.....iijj(n1,n) returns the location of n's mortar on an element face
!     n1=1 refers to x direction location and n1=2 refers to y direction
      data iijj/1,1,1,2,2,1,2,2/

!.....v_end(n) returns the index of collocation points at two ends of each
!     direction
      data v_end /1,lx1/

!.....face_l1,face_l2,face_ld return for start,end,stride for a loop over faces 
!     used on subroutine  mortar_vertex
      data face_l1 /2,3,1/, face_l2 /3,1,2/, face_ld /1,-2,1/


      end module ua_data


!---------------------------------------------------------------------
!---------------------------------------------------------------------

      subroutine alloc_space

!---------------------------------------------------------------------
!---------------------------------------------------------------------

!---------------------------------------------------------------------
! allocate space dynamically for data arrays
!---------------------------------------------------------------------

      use ua_data
      implicit none

      integer ios


      allocate (  &
     &        ta1  (lx1,lx1,lx1,lelt), ta2   (lx1,lx1,lx1,lelt),  &
     &        trhs (lx1,lx1,lx1,lelt), t     (lx1,lx1,lx1,lelt),  &
     &        tmult(lx1,lx1,lx1,lelt), dpcelm(lx1,lx1,lx1,lelt),  &
     &        pdiff(lx1,lx1,lx1,lelt), pdiffp(lx1,lx1,lx1,lelt),  &
     &        stat = ios)

      if (ios .eq. 0) allocate (  &
     &        umor(lmor), tmmor(lmor),  &
     &        rmor(lmor), dpcmor (lmor), pmorx(lmor), ppmor(lmor),  &
     &        mormult(lmor), tmort(lmor),  &
     &        stat = ios)

      if (ios .eq. 0) allocate (  &
     &        idmo    (lx1,lx1,lnje,lnje,nsides,lelt),  &
     &        idel    (lx1,lx1,          nsides,lelt),  &
     &        sje     (2,2,              nsides,lelt),  &
     &        sje_new (2,2,              nsides,lelt),  &
     &        ijel    (2,                nsides,lelt),  &
     &        ijel_new(2,                nsides,lelt),  &
     &        cbc     (                  nsides,lelt),  &
     &        cbc_new (                  nsides,lelt),  &
     &        vassign (8,lelt),       emo(2,8,8*lelt),   &
     &        nemo    (8*lelt),  &
     &        diagn   (2,12,lelt),  &
     &        stat = ios)

      if (ios .eq. 0) allocate (  &
     &        tree   (lelt), mt_to_id    (lelt),                   &
     &        newc   (lelt), mt_to_id_old(lelt),  &
     &        newi   (lelt), id_to_mt    (lelt),  &
     &        newe   (lelt), ref_front_id(lelt),  &
     &        front  (lelt), action      (lelt),  &
     &        ich    (lelt), size_e      (lelt),  &
     &        treenew(lelt),  &
     &        stat = ios)

      if (ios .eq. 0) allocate (  &
     &        ifpcmor  (8* lelt),  &
     &        eassign  (12,lelt),  if_1_edge(12,lelt),  &
     &        ncon_edge(12,lelt),  &
     &        skip (lelt), ifcoa (lelt), ifcoa_id(lelt),  &
     &        fassign(nsides,lelt), edgevis(4,nsides,lelt),    &
     &        stat = ios)

!.....coordinate of element vertices
      if (ios .eq. 0) allocate (  &
     &        xc    (8,lelt),yc    (8,lelt),zc    (8,lelt),  &
     &        xc_new(8,lelt),yc_new(8,lelt),zc_new(8,lelt),  &
     &        stat = ios)

      if (ios .ne. 0) then
         write(*,*) 'Error encountered in allocating space'
         stop
      endif

      return
      end

!-------------------------------------------------------------------------c
!                                                                         c
!        N  A  S     P A R A L L E L     B E N C H M A R K S  3.4         c
!                                                                         c
!                      O p e n M P     V E R S I O N                      c
!                                                                         c
!                                   U A                                   c
!                                                                         c
!-------------------------------------------------------------------------c
!                                                                         c
!    This benchmark is the OpenMP version of the NPB UA code.             c
!    Refer to NAS Technical Report NAS--04-006 for details                c
!                                                                         c
!    Permission to use, copy, distribute and modify this software         c
!    for any purpose with or without fee is hereby granted.  We           c
!    request, however, that all derived work reference the NAS            c
!    Parallel Benchmarks 3.4. This software is provided "as is"           c
!    without express or implied warranty.                                 c
!                                                                         c
!    Information on NPB 3.4, including the technical report, the          c
!    original specifications, source code, results and information        c
!    on how to submit new results, is available at:                       c
!                                                                         c
!           http://www.nas.nasa.gov/Software/NPB/                         c
!                                                                         c
!    Send comments or suggestions to  npb@nas.nasa.gov                    c
!                                                                         c
!          NAS Parallel Benchmarks Group                                  c
!          NASA Ames Research Center                                      c
!          Mail Stop: T27A-1                                              c
!          Moffett Field, CA   94035-1000                                 c
!                                                                         c
!          E-mail:  npb@nas.nasa.gov                                      c
!          Fax:     (650) 604-3957                                        c
!                                                                         c
!-------------------------------------------------------------------------c

!---------------------------------------------------------------------
!
! Author: H. Feng
!         R. Van der Wijngaart
!---------------------------------------------------------------------

      program ua

      use ua_data
      implicit none

      integer          step, ie,iside,i,j, fstatus,k
      external         timer_read
      double precision timer_read, mflops, tmax, nelt_tot
      character        class
      logical          ifmortar, verified
!$    integer          omp_get_max_threads
!$    external         omp_get_max_threads

      double precision t2, trecs(t_last)
      character t_names(t_last)*10

!---------------------------------------------------------------------
!     Read input file (if it exists), else take
!     defaults from parameters
!---------------------------------------------------------------------
          
      call check_timer_flag( timeron )
      if (timeron) then
         t_names(t_total) = 'total'
         t_names(t_init) = 'init'
         t_names(t_convect) = 'convect'
         t_names(t_transfb_c) = 'transfb_c'
         t_names(t_diffusion) = 'diffusion'
         t_names(t_transf) = 'transf'
         t_names(t_transfb) = 'transfb'
         t_names(t_adaptation) = 'adaptation'
         t_names(t_transf2) = 'transf+b'
         t_names(t_add2) = 'add2'
      endif

      write (*,1000) 
      open (unit=2,file='inputua.data',status='old', iostat=fstatus)

      if (fstatus .eq. 0) then
        write(*,233) 
 233    format(' Reading from input file inputua.data')
        read (2,*) fre
        read (2,*) niter
        read (2,*) nmxh
        read (2,*) alpha
        class = 'U'
        close(2)
      else
        write(*,234) 
        fre        = fre_default
        niter      = niter_default
        nmxh       = nmxh_default
        alpha      = alpha_default
        class      = class_default
      endif
 234  format(' No input file inputua.data. Using compiled defaults')

      dlmin = 0.5d0**refine_max
      dtime = 0.04d0*dlmin

      write (*,1001) refine_max
      write (*,1002) fre
      write (*,1003) niter, dtime
      write (*,1004) nmxh
      write (*,1005) alpha
!$    write (*,1006) omp_get_max_threads()
      write (*,*)


 1000 format(//,' NAS Parallel Benchmarks (NPB3.4-OMP)',  &
     &          ' - UA Benchmark', /)
 1001 format(' Levels of refinement:        ', i8)
 1002 format(' Adaptation frequency:        ', i8)
 1003 format(' Time steps:                  ', i8, '    dt: ', g15.6)
 1004 format(' CG iterations:               ', i8)
 1005 format(' Heat source radius:          ', f8.4)
 1006 format(' Number of available threads: ', i8)

      do i = 1, t_last
         call timer_clear(i)
      end do
      if (timeron) call timer_start(t_init)

      call alloc_space

!.....set up initial mesh (single element) and solution (all zero)
      call create_initial_grid

      call r_init_omp(ta1,ntot,0.d0)
      call nr_init_omp(sje,4*6*nelt,0)

      call init_locks

!.....compute tables of coefficients and weights      
      call coef 
      call geom1

!.....compute the discrete laplacian operators
      call setdef

!.....prepare for the preconditioner
      call setpcmo_pre

!.....refine initial mesh and do some preliminary work
      time = 0.d0
      call mortar
      call prepwork
      call adaptation(ifmortar,0)
      if (timeron) call timer_stop(t_init)

      call timer_clear(1)

      time = 0.d0
      do step= 0, niter

        if (step .eq. 1) then
!.........reset the solution and start the timer, keep track of total no elms

          call r_init(ta1,ntot,0.d0)

          time = 0.d0
          nelt_tot = 0.d0
          do i = 1, t_last
             if (i.ne.t_init) call timer_clear(i)
          end do
          call timer_start(1)          
        endif

!.......advance the convection step 
        call convect(ifmortar)

        if (timeron) call timer_start(t_transf2)
!.......prepare the intital guess for cg
        call transf(tmort,ta1)

!.......compute residual for diffusion term based on intital guess

!.......compute the left hand side of equation, lapacian t
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(ie,k,j,i) 
!$OMP DO 
        do ie = 1,nelt
          call laplacian(ta2(1,1,1,ie),ta1(1,1,1,ie),size_e(ie))
        end do
!$OMP END DO 
!.......compute the residual 
!$OMP DO
        do ie = 1, nelt
          do k=1,lx1
            do j=1,lx1
              do i=1,lx1
                trhs(i,j,k,ie) = trhs(i,j,k,ie) - ta2(i,j,k,ie)
              end do
            end do
          end do
        end do
!$OMP END DO
!$OMP END PARALLEL
!.......get the residual on mortar 
        call transfb(rmor,trhs)
        if (timeron) call timer_stop(t_transf2)

!.......apply boundary condition: zero out the residual on domain boundaries

!.......apply boundary conidtion to trhs
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ie,iside)
        do ie=1,nelt  
          do iside=1,nsides
            if (cbc(iside,ie).eq.0) then
              call facev(trhs(1,1,1,ie),iside,0.d0)
            end if
          end do
        end do
!$OMP END PARALLELDO
!.......apply boundary condition to rmor
        call col2(rmor,tmmor,nmor)

!.......call the conjugate gradient iterative solver
        call diffusion(ifmortar)

!.......add convection and diffusion
        if (timeron) call timer_start(t_add2)
        call add2(ta1,t,ntot)
        if (timeron) call timer_stop(t_add2)

        
!.......perform mesh adaptation
        time=time+dtime
        if ((step.ne.0).and.(step/fre*fre .eq. step)) then
           if (step .ne. niter) then
             call adaptation(ifmortar,step)
           end if
        else
          ifmortar = .false.
        end if
        nelt_tot = nelt_tot + dble(nelt)
      end do

      call timer_stop(1)
      tmax = timer_read(1)
       
      call verify(class, verified)

!.....compute millions of collocation points advanced per second.
!.....diffusion: nmxh advancements, convection: 1 advancement
      mflops = nelt_tot*dble(lx1*lx1*lx1*(nmxh+1))/(tmax*1.d6)

      call print_results('UA', class, refine_max, 0, 0, niter,  &
     &     tmax, mflops, '    coll. point advanced',  &
     &     verified, npbversion,compiletime, cs1, cs2, cs3, cs4, cs5,  &
     &     cs6, '(none)')

!---------------------------------------------------------------------
!      More timers
!---------------------------------------------------------------------
      if (.not.timeron) goto 999

      do i=1, t_last
         trecs(i) = timer_read(i)
      end do
      if (tmax .eq. 0.0) tmax = 1.0

      write(*,800)
 800  format('  SECTION     Time (secs)')
      do i=1, t_last
         write(*,810) t_names(i), trecs(i), trecs(i)*100./tmax
         if (i.eq.t_transfb_c) then
            t2 = trecs(t_convect) - trecs(t_transfb_c)
            write(*,820) 'sub-convect', t2, t2*100./tmax
         else if (i.eq.t_transfb) then
            t2 = trecs(t_diffusion) - trecs(t_transf) - trecs(t_transfb)
            write(*,820) 'sub-diffuse', t2, t2*100./tmax
         endif
 810     format(2x,a10,':',f9.3,'  (',f6.2,'%)')
 820     format('    --> ',a11,':',f9.3,'  (',f6.2,'%)')
      end do

 999  continue

      end 

!---------------------------------------------------------------
      subroutine move
!---------------------------------------------------------------
!     move element to proper location in morton space filling curve
!---------------------------------------------------------------

      use ua_data
      implicit none

      integer i,iside,jface,iel,ntemp,ii1,ii2,n1,n2,cb

      n2=2*6*nelt
      n1=n2*2

      call nr_init_omp(sje_new,n1,0)
      call nr_init_omp(ijel_new,n2,0)

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(iel,i,iside,jface,cb,ntemp,  &
!$OMP& ii1,ii2) 
!$OMP DO
      do iel=1,nelt
        i=mt_to_id(iel)
        treenew(iel)=tree(i)
        call copy(xc_new(1,iel),xc(1,i),8)
        call copy(yc_new(1,iel),yc(1,i),8)
        call copy(zc_new(1,iel),zc(1,i),8)

        do iside=1,nsides
          jface = jjface(iside)
          cb=cbc(iside,i)
          xc_new(iside,iel)=xc(iside,i)
          yc_new(iside,iel)=yc(iside,i)
          zc_new(iside,iel)=zc(iside,i)
          cbc_new(iside,iel)=cb

          if(cb.eq.2)then
            ntemp=sje(1,1,iside,i)
            ijel_new(1,iside,iel)=1
            ijel_new(2,iside,iel)=1
            sje_new(1,1,iside,iel)=id_to_mt(ntemp)

          else if(cb.eq.1) then
            ntemp=sje(1,1,iside,i)
            ijel_new(1,iside,iel)=ijel(1,iside,i)
            ijel_new(2,iside,iel)=ijel(2,iside,i)
            sje_new(1,1,iside,iel)=id_to_mt(ntemp)
         
          else if(cb.eq.3) then
            do ii2=1,2
              do ii1=1,2
                ntemp=sje(ii1,ii2,iside,i)
                ijel_new(1,iside,iel)=1
                ijel_new(2,iside,iel)=1
                sje_new(ii1,ii2,iside,iel)=id_to_mt(ntemp)
              end do
            end do

          else if(cb.eq.0)then
            sje_new(1,1,iside,iel)=0
            sje_new(1,2,iside,iel)=0
            sje_new(2,1,iside,iel)=0
            sje_new(2,2,iside,iel)=0       
          end if 

        end do

        call copy(ta2(1,1,1,iel),ta1(1,1,1,i),nxyz)

      end do
!$OMP ENDDO

!$OMP DO
      do iel=1,nelt
        call copy(xc(1,iel),xc_new(1,iel),8)
        call copy(yc(1,iel),yc_new(1,iel),8)
        call copy(zc(1,iel),zc_new(1,iel),8)
        call copy(ta1(1,1,1,iel),ta2(1,1,1,iel),nxyz)
        call ncopy(sje(1,1,1,iel),sje_new(1,1,1,iel),4*6)
        call ncopy(ijel(1,1,iel),ijel_new(1,1,iel),2*6)
        call ncopy(cbc(1,iel),cbc_new(1,iel),6)
        mt_to_id(iel)=iel
        id_to_mt(iel)=iel
        tree(iel)=treenew(iel)
      end do
!$OMP ENDDO 
!$OMP END PARALLEL

      return
      end 

      double precision function randlc(x, a)

!---------------------------------------------------------------------
!
!   This routine returns a uniform pseudorandom double precision number in the
!   range (0, 1) by using the linear congruential generator
!
!   x_{k+1} = a x_k  (mod 2^46)
!
!   where 0 < x_k < 2^46 and 0 < a < 2^46.  This scheme generates 2^44 numbers
!   before repeating.  The argument A is the same as 'a' in the above formula,
!   and X is the same as x_0.  A and X must be odd double precision integers
!   in the range (1, 2^46).  The returned value RANDLC is normalized to be
!   between 0 and 1, i.e. RANDLC = 2^(-46) * x_1.  X is updated to contain
!   the new seed x_1, so that subsequent calls to RANDLC using the same
!   arguments will generate a continuous sequence.

      implicit none
      double precision x, a
      integer(kind=8) Lx, La, a1, a2, x1, x2, xa
      double precision d2m46
      parameter(d2m46=0.5d0**46)

      Lx = x
      La = A
      a1 = ibits(La, 23, 23)
      a2 = ibits(La, 0, 23)
      x1 = ibits(Lx, 23, 23)
      x2 = ibits(Lx, 0, 23)
      xa = ishft(ibits(a1*x2+a2*x1, 0, 23), 23) + a2*x2
      Lx   = ibits(xa,0, 46)
      x    = dble(Lx)
      randlc = d2m46*x
      return
      end


!---------------------------------------------------------------------
!---------------------------------------------------------------------


      SUBROUTINE VRANLC (N, X, A, Y)
      implicit none
      integer n, i
      double precision x, a, y(*)
      integer(kind=8) Lx, La, a1, a2, x1, x2, xa
      double precision d2m46
      parameter(d2m46=0.5d0**46)

      Lx = X
      La = A
      a1 = ibits(La, 23, 23)
      a2 = ibits(La, 0, 23)
      do i = 1, N
         x1 = ibits(Lx, 23, 23)
         x2 = ibits(Lx, 0, 23)
         xa = ishft(ibits(a1*x2+a2*x1, 0, 23), 23) + a2*x2
         Lx   = ibits(xa,0, 46)
         y(i) = d2m46*dble(Lx)
      end do
      x = dble(Lx)
      return
      end

!---------------------------------------------------------------------
!---------------------------------------------------------------------

      subroutine read_input

!---------------------------------------------------------------------
!---------------------------------------------------------------------

      use lu_data
      implicit none

      integer  fstatus
!$    integer  omp_get_max_threads
!$    external omp_get_max_threads


!---------------------------------------------------------------------
!    if input file does not exist, it uses defaults
!       ipr = 1 for detailed progress output
!       inorm = how often the norm is printed (once every inorm iterations)
!       itmax = number of pseudo time steps
!       dt = time step
!       omega 1 over-relaxation factor for SSOR
!       tolrsd = steady state residual tolerance levels
!       nx, ny, nz = number of grid points in x, y, z directions
!---------------------------------------------------------------------

         write(*, 1000)

         open (unit=3,file='inputlu.data',status='old',  &
     &         access='sequential',form='formatted', iostat=fstatus)
         if (fstatus .eq. 0) then

            write(*, *) 'Reading from input file inputlu.data'

            read (3,*)
            read (3,*)
            read (3,*) ipr, inorm
            read (3,*)
            read (3,*)
            read (3,*) itmax
            read (3,*)
            read (3,*)
            read (3,*) dt
            read (3,*)
            read (3,*)
            read (3,*) omega
            read (3,*)
            read (3,*)
            read (3,*) tolrsd(1),tolrsd(2),tolrsd(3),tolrsd(4),tolrsd(5)
            read (3,*)
            read (3,*)
            read (3,*) nx0, ny0, nz0
            close(3)
         else
            ipr = ipr_default
            inorm = inorm_default
            itmax = itmax_default
            dt = dt_default
            omega = omega_default
            tolrsd(1) = tolrsd1_def
            tolrsd(2) = tolrsd2_def
            tolrsd(3) = tolrsd3_def
            tolrsd(4) = tolrsd4_def
            tolrsd(5) = tolrsd5_def
            nx0 = isiz1
            ny0 = isiz2
            nz0 = isiz3
         endif

!---------------------------------------------------------------------
!   check problem size
!---------------------------------------------------------------------

         if ( ( nx0 .lt. 4 ) .or.  &
     &        ( ny0 .lt. 4 ) .or.  &
     &        ( nz0 .lt. 4 ) ) then

            write (*,2001)
 2001       format (5x,'PROBLEM SIZE IS TOO SMALL - ',  &
     &           /5x,'SET EACH OF NX, NY AND NZ AT LEAST EQUAL TO 5')
            stop

         end if

         if ( ( nx0 .gt. isiz1 ) .or.  &
     &        ( ny0 .gt. isiz2 ) .or.  &
     &        ( nz0 .gt. isiz3 ) ) then

            write (*,2002)
 2002       format (5x,'PROBLEM SIZE IS TOO LARGE - ',  &
     &           /5x,'NX, NY AND NZ SHOULD BE EQUAL TO ',  &
     &           /5x,'ISIZ1, ISIZ2 AND ISIZ3 RESPECTIVELY')
            stop

         end if


         write(*, 1001) nx0, ny0, nz0
         write(*, 1002) itmax
!$       write(*, 1003) omp_get_max_threads()
         write(*, *)


 1000 format(//,' NAS Parallel Benchmarks (NPB3.4-OMP)',  &
     &          ' - LU Benchmark', /)
 1001    format(' Size: ', i4, 'x', i4, 'x', i4)
 1002    format(' Iterations:                  ', i5)
 1003    format(' Number of available threads: ', i5)
         


      return
      end

      double precision function randlc(x, a)

!---------------------------------------------------------------------
!
!   This routine returns a uniform pseudorandom double precision number in the
!   range (0, 1) by using the linear congruential generator
!
!   x_{k+1} = a x_k  (mod 2^46)
!
!   where 0 < x_k < 2^46 and 0 < a < 2^46.  This scheme generates 2^44 numbers
!   before repeating.  The argument A is the same as 'a' in the above formula,
!   and X is the same as x_0.  A and X must be odd double precision integers
!   in the range (1, 2^46).  The returned value RANDLC is normalized to be
!   between 0 and 1, i.e. RANDLC = 2^(-46) * x_1.  X is updated to contain
!   the new seed x_1, so that subsequent calls to RANDLC using the same
!   arguments will generate a continuous sequence.

      implicit none
      double precision x, a
      integer(kind=8) i246m1, Lx, La
      double precision d2m46

      parameter(d2m46=0.5d0**46)

      parameter(i246m1=INT(Z'00003FFFFFFFFFFF',8))

      Lx = X
      La = A

      Lx   = iand(Lx*La,i246m1)
      randlc = d2m46*dble(Lx)
      x    = dble(Lx)
      return
      end


!---------------------------------------------------------------------
!---------------------------------------------------------------------


      SUBROUTINE VRANLC (N, X, A, Y)
      implicit none
      integer n, i
      double precision x, a, y(*)
      integer(kind=8) i246m1, Lx, La
      double precision d2m46

! This doesn't work, because the compiler does the calculation in 32
! bits and overflows. No standard way (without f90 stuff) to specify
! that the rhs should be done in 64 bit arithmetic. 
!      parameter(i246m1=2**46-1)

      parameter(d2m46=0.5d0**46)

      parameter(i246m1=INT(Z'00003FFFFFFFFFFF',8))

      Lx = X
      La = A
      do i = 1, N
         Lx   = iand(Lx*La,i246m1)
         y(i) = d2m46*dble(Lx)
      end do
      x    = dble(Lx)

      return
      end

!---------------------------------------------------------------------
!---------------------------------------------------------------------
!
!  ft_data module
!
!---------------------------------------------------------------------
!---------------------------------------------------------------------

      module ft_data

      include 'npbparams.h'

! total number of grid points with padding
      integer(kind2) nxp, ntotalp
      parameter (nxp=nx+1)
      parameter (ntotalp=nxp*ny*nz)
      double precision ntotal_f
      parameter (ntotal_f=dble(nx)*ny*nz)


! If processor array is 1x1 -> 0D grid decomposition


! Cache blocking params. These values are good for most
! RISC processors.  
! FFT parameters:
!  fftblock controls how many ffts are done at a time. 
!  The default is appropriate for most cache-based machines
!  On vector machines, the FFT can be vectorized with vector
!  length equal to the block size, so the block size should
!  be as large as possible. This is the size of the smallest
!  dimension of the problem: 128 for class A, 256 for class B and
!  512 for class C.

      include 'blk_par.h'
!      integer fftblock_default, fftblockpad_default
!      parameter (fftblock_default=32, fftblockpad_default=34)
      
      integer fftblock, fftblockpad

! we need a bunch of logic to keep track of how
! arrays are laid out. 


! Note: this serial version is the derived from the parallel 0D case
! of the ft NPB.
! The computation proceeds logically as

! set up initial conditions
! fftx(1)
! transpose (1->2)
! ffty(2)
! transpose (2->3)
! fftz(3)
! time evolution
! fftz(3)
! transpose (3->2)
! ffty(2)
! transpose (2->1)
! fftx(1)
! compute residual(1)

! for the 0D, 1D, 2D strategies, the layouts look like xxx
!        
!            0D        1D        2D
! 1:        xyz       xyz       xyz

! the array dimensions are stored in dims(coord, phase)
      integer dims(3)

      integer T_total, T_setup, T_fft, T_evolve, T_checksum,  &
     &        T_fftx, T_ffty,  &
     &        T_fftz, T_max
      parameter (T_total = 1, T_setup = 2, T_fft = 3,  &
     &           T_evolve = 4, T_checksum = 5,  &
     &           T_fftx = 6,  &
     &           T_ffty = 7,  &
     &           T_fftz = 8, T_max = 8)



      logical timers_enabled


      external timer_read
      double precision timer_read
      external ilog2
      integer ilog2

      external randlc
      double precision randlc


! other stuff
      logical debug, debugsynch

      double precision seed, a, pi, alpha
      parameter (seed = 314159265.d0, a = 1220703125.d0,  &
     &  pi = 3.141592653589793238d0, alpha=1.0d-6)


! roots of unity array
! relies on x being largest dimension?
      double complex u(nxp)


! for checksum data
      double complex sums(0:niter_default)

! number of iterations
      integer niter


      end module ft_data


!---------------------------------------------------------------------
!---------------------------------------------------------------------
!
!  ft_fields module
!
!---------------------------------------------------------------------
!---------------------------------------------------------------------

      module ft_fields

!---------------------------------------------------------------------
! u0, u1, u2 are the main arrays in the problem. 
! Depending on the decomposition, these arrays will have different 
! dimensions. To accomodate all possibilities, we allocate them as 
! one-dimensional arrays and pass them to subroutines for different 
! views
!  - u0 contains the initial (transformed) initial condition
!  - u1 and u2 are working arrays
!  - twiddle contains exponents for the time evolution operator. 
!---------------------------------------------------------------------

      double complex, allocatable ::  &
     &                 u0(:), pad1(:),  &
     &                 u1(:), pad2(:)
!     >                 u2(:)
      double precision, allocatable :: twiddle(:)
!---------------------------------------------------------------------
! Large arrays are in module so that they are allocated on the
! heap rather than the stack. This module is not
! referenced directly anywhere else. Padding is to avoid accidental 
! cache problems, since all array sizes are powers of two.
!---------------------------------------------------------------------


      end module ft_fields


!---------------------------------------------------------------------
!---------------------------------------------------------------------

      subroutine alloc_space

!---------------------------------------------------------------------
!---------------------------------------------------------------------

!---------------------------------------------------------------------
! allocate space dynamically for data arrays
!---------------------------------------------------------------------

      use ft_data, only : ntotalp
      use ft_fields

      implicit none

      integer ios


      allocate (  &
     &          u0(ntotalp), pad1(3),  &
     &          u1(ntotalp), pad2(3),  &
!     >          u2(ntotalp),
     &          twiddle(ntotalp),  &
     &          stat = ios)

      if (ios .ne. 0) then
         write(*,*) 'Error encountered in allocating space'
         stop
      endif

      return
      end

!-----------------------------------------------------------
      subroutine adaptation (ifmortar,step)
!-----------------------------------------------------------
!     For 3-D mesh adaptation (refinement+ coarsening)
!-----------------------------------------------------------

      use ua_data
      implicit none
      
      logical if_coarsen,if_refine,ifmortar,ifrepeat
      integer iel,miel,irefine,icoarsen,neltold,step

      if (timeron) call timer_start(t_adaptation)
      ifmortar=.false.
!.....compute heat source center(x0,y0,z0)
      x0=x00+velx*time
      y0=y00+vely*time
      z0=z00+velz*time

!.....Search elements to be refined. Check with restrictions. Perform
!     refinement repeatedly until all desired refinements are done.

!.....ich(iel)=0 no grid change on element iel
!.....ich(iel)=2 iel is marked to be coarsened
!.....ich(iel)=4 iel is marked to be refined

!.....irefine records how many elements got refined
      irefine=0

!.....check whether elements need to be refined because they have overlap
!     with the  heat source
4     call find_refine(if_refine)

      if(if_refine) then
        ifrepeat=.true.
2       if(ifrepeat) then
!.........Check with restriction, unmark elements that cannot be refined.
!         Elements preventing desired refinement will be marked to be refined.
          call check_refine(ifrepeat) 
          go to 2
        end if
!.......perform refinement
        call do_refine(ifmortar,irefine)
        goto 4
      endif

!.....Search for elements to be coarsened. Check with restrictions,
!     Perform coarsening repeatedly until all possible coarsening
!     is done.

!.....icoarsen records how many elements got coarsened 
      icoarsen=0

!.....skip(iel)=.true. indicates an element no longer exists (because it
!     got merged)
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(iel)
       do iel=1,nelt
        skip(iel)=.false.
      end do
!$OMP END PARALLEL DO

      neltold=nelt

!.....Check whether elements need to be coarsened because they don't have
!     overlap with the heat source. Only elements that don't have a larger 
!     size neighbor can be marked to be coarsened

5     call find_coarsen(if_coarsen,neltold)

      if(if_coarsen) then
!.......Perform coarsening, however subject to restriction. Only possible 
!       coarsening will be performed. if_coarsen=.true. indicates that
!       actual coarsening happened
        call do_coarsen(if_coarsen,icoarsen,neltold)
        if(if_coarsen) then
!.........ifmortar=.true. indicates the grid changed, i.e. the mortar points 
!         indices need to be regenerated on the new grid.
          ifmortar=.true.
          go to 5
        end if 
      end if

      write(*,1000) step, irefine, icoarsen, nelt
 1000 format('Step ',i4, ': elements refined, merged, total: ',  &
     &       i7, 1X , i7, 1X, i7)

!.....mt_to_id(miel) takes as argument the morton index  and returns the actual 
!                    element index
!.....id_to_mt(iel)  takes as argument the actual element index and returns the 
!                    morton index
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(miel,iel)
      do miel=1,nelt
        iel=mt_to_id(miel)
        id_to_mt(iel)=miel
      end do 
!$OMP END PARALLEL DO

!.....Reorder the elements in the order of the morton curve. After the move 
!     subroutine the element indices are  the same as the morton indices
      call move

!.....if the grid changed, regenerate mortar indices and update variables
!     associated to grid.
      if (ifmortar) then
        call mortar
        call prepwork
      endif
      if (timeron) call timer_stop(t_adaptation)

      return
      end 


!-----------------------------------------------------------
      subroutine do_coarsen(if_coarsen,icoarsen,neltold)
!---------------------------------------------------------------
!     Coarsening procedure: 
!     1) check with restrictions
!     2) perform coarsening
!---------------------------------------------------------------

      use ua_data
      implicit none

      logical if_coarsen, icheck,test,test1,test2,test3
      integer iel, ntp(8), ntempmin, ic, parent, mielnew, miel,  &
     &        icoarsen, i, index, num_coarsen, ntemp, ii, ntemp1,  &
     &        neltold
      
      if_coarsen=.false.

!.....If an element has been merged, it will be skipped afterwards
!     skip(iel)=.true. for elements that will be skipped.
!     ifcoa_id(iel)=.true. indicates that element iel will be coarsened
!     ifcoa(miel)=.true. refers to element miel(mortar index) will be
!                        coarsened

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(iel)
!$OMP DO 
      do iel=1,nelt
        mt_to_id_old(iel)=mt_to_id(iel)
        mt_to_id(iel)=0
      end do
!$OMP END DO nowait
!$OMP DO 
      do iel=1,neltold 
        ifcoa_id(iel)=.false.
      end do
!$OMP END DO nowait
!$OMP END PARALLEL

!.....Check whether the potential coarsening will make neighbor, 
!     and neighbor's neighbor....break grid restriction

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(miel,iel,ic,  &
!$OMP& ntp,parent,test,test1,i,test2,test3)  &
!$OMP& SHARED(if_coarsen)
      do miel=1,nelt
        ifcoa(miel)=.false.
        front(miel)=0
        iel=mt_to_id_old(miel)
!.......if an element is marked to be coarsened
        if(ich(iel).eq.2) then

!.........If the current  element is the "first" child (front-left-
!         bottom) of its parent (tree(iel) mod 8 equals 0), then 
!         find all its neighbors. Check whether they are from the same 
!         parent.

          ic=tree(iel)
          if(.not.btest(ic,0).and..not.btest(ic,1).and.  &
     &       .not.btest(ic,2)) then
            ntp(1)=iel
            ntp(2)=sje(1,1,1,iel)
            ntp(3)=sje(1,1,3,iel)
            ntp(4)=sje(1,1,1,ntp(3))
            ntp(5)=sje(1,1,5,iel)
            ntp(6)=sje(1,1,1,ntp(5))
            ntp(7)=sje(1,1,3,ntp(5))
            ntp(8)=sje(1,1,1,ntp(7))
 
            parent=ishft(tree(iel),-3)
            test=.false.

            test1=.true.
            do i=1,8
              if(ishft(tree(ntp(i)),-3).ne.parent)test1=.false.
            end do

!...........check whether all child elements are marked to be coarsened
            if(test1)then
              test2=.true.
              do i=1,8
                if(ich(ntp(i)).ne.2)test2=.false.
              end do

!.............check whether all child elements can be coarsened or not.
              if(test2)then
                test3=.true.
                do i=1,8
                  if(.not.icheck(ntp(i),i))test3=.false.
                end do
                if(test3)test=.true.
              end if
            end if
!...........if the eight child elements are eligible to be coarsened
!           mark the first children ifcoa(miel)=.true.
!           mark them all ifcoa_id()=.true.
!           front(miel) will be used to calculate (potentially in parallel) 
!                       how many elements with seuqnece numbers less than
!                       miel will be coarsened.
!           skip()      marks that an element will no longer exist after merge.

            if(test)then

              ifcoa(miel)=.true.
              do i=1,8
                ifcoa_id(ntp(i))=.true.
              end do
              front(miel)=1
              do i=1,7
                 skip(ntp(i+1))=.true.
              end do
              if(.not.if_coarsen) if_coarsen=.true.
            end if
          end if 
        end if 
      end do 
!$OMP END PARALLEL DO

!.....compute front(iel), how many elements will be coarsened before iel
!     (including iel)
      call parallel_add(front)

!.....num_coarsen is the total number of elements that will be coarsened
      num_coarsen=front(nelt)

!.....action(i) records the morton index of the i'th element (if it is an
!     element's front-left-bottom-child) to be coarsened.

!.....create array mt_to_id to convert actual element index to morton index
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(miel,iel,mielnew)
      do miel=1,nelt
        iel=mt_to_id_old(miel)
        if(.not.skip(iel))then
          if(ifcoa(miel))then
            action(front(miel))=miel
            mielnew=miel-(front(miel)-1)*7
          else 
            mielnew=miel-front(miel)*7
          end if
          mt_to_id(mielnew)=iel
        end if
      end do
!$OMP END PARALLEL DO

!.....perform the coarsening procedure (potentially in parallel)
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(index,miel,iel,ntp)
      do index=1,num_coarsen
        miel=action(index)
        iel=mt_to_id_old(miel)
!.......find eight child elements to be coarsened
        ntp(1)=iel
        ntp(2)=sje(1,1,1,iel)
        ntp(3)=sje(1,1,3,iel)
        ntp(4)=sje(1,1,1,ntp(3))
        ntp(5)=sje(1,1,5,iel)
        ntp(6)=sje(1,1,1,ntp(5))
        ntp(7)=sje(1,1,3,ntp(5))
        ntp(8)=sje(1,1,1,ntp(7))
!.......merge them to be the parent
        call merging(ntp)
      end do
!$OMP END PARALLEL DO
      nelt=nelt-num_coarsen*7
      icoarsen=icoarsen+num_coarsen*8

      return
      end

!-------------------------------------------------------
      subroutine do_refine(ifmortar,irefine)
!-------------------------------------------------------
!     Refinement procedure
!--------------------------------------------------------

      use ua_data
      implicit none

      logical ifmortar
      double precision xctemp(8), yctemp(8), zctemp(8), xleft, xright,  &
     &       yleft, yright, zleft, zright, ta1temp(lx1,lx1,lx1),  &
     &       xhalf, yhalf, zhalf
      integer iel, i, ii, jj, j, jface,  &
     &        ntemp, ndir, facedir, k, le(4), ne(4), mielnew,  &
     &        miel, irefine,ntemp1, num_refine, index, treetemp,  &
     &        sjetemp(2,2,6), n1, n2, nelttemp,  &
     &        cb, cbctemp(6)

!.....initialize

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(miel)
      do miel=1,nelt
        mt_to_id_old(miel)=mt_to_id(miel)
        mt_to_id(miel)=0
        action(miel)=0
        if(ich(mt_to_id_old(miel)).ne.4)then
          front(miel)=0
        else
          front(miel)=1
        end if
      end do
!$OMP END PARALLEL DO

!.....front(iel) records how many elements with sequence numbers less than
!     or equal to iel will be refined
      call parallel_add(front)

!.....num_refine is the total number of elements that will be refined
      num_refine=front(nelt)

!.....action(i) records the morton index of the  i'th element to be refined
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(miel,iel)
      do miel=1,nelt
        iel=mt_to_id_old(miel)
        if(ich(iel).eq.4)then
          action(front(miel))=miel
        end if
      end do
!$OMP END PARALLEL DO

!.....Compute array mt_to_id to convert the element index to morton index.
!     ref_front_id(iel) records how many elements with index less than
!     iel (actual element index, not morton index), will be refined.
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(miel,iel,ntemp,mielnew)
      do miel=1,nelt
        iel=mt_to_id_old(miel)
        if(ich(iel).eq.4)then
          ntemp=(front(miel)-1)*7
          mielnew=miel+ntemp
        else
          ntemp=front(miel)*7
          mielnew=miel+ntemp
        end if

        mt_to_id(mielnew)=iel
        ref_front_id(iel)=nelt+ntemp
      end do
!$OMP END PARALLEL DO


!.....Perform refinement (potentially in parallel): 
!       - Cut an element into eight children.
!       - Assign them element index  as iel, nelt+1,...., nelt+7.
!       - Update neighboring information.

      nelttemp=nelt

      if (num_refine .gt. 0) then
        ifmortar=.true.
      endif
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(index,miel,mielnew,iel,nelt,  &
!$OMP& treetemp,xctemp,yctemp,zctemp,cbctemp,sjetemp,ta1temp,  &
!$OMP& ii,jj,ntemp,xleft,xright,xhalf,yleft,yright,yhalf,zleft,zright,  &
!$OMP& zhalf,ndir,facedir,jface,cb,le,ne,n1,n2,i,j,k)
      do index=1, num_refine  
!.......miel is old morton index and mielnew is new morton index after refinement.
        miel=action(index)
        mielnew=miel+(front(miel)-1)*7
        iel=mt_to_id_old(miel) 
        nelt=nelttemp+(front(miel)-1)*7 
!.......save iel's information in a temporary array
        treetemp=tree(iel)
        do i=1,8
          xctemp(i)=xc(i,iel)
          yctemp(i)=yc(i,iel)
          zctemp(i)=zc(i,iel)
        end do
        do i=1,6
          cbctemp(i)=cbc(i,iel)
          do jj=1,2
            do ii=1,2
              sjetemp(ii,jj,i)=sje(ii,jj,i,iel)
            end do
          end do
        end do
        call copy(ta1temp,ta1(1,1,1,iel),nxyz)


!.......zero out iel here
        tree(iel)=0
        call nr_init(cbc(1,iel),6,0)
        call nr_init(sje(1,1,1,iel),24,0)
        call nr_init(ijel(1,1,iel),12,0)
        call r_init(ta1(1,1,1,iel),nxyz,0.d0)


!.......initialize new child elements:iel and nelt+1~nelt+7
        do j=1,7 
          mt_to_id(mielnew+j)=nelt+j
          tree(nelt+j)=0
          call nr_init(cbc(1,nelt+j),6,0)
          call nr_init(sje(1,1,1,nelt+j),24,0)
          call nr_init(ijel(1,1,nelt+j),12,0)
          call r_init(ta1(1,1,1,nelt+j),nxyz,0.d0)
        end do
          
!.......update the tree()
        ntemp=ishft(treetemp,3)
        tree(iel)=ntemp
        do i=1,7
          tree(nelt+i)=ntemp+mod(i,8)
        end do   
!.......update the children's vertices' coordinates
        xhalf=xctemp(1)+(xctemp(2)-xctemp(1))/2.d0
        xleft=xctemp(1)
        xright=xctemp(2)
        yhalf=yctemp(1)+(yctemp(3)-yctemp(1))/2.d0
        yleft=yctemp(1)
        yright=yctemp(3)
        zhalf=zctemp(1)+(zctemp(5)-zctemp(1))/2.d0
        zleft=zctemp(1)
        zright=zctemp(5)
       
        do j=1,7,2
          do i=1,7,2
            xc(i,nelt+j)     = xhalf
            xc(i+1,nelt+j)   = xright 
          end do
        end do

        do j=2,6,2
          do i=1,7,2
            xc(i,nelt+j)   = xleft
            xc(i+1,nelt+j) = xhalf
          end do
        end do
         
        do i=1,7,2
          xc(i,iel)=xleft
          xc(i+1,iel)=xhalf
        end do

        do i=1,2
          yc(i,nelt+1)=yleft
          yc(i,nelt+4)=yleft
          yc(i,nelt+5)=yleft
          yc(i+4,nelt+1)=yleft
          yc(i+4,nelt+4)=yleft
          yc(i+4,nelt+5)=yleft
        enddo
        do i=3,4
          yc(i,nelt+1)=yhalf
          yc(i,nelt+4)=yhalf
          yc(i,nelt+5)=yhalf
          yc(i+4,nelt+1)=yhalf
          yc(i+4,nelt+4)=yhalf
          yc(i+4,nelt+5)=yhalf
        end do
        do j=2,3
          do i=1,2
            yc(i,nelt+j)=yhalf
            yc(i,nelt+j+4)=yhalf
            yc(i+4,nelt+j)=yhalf
            yc(i+4,nelt+j+4)=yhalf
          end do
          do i=3,4
            yc(i,nelt+j)=yright
            yc(i,nelt+j+4)=yright
            yc(i+4,nelt+j)=yright
            yc(i+4,nelt+j+4)=yright
          end do
        end do
          
        do i=1,2
          yc(i,iel)=yleft
          yc(i+4,iel)=yleft
        end do
        do i=3,4
          yc(i,iel)=yhalf
          yc(i+4,iel)=yhalf
        end do

        do j=1,3
          do i=1,4
            zc(i,nelt+j)=zleft
            zc(i+4,nelt+j)=zhalf
          end do
        end do
        do j=4,7
          do i=1,4
            zc(i,nelt+j)=zhalf
            zc(i+4,nelt+j)=zright
          end do
        end do
        do i=1,4
          zc(i,iel)=zleft
          zc(i+4,iel)=zhalf
        end do

!.......update the children's neighbor information

!.......ndir refers to the x,y,z directions, respectively.
!       facedir refers to the orientation of the face in each direction, 
!       e.g. ndir=1, facedir=0 refers to face 1,
!       and ndir =1, facedir=1 refers to face 2.

        do ndir = 1, 3
          do facedir = 0, 1
            i=2*ndir-1+facedir
            jface=jjface(i)
            cb=cbctemp(i)

!...........find the new element indices of the four children on each
!           face of the parent element
            do k = 1, 4
              le(k) = le_arr(k,facedir,ndir)+nelt
              ne(k) = le_arr(k,1-facedir,ndir)+nelt
            end do
            if(facedir.eq.0)then
              le(1)=iel
            else
              ne(1)=iel
            end if
!...........update neighbor information of the four child elements on each 
!           face of the parent element
            do k=1,4
              cbc(i,le(k))=2
              sje(1,1,i,le(k))=ne(k)
              ijel(1,i,le(k))=1
              ijel(2,i,le(k))=1
            end do

!...........if the face type of the parent element is type 2
            if(cb.eq.2) then
              ntemp=sjetemp(1,1,i)

!.............if the neighbor ntemp is not marked to be refined
              if(ich(ntemp).ne.4)then
                cbc(jface,ntemp)=3
                ijel(1,jface,ntemp)=1
                ijel(2,jface,ntemp)=1
  
                do k=1,4
                  cbc(i,ne(k))=1
                  sje(1,1,i,ne(k))=ntemp
                  if(k.eq.1) then
                    ijel(1,i,ne(k))=1
                    ijel(2,i,ne(k))=1
                    sje(1,1,jface,ntemp)=ne(k)
                  elseif(k.eq.2) then
                    ijel(1,i,ne(k))=1
                    ijel(2,i,ne(k))=2
                    sje(1,2,jface,ntemp)=ne(k)
                  elseif(k.eq.3) then
                    ijel(1,i,ne(k))=2
                    ijel(2,i,ne(k))=1
                    sje(2,1,jface,ntemp)=ne(k)
                  elseif(k.eq.4) then
                    ijel(1,i,ne(k))=2
                    ijel(2,i,ne(k))=2
                    sje(2,2,jface,ntemp)=ne(k)
                  end if
                end do

!.............if the neighbor ntemp is also marked to be refined
              else
                n1=ref_front_id(ntemp)
                 
                do k=1,4
                  cbc(i,ne(k))=2
                  n2=n1+le_arr(k,facedir,ndir)
                  if(n2.eq.n1+8)n2=ntemp
                  sje(1,1,i,ne(k))=n2
                  ijel(1,i,ne(k))=1
                end do

              endif
!...........if the face type of the parent element is type 3
            elseif(cb.eq.3) then
              do k=1,4
                cbc(i,ne(k))=2
                if(k.eq.1) then
                  ntemp=sjetemp(1,1,i)
                elseif (k.eq.2) then
                  ntemp=sjetemp(1,2,i)
                elseif(k.eq.3) then
                  ntemp=sjetemp(2,1,i)
                elseif(k.eq.4) then
                  ntemp=sjetemp(2,2,i)
                end if
                ijel(1,i,ne(k))=1
                ijel(2,i,ne(k))=1
                sje(1,1,i,ne(k))=ntemp
                cbc(jface,ntemp)=2
                sje(1,1,jface,ntemp)=ne(k)
                ijel(1,jface,ntemp)=1
                ijel(2,jface,ntemp)=1
              end do

!...........if the face type of the parent element is type 0
            elseif(cb.eq.0) then
              do k=1,4
                cbc(i,ne(k))=cb
              end do
            end if

          end do 
        end do 

!.......map solution from parent element to children
        call remap(ta1(1,1,1,iel),ta1(1,1,1,ref_front_id(iel)+1),  &
     &             ta1temp(1,1,1))
      end do
!$OMP ENDPARALLEL DO

      nelt=nelttemp+num_refine*7
      irefine=irefine+num_refine
      ntot=nelt*lx1*lx1*lx1
      return
      end

!-----------------------------------------------------------
       logical function ifcor(n1,n2,i,iface)
!-----------------------------------------------------------
!      returns whether element n1's face i and element n2's 
!      jjface(iface) have intersections, i.e. whether n1 and 
!      n2 are neighbored by an edge.
!-----------------------------------------------------------

       use ua_data
       implicit none

       integer n1,n2,i,iface
       logical ifsame

       ifcor=.false.

       if(ifsame(n1,e1v1(iface,i),n2,e2v1(iface,i)).or.  &
     &    ifsame(n1,e1v2(iface,i),n2,e2v2(iface,i))) then
          ifcor=.true.
       end if

       return
       end

!-----------------------------------------------------------
      logical function icheck(ie,n)
!-----------------------------------------------------------
!     Check whether element ie's three faces (sharing vertex n)
!     are nonconforming. This will prevent it from being coarsened.
!     Also check ie's neighbors on those three faces, whether ie's
!     neighbors by only an edge have a size smaller than ie's,
!     which also prevents ie from being coarsened.
!-----------------------------------------------------------

      use ua_data
      implicit none

      integer ie, n, iside, ntemp1, ntemp2, ntemp3, n1, n2, n3,  &
     &cb2_1,cb3_1,cb1_2,cb3_2,cb1_3,cb2_3

      icheck=.true.
      cb2_1=0
      cb3_1=0
      cb1_2=0
      cb3_2=0
      cb1_3=0
      cb2_3=0

      n1=f_c(1,n)
      n2=f_c(2,n)
      n3=f_c(3,n)
      if((cbc(n1,ie).eq.3) .or. (cbc(n2,ie).eq.3) .or.  &
     &   (cbc(n3,ie).eq.3)) then
         icheck=.false.
      else
        ntemp1=sje(1,1,n1,ie)
        ntemp2=sje(1,1,n2,ie)
        ntemp3=sje(1,1,n3,ie)
        if(ntemp1.ne.0)then
           cb2_1=cbc(n2,ntemp1)
           cb3_1=cbc(n3,ntemp1)
        end if
        if(ntemp2.ne.0)then
           cb3_2=cbc(n3,ntemp2)
           cb1_2=cbc(n1,ntemp2)
        end if
        if(ntemp3.ne.0)then
           cb1_3=cbc(n1,ntemp3)
           cb2_3=cbc(n2,ntemp3)
        end if
        if((cbc(n1,ie).eq.2.and.(cb2_1.eq.3.or.  &
     &                               cb3_1.eq.3)).or.  &
     &     (cbc(n2,ie).eq.2.and.(cb3_2.eq.3.or.  &
     &                               cb1_2.eq.3)).or.  &
     &     (cbc(n3,ie).eq.2.and.(cb1_3.eq.3.or.  &
     &                              cb2_3.eq.3)))then
          icheck=.false.
        end if
      end if

      return
      end 

!-----------------------------------------------------------
      subroutine find_coarsen(if_coarsen,neltold)
!-----------------------------------------------------------
!     Search elements to be coarsened. Check with restrictions.
!     This subroutine only checks the element itself, not its
!     neighbors.
!-----------------------------------------------------------

      use ua_data
      implicit none

      logical if_coarsen, iftemp, iftouch
      integer iel,i,neltold

      if_coarsen=.false.

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(iel,i,iftemp)  &
!$OMP& SHARED(if_coarsen)
      do iel=1,neltold
        if(.not.skip(iel))then
          ich(iel)=0
          if(.not.iftouch(iel)) then
            iftemp=.false.
            do i=1,nsides
!.............if iel has a larger size than its face neighbors, it
!             can not be coarsened
              if(cbc(i,iel).eq.3) then
                iftemp=.true.
              endif
            enddo
            if(.not.iftemp) then
              if(.not.if_coarsen) if_coarsen=.true.
              ich(iel)=2
            end if
          end if
        endif
      enddo
!$OMP END PARALLEL DO

      return
      end

!-----------------------------------------------------------
      subroutine find_refine(if_refine)
!-----------------------------------------------------------
!     search elements to be refined based on whether they
!     have overlap with the heat source
!-----------------------------------------------------------

      use ua_data
      implicit none

      logical if_refine, iftouch
      integer iel

      if_refine=.false.

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(iel)  &
!$OMP& SHARED(if_refine)
      do iel=1,nelt
        ich(iel)=0
        if(iftouch(iel)) then
          if((xc(2,iel)-xc(1,iel)).gt.dlmin) then
            if(.not.if_refine) if_refine=.true.
            ich(iel)=4
          end if
        end if
      enddo
!$OMP END PARALLEL DO

      return
      end

!-----------------------------------------------------------------
      subroutine check_refine(ifrepeat)
!-----------------------------------------------------------------
!     Check whether the potential refinement will violate the
!     restriction. If so, mark the neighbor and unmark the
!     original element, and set ifrepeat true. i.e. this procedure
!     needs to be repeated until no further check is needed
!-----------------------------------------------------------------

      use ua_data
      implicit none
 
      logical ifrepeat,ifcor
      integer iel,iface,ntemp,nntemp,i,jface

      ifrepeat=.false.

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(iel,i,jface,ntemp,  &
!$OMP& iface,nntemp) SHARED(ifrepeat)
      do iel=1,nelt
!.......if iel is marked to be refined
        if(ich(iel).eq.4) then
!.........check its six faces
          do i=1,nsides
            jface=jjface(i)
            ntemp=sje(1,1,i,iel)
!...........if one face neighbor is larger in size than iel
            if(cbc(i,iel).eq.1) then
!.............unmark iel
              ich(iel)=0
!.............the large size neighbor ntemp is marked to be refined
              if(ich(ntemp).ne.4) then
                if(.not.ifrepeat) ifrepeat=.true.
                ich(ntemp)=4
              end if
!.............check iel's neighbor, neighbored by an edge on face i, which
!             must be a face neighbor of ntemp
              do iface=1,nsides
                if(iface.ne.i.and.iface.ne.jface) then
!................if edge neighbors are larger than iel, mark them to be refined
                  if(cbc(iface,ntemp).eq.2) then
                    nntemp=sje(1,1,iface,ntemp)
!..................ifcor is to make sure the edge neighbor exist
                    if(ich(nntemp).ne.4.and.  &
     &                 ifcor(iel,nntemp,i,iface))then
                      ich(nntemp)=4
                    end if
                  end if
                end if
              end do
!...........if face neighbor are of the same size of iel, check edge neighbors
            elseif(cbc(i,iel).eq.2)then
              do iface=1,nsides
                if(iface.ne.i.and.iface.ne.jface) then
                  if(cbc(iface,ntemp).eq.1)then
                    nntemp=sje(1,1,iface,ntemp)
                    ich(nntemp)=4
                    ich(iel)=0
                    if(.not.ifrepeat) ifrepeat=.true.
                  end if
                end if
              end do
            end if
          enddo
        end if
      end do
!$OMP END PARALLEL DO

      return
      end

!-----------------------------------------------------------------
      logical function iftouch(iel)
!-----------------------------------------------------------------
!     check whether element iel has overlap with the heat source
!-----------------------------------------------------------------

      use ua_data
      implicit none

      double precision dis, dis1, dis2, dis3, alpha2
      integer iel

      alpha2 = alpha*alpha

      if     (x0 .lt. xc(1,iel)) then
        dis1 = xc(1,iel) - x0
      elseif (x0 .gt. xc(2,iel)) then
        dis1 = x0 - xc(2,iel)
      else
        dis1 = 0.d0
      endif

      if     (y0 .lt. yc(1,iel)) then
        dis2 = yc(1,iel) - y0
      elseif (y0 .gt. yc(3,iel)) then
        dis2 = y0 - yc(3,iel)
      else
        dis2 = 0.d0
      endif

      if     (z0 .lt. zc(1,iel)) then
        dis3 = zc(1,iel) - z0
      elseif (z0 .gt. zc(5,iel)) then
        dis3 = z0 - zc(5,iel)
      else
       dis3 = 0.d0
      endif

      dis = dis1**2+dis2**2+dis3**2

      if (dis .lt. alpha2) then
       iftouch=.true.
      else
       iftouch=.false.
      end if

      return
      end


!-----------------------------------------------------------------
      subroutine remap (y,y1,x) 
!-----------------------------------------------------------------
!     After a refinement, map the solution  from the parent (x) to
!     the eight children. y is the solution on the first child
!     (front-bottom-left) and y1 is the solution on the next 7 
!     children.
!-----------------------------------------------------------------

      use ua_data
      implicit none

      double precision x(lx1,lx1,lx1),y(lx1,lx1,lx1),y1(lx1,lx1,lx1,7),  &
     &       yone(lx1,lx1,lx1,2), ytwo(lx1,lx1,lx1,4)
      integer i, iz, ii, jj, kk

      call r_init(y,lx1*lx1*lx1,0.d0)
      call r_init(y1,lx1*lx1*lx1*7,0.d0)
      call r_init(yone,lx1*lx1*lx1*2,0.d0)
      call r_init(ytwo,lx1*lx1*lx1*4,0.d0)

      do  i=1,lx1
        do kk = 1, lx1
          do jj = 1, lx1
            do ii = 1, lx1
              yone(ii,jj,i,1) = yone(ii,jj,i,1) +ixmc1(ii,kk)*x(kk,jj,i)
              yone(ii,jj,i,2) = yone(ii,jj,i,2) +ixmc2(ii,kk)*x(kk,jj,i)
            end do
          end do
        end do

        do kk = 1, lx1
          do jj = 1, lx1
            do ii = 1, lx1
              ytwo(ii,i,jj,1) = ytwo(ii,i,jj,1) +  &
     &                          yone(ii,kk,i,1)*ixtmc1(kk,jj)
              ytwo(ii,i,jj,2) = ytwo(ii,i,jj,2) +  &
     &                          yone(ii,kk,i,1)*ixtmc2(kk,jj)
              ytwo(ii,i,jj,3) = ytwo(ii,i,jj,3) +  &
     &                          yone(ii,kk,i,2)*ixtmc1(kk,jj)
              ytwo(ii,i,jj,4) = ytwo(ii,i,jj,4) +  &
     &                          yone(ii,kk,i,2)*ixtmc2(kk,jj)
            end do
          end do
        end do
      end do

      do  iz=1,lx1
        do kk = 1, lx1
          do jj = 1, lx1
            do ii = 1, lx1
              y(ii,iz,jj) = y(ii,iz,jj) +  &
     &                        ytwo(ii,kk,iz,1)*ixtmc1(kk,jj)
              y1(ii,iz,jj,1) = y1(ii,iz,jj,1) +  &
     &                        ytwo(ii,kk,iz,3)*ixtmc1(kk,jj)
              y1(ii,iz,jj,2) = y1(ii,iz,jj,2) +  &
     &                        ytwo(ii,kk,iz,2)*ixtmc1(kk,jj)
              y1(ii,iz,jj,3) = y1(ii,iz,jj,3) +  &
     &                        ytwo(ii,kk,iz,4)*ixtmc1(kk,jj)
              y1(ii,iz,jj,4) = y1(ii,iz,jj,4) +  &
     &                        ytwo(ii,kk,iz,1)*ixtmc2(kk,jj)
              y1(ii,iz,jj,5) = y1(ii,iz,jj,5) +  &
     &                        ytwo(ii,kk,iz,3)*ixtmc2(kk,jj)
              y1(ii,iz,jj,6) = y1(ii,iz,jj,6) +  &
     &                        ytwo(ii,kk,iz,2)*ixtmc2(kk,jj)
              y1(ii,iz,jj,7) = y1(ii,iz,jj,7) +  &
     &                        ytwo(ii,kk,iz,4)*ixtmc2(kk,jj)            
            end do
          end do
        end do
      end do

      return
      end


!=======================================================================
      subroutine merging(iela)
!-----------------------------------------------------------------------
!     This subroutine is to merge the eight child elements and map 
!     the solution from eight children to the  merged element. 
!     iela array records the eight elements to be merged.
!-----------------------------------------------------------------------

      use ua_data
      implicit none

      double precision x1,x2,y1,y2,z1,z2
      integer ielnew,i,ntemp,jface,ii,cb,ntempa(4),iela(8),ielold,  &
     &        ntema(4)

      ielnew=iela(1)

      tree(ielnew)=ishft(tree(ielnew),-3)   

!.....element vertices 
      x1=xc(1,iela(1))
      x2=xc(2,iela(2))
      y1=yc(1,iela(1))
      y2=yc(3,iela(3))
      z1=zc(1,iela(1))
      z2=zc(5,iela(5))

      do i=1,7,2
        xc(i,ielnew)=x1
      end do
      do i=2,8,2
        xc(i,ielnew)=x2
      end do
      do i=1,2
        yc(i,ielnew)=y1
        yc(i+4,ielnew)=y1
      end do
      do i=3,4
        yc(i,ielnew)=y2
        yc(i+4,ielnew)=y2
      end do
      do i=1,4
        zc(i,ielnew)=z1
      end do
      do i=5,8
        zc(i,ielnew)=z2
      end do

!.....update neighboring information
      do i=1,nsides
        jface=jjface(i)
        ielold=iela(children(1,i))
        do ii=1,4
          ntempa(ii)=iela(children(ii,i))
        end do

        cb=cbc(i,ielold)
       
        if (cb.eq.2) then
!.........if the neighbor elements also will be coarsened
          if(ifcoa_id(sje(1,1,i,ielold)))then
            if (i.eq.2 .or. i.eq. 4 .or. i.eq.6) then
              ntemp=sje(1,1,i,sje(1,1,i,ntempa(1)))
            else
              ntemp=sje(1,1,i,ntempa(1))
            end if 
            sje(1,1,i,ielnew)=ntemp
            ijel(1,i,ielnew)=1
            ijel(2,i,ielnew)=1
            cbc(i,ielnew)=2

!.........if the neighbor elements will not be coarsened
          else
            do ii=1,4
              ntema(ii)=sje(1,1,i,ntempa(ii)) 
              cbc(jface,ntema(ii))=1
              sje(1,1,jface,ntema(ii))=ielnew
              ijel(1,jface,ntema(ii))=iijj(1,ii)
              ijel(2,jface,ntema(ii))=iijj(2,ii)
              sje(iijj(1,ii),iijj(2,ii),i,ielnew)=ntema(ii)
              ijel(1,i,ielnew)=1
              ijel(2,i,ielnew)=1
            end do
            cbc(i,ielnew)=3
          end if       

        else if(cb.eq.1)then

          ntemp=sje(1,1,i,ielold)
          cbc(jface,ntemp)=2
          ijel(1,jface,ntemp)=1
          ijel(2,jface,ntemp)=1
          sje(1,1,jface,ntemp)=ielnew
          sje(1,2,jface,ntemp)=0
          sje(2,1,jface,ntemp)=0
          sje(2,2,jface,ntemp)=0
           
          cbc(i,ielnew)=2
          ijel(1,i,ielnew)=1
          ijel(2,i,ielnew)=1
          sje(1,1,i,ielnew)=ntemp
         
        else if(cb.eq.0)then
          cbc(i,ielnew)=0
          sje(1,1,i,ielnew)=0
          sje(1,2,i,ielnew)=0
          sje(2,1,i,ielnew)=0
          sje(2,2,i,ielnew)=0
        endif

      end do

!.....map solution from children to the merged element
      call remap2(iela, ielnew)
      
      return
      end

!-----------------------------------------------------------------
      subroutine remap2(iela, ielnew)
!-----------------------------------------------------------------
!     Map the solution from the children to the parent.
!     iela array records the eight elements to be merged.
!     ielnew is the element index of the merged element.
!-----------------------------------------------------------------

      use ua_data
      implicit none

      integer iela(8), ielnew

      double precision temp1(lx1,lx1,lx1),  &
     &       temp2(lx1,lx1,lx1),temp3(lx1,lx1,lx1),temp4(lx1,lx1,lx1),  &
     &       temp5(lx1,lx1,lx1),temp6(lx1,lx1,lx1)

      call remapx(ta1(1,1,1,iela(1)),ta1(1,1,1,iela(2)),temp1)
      call remapx(ta1(1,1,1,iela(3)),ta1(1,1,1,iela(4)),temp2)
      call remapx(ta1(1,1,1,iela(5)),ta1(1,1,1,iela(6)),temp3)
      call remapx(ta1(1,1,1,iela(7)),ta1(1,1,1,iela(8)),temp4)
      call remapy(temp1,temp2,temp5)
      call remapy(temp3,temp4,temp6)
      call remapz(temp5,temp6,ta1(1,1,1,ielnew))

      return
      end       

!-----------------------------------------------------------------
      subroutine remapz(x1,x2,y)
!-----------------------------------------------------------------
!     z direction mapping after the merge.
!     Map solution from x1 & x2 to y.
!-----------------------------------------------------------------

      use ua_data
      implicit none

      double precision x1(lx1,lx1,lx1),x2(lx1,lx1,lx1),y(lx1,lx1,lx1)
      integer ix, iy, ip

      do iy=1,lx1
        do ix=1,lx1
          y(ix,iy,1)=x1(ix,iy,1)

          y(ix,iy,2)=0.d0
          do ip=1,lx1
            y(ix,iy,2)=y(ix,iy,2)+map2(ip)*x1(ix,iy,ip)
          end do

          y(ix,iy,3)=x1(ix,iy,lx1)

          y(ix,iy,4)=0.d0
          do ip=1,lx1
            y(ix,iy,4)=y(ix,iy,4)+map4(ip)*x2(ix,iy,ip)
          end do

          y(ix,iy,lx1)=x2(ix,iy,lx1)
        end do
      end do

      return
      end      

!-----------------------------------------------------------------
      subroutine remapy(x1,x2,y)
!-----------------------------------------------------------------
!     y direction mapping after the merge.
!     Map solution from x1 & x2 to y.
!-----------------------------------------------------------------

      use ua_data
      implicit none

      double precision x1(lx1,lx1,lx1),x2(lx1,lx1,lx1),y(lx1,lx1,lx1)
      integer ix, iz, ip

      do iz=1,lx1
        do ix=1,lx1
          y(ix,1,iz)=x1(ix,1,iz)

          y(ix,2,iz)=0.d0
          do ip=1,lx1
            y(ix,2,iz)=y(ix,2,iz)+map2(ip)*x1(ix,ip,iz)
          end do

          y(ix,3,iz)=x1(ix,lx1,iz)

          y(ix,4,iz)=0.d0
          do ip=1,lx1
            y(ix,4,iz)=y(ix,4,iz)+map4(ip)*x2(ix,ip,iz)
          end do

          y(ix,lx1,iz)=x2(ix,lx1,iz)
        end do
      end do

      return
      end      

!-----------------------------------------------------------------
      subroutine remapx(x1,x2,y)
!-----------------------------------------------------------------
!     x direction mapping after the merge.
!     Map solution from x1 & x2 to y.
!-----------------------------------------------------------------

      use ua_data
      implicit none

      double precision x1(lx1,lx1,lx1),x2(lx1,lx1,lx1),y(lx1,lx1,lx1)
      integer iy, iz, ip

      do iz=1,lx1
        do iy=1,lx1
          y(1,iy,iz)=x1(1,iy,iz)

          y(2,iy,iz)=0.d0
          do ip=1,lx1
            y(2,iy,iz)=y(2,iy,iz)+map2(ip)*x1(ip,iy,iz)
          end do

          y(3,iy,iz)=x1(lx1,iy,iz)

          y(4,iy,iz)=0.d0
          do ip=1,lx1
            y(4,iy,iz)=y(4,iy,iz)+map4(ip)*x2(ip,iy,iz)
          end do

          y(lx1,iy,iz)=x2(lx1,iy,iz)
        end do
      end do

      return
      end      
       

!---------------------------------------------------------
      subroutine convect(ifmortar)  
!---------------------------------------------------------
!     Advance the convection term using 4th order RK
!     1.ta1 is solution from last time step 
!     2.the heat source is considered part of d/dx
!     3.trhs is right hand side for the diffusion equation
!     4.tmor is solution on mortar points, which will be used
!       as the initial guess when advancing the diffusion term 
!---------------------------------------------------------

      use ua_data
      implicit none

      double precision alpha2, tempa(lx1,lx1,lx1),  &
     &       rdtime, pidivalpha, sixth,  &
     &       dtx1, dtx2, dtx3, src, rk1(lx1,lx1,lx1), rk2(lx1,lx1,lx1),  &
     &       rk3(lx1,lx1,lx1), rk4(lx1,lx1,lx1), temp(lx1,lx1,lx1),  &
     &       subtime(3), xx0(3), yy0(3), zz0(3), dtime2, r2, sum,  &
     &       xloc(lx1), yloc(lx1), zloc(lx1)
      integer k,iel,i,j,iside,isize, substep, ip
      logical ifmortar
      parameter (sixth=1.d0/6.d0)

      if (timeron) call timer_start(t_convect)
      pidivalpha = dacos(-1.d0)/alpha
      alpha2     = alpha*alpha
      dtime2     = dtime/2.d0 
      rdtime     = 1.d0/dtime
      subtime(1) = time
      subtime(2) = time+dtime2
      subtime(3) = time+dtime
      do substep = 1, 3
        xx0(substep) = x00+velx*subtime(substep)
        yy0(substep) = y00+vely*subtime(substep)
        zz0(substep) = z00+velz*subtime(substep)
      end do

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(rk4,rk3,rk2,temp,rk1,dtx3,  &
!$OMP& dtx2,dtx1,iside,ip,sum,src,r2,i,j,k,isize,iel,tempa,  &
!$OMP& xloc,yloc,zloc)

      do iel = 1, nelt
        isize=size_e(iel)
!.......xloc(i) is the location of i'th collocation in x direction in an element.
!       yloc(i) is the location of j'th collocation in y direction in an element.
!       zloc(i) is the location of k'th collocation in z direction in an element.
        do i = 1, lx1
          xloc(i) = xfrac(i)*(xc(2,iel)-xc(1,iel))+xc(1,iel)
        end do
        do j = 1, lx1
          yloc(j) = xfrac(j)*(yc(4,iel)-yc(1,iel))+yc(1,iel)
        end do
        do k = 1, lx1
          zloc(k) = xfrac(k)*(zc(5,iel)-zc(1,iel))+zc(1,iel)
        end do

        do k = 1, lx1
          do j = 1, lx1
            do i = 1, lx1
              r2 = (xloc(i)-xx0(1))**2+(yloc(j)-yy0(1))**2+  &
     &             (zloc(k)-zz0(1))**2
              if (r2.le.alpha2) then
                src = dcos(dsqrt(r2)*pidivalpha)+1.d0
              else
                src = 0.d0
              endif
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(i,ip) * ta1(ip,j,k,iel)
              end do
              dtx1 = -velx*sum*xrm1_s(i,j,k,isize)
              sum  = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(j,ip) * ta1(i,ip,k,iel)
              end do
              dtx2=-vely*sum*xrm1_s(i,j,k,isize)
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(k,ip) * ta1(i,j,ip,iel)
              end do
              dtx3=-velz*sum*xrm1_s(i,j,k,isize)

              rk1(i,j,k)= dtx1 + dtx2 + dtx3 + src
              temp(i,j,k)=ta1(i,j,k,iel)+dtime2*rk1(i,j,k)

            end do
          end do
        end do        

        do k = 1, lx1
          do j = 1, lx1
            do i = 1, lx1
              r2 = (xloc(i)-xx0(2))**2 + (yloc(j)-yy0(2))**2 +  &
     &             (zloc(k)-zz0(2))**2
              if (r2.le.alpha2) then
                src = dcos(dsqrt(r2)*pidivalpha)+1.d0
              else
                src = 0.d0
              endif
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(i,ip) * temp(ip,j,k)
              end do
              dtx1 =-velx*sum*xrm1_s(i,j,k,isize)
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(j,ip) * temp(i,ip,k)
              end do
              dtx2 =-vely*sum*xrm1_s(i,j,k,isize)
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(k,ip) * temp(i,j,ip)
              end do
              dtx3 =-velz*sum*xrm1_s(i,j,k,isize)

              rk2(i,j,k)= dtx1 + dtx2 + dtx3 + src
              tempa(i,j,k)=ta1(i,j,k,iel)+dtime2*rk2(i,j,k)
            end do
          end do
        end do        

        do k = 1, lx1
          do j = 1, lx1
            do i = 1, lx1
              r2 = (xloc(i)-xx0(2))**2 + (yloc(j)-yy0(2))**2 +  &
     &             (zloc(k)-zz0(2))**2
              if (r2.le.alpha2) then
                src = dcos(dsqrt(r2)*pidivalpha)+1.d0
              else
                src = 0.d0
              endif
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(i,ip) * tempa(ip,j,k)
              end do
              dtx1 =-velx*sum*xrm1_s(i,j,k,isize)
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(j,ip) * tempa(i,ip,k)
              end do
              dtx2 =-vely*sum*xrm1_s(i,j,k,isize)
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(k,ip) * tempa(i,j,ip)
              end do
              dtx3 =-velz*sum*xrm1_s(i,j,k,isize)

              rk3(i,j,k)= dtx1 + dtx2 + dtx3 + src
              temp(i,j,k)=ta1(i,j,k,iel)+dtime*rk3(i,j,k)
            end do
          end do
        end do        

        do k = 1, lx1
          do j = 1, lx1
            do i = 1, lx1
              r2 = (xloc(i)-xx0(3))**2 + (yloc(j)-yy0(3))**2 +  &
     &             (zloc(k)-zz0(3))**2
              if (r2.le.alpha2) then
                src = dcos(dsqrt(r2)*pidivalpha)+1.d0
              else
                src = 0.d0
              endif
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(i,ip) * temp(ip,j,k)
              end do
              dtx1 =-velx*sum*xrm1_s(i,j,k,isize)
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(j,ip) * temp(i,ip,k)
              end do
              dtx2 =-vely*sum*xrm1_s(i,j,k,isize)
              sum = 0.d0
              do ip = 1, lx1
                sum = sum + dxm1(k,ip) * temp(i,j,ip)
              end do
              dtx3 =-velz*sum*xrm1_s(i,j,k,isize)

              rk4(i,j,k)= dtx1 + dtx2 + dtx3 + src
              tempa(i,j,k)=sixth*(rk1(i,j,k)+2.d0*  &
     &                   rk2(i,j,k)+2.d0*rk3(i,j,k)+rk4(i,j,k))
            end do
          end do
        end do        

!.......apply boundary condition
        do iside=1,nsides
          if(cbc(iside,iel).eq.0)then
            call facev(tempa,iside,0.0d0)
          end if
        end do
          
        do k=1,lx1
          do j=1,lx1
            do i=1,lx1
              trhs(i,j,k,iel)=bm1_s(i,j,k,isize)*(ta1(i,j,k,iel)*rdtime+  &
     &                        tempa(i,j,k))
              ta1(i,j,k,iel)=ta1(i,j,k,iel)+tempa(i,j,k)*dtime
            end do
          end do
        end do

      end do 
!$OMP END PARALLEL DO

!.....get mortar for intial guess for CG

      if (timeron) call timer_start(t_transfb_c)
      if(ifmortar)then
        call transfb_c_2(ta1)
      else
        call transfb_c(ta1)
      end if
      if (timeron) call timer_stop(t_transfb_c)

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
      do i=1,nmor
       tmort(i)=tmort(i)/mormult(i)
      end do
!$OMP END PARALLEL DO
      if (timeron) call timer_stop(t_convect)

      return
      end

!-------------------------------------------------------------------------!
!                                                                         !
!        N  A  S     P A R A L L E L     B E N C H M A R K S  3.4         !
!                                                                         !
!                       O p e n M P     V E R S I O N                     !
!                                                                         !
!                                   E P                                   !
!                                                                         !
!-------------------------------------------------------------------------!
!                                                                         !
!    This benchmark is an OpenMP version of the NPB EP code.              !
!    It is described in NAS Technical Report 99-011.                      !
!                                                                         !
!    Permission to use, copy, distribute and modify this software         !
!    for any purpose with or without fee is hereby granted.  We           !
!    request, however, that all derived work reference the NAS            !
!    Parallel Benchmarks 3.4. This software is provided "as is"           !
!    without express or implied warranty.                                 !
!                                                                         !
!    Information on NPB 3.4, including the technical report, the          !
!    original specifications, source code, results and information        !
!    on how to submit new results, is available at:                       !
!                                                                         !
!           http://www.nas.nasa.gov/Software/NPB/                         !
!                                                                         !
!    Send comments or suggestions to  npb@nas.nasa.gov                    !
!                                                                         !
!          NAS Parallel Benchmarks Group                                  !
!          NASA Ames Research Center                                      !
!          Mail Stop: T27A-1                                              !
!          Moffett Field, CA   94035-1000                                 !
!                                                                         !
!          E-mail:  npb@nas.nasa.gov                                      !
!          Fax:     (650) 604-3957                                        !
!                                                                         !
!-------------------------------------------------------------------------!


!---------------------------------------------------------------------
!
! Author: P. O. Frederickson 
!         D. H. Bailey
!         A. C. Woo
!         H. Jin
!---------------------------------------------------------------------

!---------------------------------------------------------------------
      program EMBAR
!---------------------------------------------------------------------

!   This is the OpenMP version of the APP Benchmark 1,
!   the "embarassingly parallel" benchmark.

      use, intrinsic :: ieee_arithmetic, only : ieee_is_nan

      use ep_data

      implicit none

      double precision Mops, t1, t2, t3, t4, x1, x2,  &
     &                 sx, sy, tm, an, tt, gc, dum(3)
      double precision sx_verify_value, sy_verify_value, sx_err, sy_err

      integer          i, ik, kk, l, k, nit,  &
     &                 np, k_offset, j

      logical          verified, timers_enabled

      external         randlc, timer_read
      double precision randlc, timer_read

      character*15     size

      double precision epsilon
      parameter       (epsilon=1.d-8)

!$    integer  omp_get_max_threads
!$    external omp_get_max_threads

      data             dum /1.d0, 1.d0, 1.d0/


      call check_timer_flag( timers_enabled )

!   Because the size of the problem is too large to store in a 32-bit
!   integer for some classes, we put it into a string (for printing).
!   Have to strip off the decimal point put in there by the floating
!   point print statement (internal file)

      write(*, 1000)
      write(size, '(f15.0)' ) 2.d0**(m+1)
      j = 15
      if (size(j:j) .eq. '.') j = j - 1
      write (*,1001) size(1:j)
!$    write (*,1003) omp_get_max_threads()
      write (*,*)

 1000 format(//,' NAS Parallel Benchmarks (NPB3.4-OMP)',  &
     &          ' - EP Benchmark', /)
 1001 format(' Number of random numbers generated: ', a15)
 1003 format(' Number of available threads:        ', 2x,i13)

      verified = .false.

!   Compute the number of "batches" of random number pairs generated 
!   per processor. Adjust if the number of processors does not evenly 
!   divide the total number

      np = nn 


!   Call the random number generator functions and initialize
!   the x-array to reduce the effects of paging on the timings.
!   Also, call all mathematical functions that are used. Make
!   sure these initializations cannot be eliminated as dead code.

      call vranlc(0, dum(1), dum(2), dum(3))
      dum(1) = randlc(dum(2), dum(3))
      Mops = log(sqrt(abs(max(1.d0,1.d0))))

!$omp parallel default(shared) private(i)
      do 5    i = 1, 2*nk
         x(i) = -1.d99
 5    continue

      call timer_clear(1)
      if (timers_enabled) call timer_clear(2)
      if (timers_enabled) call timer_clear(3)
!$omp end parallel

      call timer_start(1)

      t1 = a
      call vranlc(0, t1, a, x)

!   Compute AN = A ^ (2 * NK) (mod 2^46).

      t1 = a

      do 100 i = 1, mk + 1
         t2 = randlc(t1, t1)
 100  continue

      an = t1
      tt = s
      gc = 0.d0
      sx = 0.d0
      sy = 0.d0

      do 110 i = 0, nq - 1
         q(i) = 0.d0
 110  continue

!   Each instance of this loop may be performed independently. We compute
!   the k offsets separately to take into account the fact that some nodes
!   have more numbers to generate than others

      k_offset = -1

!$omp parallel default(shared) reduction(+:sx,sy)  &
!$omp&  private(k,kk,t1,t2,t3,t4,i,ik,x1,x2,l)
      do 115 i = 0, nq - 1
         qq(i) = 0.d0
 115  continue

!$omp do schedule(static)
      do 150 k = 1, np
         kk = k_offset + k 
         t1 = s
         t2 = an

!        Find starting seed t1 for this kk.

         if (timers_enabled) call timer_start(3)
         do 120 i = 1, 100
            ik = kk / 2
            if (2 * ik .ne. kk) t3 = randlc(t1, t2)
            if (ik .eq. 0) goto 130
            t3 = randlc(t2, t2)
            kk = ik
 120     continue

!        Compute uniform pseudorandom numbers.
 130     continue

         call vranlc(2 * nk, t1, a, x)
         if (timers_enabled) call timer_stop(3)

!        Compute Gaussian deviates by acceptance-rejection method and 
!        tally counts in concentric square annuli.  This loop is not 
!        vectorizable. 

         if (timers_enabled) call timer_start(2)

         do 140 i = 1, nk
            x1 = 2.d0 * x(2*i-1) - 1.d0
            x2 = 2.d0 * x(2*i) - 1.d0
            t1 = x1 ** 2 + x2 ** 2
            if (t1 .le. 1.d0) then
               t2   = sqrt(-2.d0 * log(t1) / t1)
               t3   = (x1 * t2)
               t4   = (x2 * t2)
               l    = max(abs(t3), abs(t4))
               qq(l) = qq(l) + 1.d0
               sx   = sx + t3
               sy   = sy + t4
            endif
 140     continue

         if (timers_enabled) call timer_stop(2)

 150  continue
!$omp end do nowait

      do 155 i = 0, nq - 1
!$omp atomic
         q(i) = q(i) + qq(i)
 155  continue
!$omp end parallel

      do 160 i = 0, nq - 1
         gc = gc + q(i)
 160  continue

      call timer_stop(1)
      tm  = timer_read(1)

      nit=0
      verified = .true.
      if (m.eq.24) then
         sx_verify_value = -3.247834652034740D+3
         sy_verify_value = -6.958407078382297D+3
      elseif (m.eq.25) then
         sx_verify_value = -2.863319731645753D+3
         sy_verify_value = -6.320053679109499D+3
      elseif (m.eq.28) then
         sx_verify_value = -4.295875165629892D+3
         sy_verify_value = -1.580732573678431D+4
      elseif (m.eq.30) then
         sx_verify_value =  4.033815542441498D+4
         sy_verify_value = -2.660669192809235D+4
      elseif (m.eq.32) then
         sx_verify_value =  4.764367927995374D+4
         sy_verify_value = -8.084072988043731D+4
      elseif (m.eq.36) then
         sx_verify_value =  1.982481200946593D+5
         sy_verify_value = -1.020596636361769D+5
      elseif (m.eq.40) then
         sx_verify_value = -5.319717441530D+05
         sy_verify_value = -3.688834557731D+05
      elseif (m.eq.44) then
         sx_verify_value = -1.986768071074039D+1
         sy_verify_value = -2.164441190520301D+1
      else
         verified = .false.
      endif
      if (verified) then
         sx_err = abs((sx - sx_verify_value)/sx_verify_value)
         sy_err = abs((sy - sy_verify_value)/sy_verify_value)
         if (ieee_is_nan(sx_err) .or. ieee_is_nan(sy_err)) then
            verified = .false.
         else
            verified = ((sx_err.le.epsilon) .and. (sy_err.le.epsilon))
         endif
      endif
      Mops = 2.d0**(m+1)/tm/1000000.d0

      write (6,11) tm, m, gc, sx, sy, (i, q(i), i = 0, nq - 1)
 11   format ('EP Benchmark Results:'//'CPU Time =',f10.4/'N = 2^',  &
     &        i5/'No. Gaussian Pairs =',f15.0/'Sums = ',1p,2d25.15/  &
     &        'Counts:'/(i3,0p,f15.0))

      call print_results('EP', class, m+1, 0, 0, nit,  &
     &                   tm, Mops,  &
     &                   'Random numbers generated',  &
     &                   verified, npbversion, compiletime, cs1,  &
     &                   cs2, cs3, cs4, cs5, cs6, cs7)


      if (timers_enabled) then
         if (tm .le. 0.d0) tm = 1.0
         tt = timer_read(1)
         print 810, 'Total time:    ', tt, tt*100./tm
         tt = timer_read(2)
         print 810, 'Gaussian pairs:', tt, tt*100./tm
         tt = timer_read(3)
         print 810, 'Random numbers:', tt, tt*100./tm
810      format(1x,a,f9.3,' (',f6.2,'%)')
      endif


      end

!------------------------------------------------------------------
      subroutine init_locks
!------------------------------------------------------------------
!     This version uses ATOMIC for atomic updates, 
!     but locks are still used in get_emo (mason.f).
!------------------------------------------------------------------

      use ua_data
      implicit none

      integer i

!.....initialize locks in parallel
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
!$    do i=1,8*lelt
!$      call omp_init_lock(tlock(i))
!$    end do

      return
      end


!------------------------------------------------------------------
      subroutine transf(tmor,tx)
!------------------------------------------------------------------
!     Map values from mortar(tmor) to element(tx)
!------------------------------------------------------------------

      use ua_data
      implicit none

      double precision tmor(*),tx(*), tmp(lx1,lx1,2)
      integer ig1,ig2,ig3,ig4,ie,iface,il1,il2,il3,il4,  &
     &        nnje,ije1,ije2,col,i,j,ig,il


!.....zero out tx on element boundaries
      call col2(tx,tmult,ntot)     

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(il,j,ig,i,col,ije2,ije1,ig4,  &
!$OMP& ig3,ig2,ig1,nnje,il4,il3,il2,il1,iface,ie,tmp)
      do ie=1,nelt
        do iface=1,nsides

!.........get the collocation point index of the four local corners on the
!         face iface of element ie
          il1=idel(1,1,iface,ie)
          il2=idel(lx1,1,iface,ie)
          il3=idel(1,lx1,iface,ie)
          il4=idel(lx1,lx1,iface,ie)

!.........get the mortar indices of the four local corners
          ig1= idmo(1,  1  ,1,1,iface,ie)
          ig2= idmo(lx1,1  ,1,2,iface,ie)
          ig3= idmo(1,  lx1,2,1,iface,ie)
          ig4= idmo(lx1,lx1,2,2,iface,ie)
  
!.........copy the value from tmor to tx for these four local corners
          tx(il1) = tmor(ig1)
          tx(il2) = tmor(ig2)
          tx(il3) = tmor(ig3)
          tx(il4) = tmor(ig4)
 
!.........nnje=1 for conforming faces, nnje=2 for nonconforming faces
          if(cbc(iface,ie).eq.3) then
            nnje=2
          else
            nnje=1 
          end if

!.........for nonconforming faces
          if(nnje.eq.2) then

!...........nonconforming faces have four pieces of mortar, first map them to
!           two intermediate mortars, stored in tmp
            call r_init(tmp,lx1*lx1*2,0.d0)
   
            do ije1=1,nnje
              do ije2=1,nnje
                do col=1,lx1

!.................in each row col, when coloumn i=1 or lx1, the value
!                 in tmor is copied to tmp
                  i = v_end(ije2)
                  ig=idmo(i,col,ije1,ije2,iface,ie)
                  tmp(i,col,ije1)=tmor(ig)

!.................in each row col, value in the interior three collocation
!                 points is computed by apply mapping matrix qbnew to tmor
                  do i=2,lx1-1
                    il= idel(i,col,iface,ie)
                    do j=1,lx1
                      ig=idmo(j,col,ije1,ije2,iface,ie)
                      tmp(i,col,ije1) = tmp(i,col,ije1) +  &
     &                qbnew(i-1,j,ije2)*tmor(ig)
                    end do
                  end do

                end do
              end do
            end do
      
!...........mapping from two pieces of intermediate mortar tmp to element 
!           face tx

            do ije1=1, nnje

!.............the first column, col=1, is an edge of face iface.
!             the value on the three interior collocation points, tx, is 
!             computed by applying mapping matrices qbnew to tmp.
!             the mapping result is divided by 2, because there will be 
!             duplicated contribution from another face sharing this edge.
              col=1
              do i=2,lx1-1
                il= idel(col,i,iface,ie)
                do j=1,lx1
                    tx(il) = tx(il) + qbnew(i-1,j,ije1)*  &
     &                       tmp(col,j,ije1)*0.5d0
                end do 
              end do 

!.............for column 2 ~ lx-1 
              do col=2,lx1-1

!...............when i=1 or lx1, the collocation points are also on an edge of
!               the face, so the mapping result also needs to be divided by 2
                i = v_end(ije1)
                il= idel(col,i,iface,ie)
                tx(il)=tx(il)+tmp(col,i,ije1)*0.5d0

!...............compute the value at interior collocation points in 
!               columns 2 ~ lx1
                do i=2,lx1-1
                  il= idel(col,i,iface,ie)
                  do j=1,lx1
                    tx(il) = tx(il) + qbnew(i-1,j,ije1)* tmp(col,j,ije1)
                  end do 
                end do
              end do

!.............same as col=1
              col=lx1
              do  i=2,lx1-1
                il= idel(col,i,iface,ie)
                do j=1,lx1
                  tx(il) = tx(il) + qbnew(i-1,j,ije1)*  &
     &                     tmp(col,j,ije1)*0.5d0
                end do 
              end do
            end do

!.........for conforming faces
          else

!.........face interior
            do col=2,lx1-1
              do i=2,lx1-1  
                il= idel(i,col,iface,ie)
                ig= idmo(i,col,1,1,iface,ie)
                tx(il)=tmor(ig)
              end do
            end do

        
!...........edges of conforming faces

!...........if local edge 1 is a nonconforming edge
            if(idmo(lx1,1,1,1,iface,ie).ne.0)then
              do i=2,lx1-1               
                il= idel(i,1,iface,ie)
                do ije1=1,2
                  do j=1,lx1
                    ig=idmo(j,1,1,ije1,iface,ie)
                    tx(il) = tx(il) + qbnew(i-1,j,ije1)*tmor(ig)*0.5d0
                  end do
                end do
              end do

!...........if local edge 1 is a conforming edge
            else
              do i=2,lx1-1
                il= idel(i,1,iface,ie)
                ig= idmo(i,1,1,1,iface,ie)
                tx(il)=tmor(ig)
              end do
            end if 

!...........if local edge 2 is a nonconforming edge
            if(idmo(lx1,2,1,2,iface,ie).ne.0)then
              do i=2,lx1-1               
                il= idel(lx1,i,iface,ie)
                do ije1=1,2
                  do j=1,lx1
                    ig=idmo(lx1,j,ije1,2,iface,ie)
                    tx(il) = tx(il) + qbnew(i-1,j,ije1)*tmor(ig)*0.5d0
                  end do
                end do
              end do

!...........if local edge 2 is a conforming edge
            else
              do i=2,lx1-1
                il= idel(lx1,i,iface,ie)
                ig= idmo(lx1,i,1,1,iface,ie)
                tx(il)=tmor(ig)
              end do
            end if 

!...........if local edge 3 is a nonconforming edge
            if(idmo(2,lx1,2,1,iface,ie).ne.0)then
              do  i=2,lx1-1               
                il= idel(i,lx1,iface,ie)
                do ije1=1,2
                  do j=1,lx1
                    ig=idmo(j,lx1,2,ije1,iface,ie)
                    tx(il) = tx(il) + qbnew(i-1,j,ije1)*tmor(ig)*0.5d0
                  end do
                end do
              end do

!...........if local edge 3 is a conforming edge
            else
              do i=2,lx1-1
                il= idel(i,lx1,iface,ie)
                ig= idmo(i,lx1,1,1,iface,ie)
                tx(il)=tmor(ig)
              end do
            end if 

!...........if local edge 4 is a nonconforming edge
            if(idmo(1,lx1,1,1,iface,ie).ne.0)then
              do i=2,lx1-1               
                il= idel(1,i,iface,ie)
                do ije1=1,2
                  do j=1,lx1
                    ig=idmo(1,j,ije1,1,iface,ie)
                    tx(il) = tx(il) + qbnew(i-1,j,ije1)*tmor(ig)*0.5d0
                  end do
                end do
              end do
!...........if local edge 4 is a conforming edge
            else
              do i=2,lx1-1
                il= idel(1,i,iface,ie)
                ig= idmo(1,i,1,1,iface,ie)
                tx(il)=tmor(ig)
              end do
            end if 
          end if
          
        end do
      end do
!$OMP END PARALLEL DO

      return
      end


!------------------------------------------------------------------
      subroutine transfb(tmor,tx)
!------------------------------------------------------------------
!     Map from element(tx) to mortar(tmor).
!     tmor sums contributions from all elements.
!------------------------------------------------------------------

      use ua_data
      implicit none

      double precision third
      parameter (third=1.d0/3.d0)
      integer shift

      double precision tmp,tmp1,tx(*),tmor(*),temp(lx1,lx1,2),  &
     &                 top(lx1,2)
      integer il1,il2,il3,il4,ig1,ig2,ig3,ig4,ie,iface,nnje,  &
     &        ije1,ije2,col,i,j,ije,ig,il

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(il,j,ig,i,col,ije2,ije1,ig4,  &
!$OMP& ig3,ig2,ig1,nnje,il4,il3,il2,il1,iface,ie,ije,  &
!$OMP& tmp,shift,temp,top,tmp1)

!$OMP DO
      do ie=1,nmor
        tmor(ie)=0.d0
      end do
!$OMP END DO

!$OMP DO
      do ie=1,nelt
        do iface=1,nsides
!.........nnje=1 for conforming faces, nnje=2 for nonconforming faces
          if(cbc(iface,ie).eq.3) then
            nnje=2
          else
            nnje=1 
          end if

!.........get collocation point index of four local corners on the face
          il1 = idel(1,  1,  iface,ie)
          il2 = idel(lx1,1,  iface,ie)
          il3 = idel(1,  lx1,iface,ie)
          il4 = idel(lx1,lx1,iface,ie)

!.........get the mortar indices of the four local corners
          ig1 = idmo(1,  1,  1,1,iface,ie)
          ig2 = idmo(lx1,1,  1,2,iface,ie)
          ig3 = idmo(1,  lx1,2,1,iface,ie )
          ig4 = idmo(lx1,lx1,2,2,iface,ie)

!.........sum the values from tx to tmor for these four local corners
!         only 1/3 of the value is summed, since there will be two duplicated
!         contributions from the other two faces sharing this vertex 
!$OMP ATOMIC
          tmor(ig1) = tmor(ig1)+tx(il1)*third
!$OMP ATOMIC
          tmor(ig2) = tmor(ig2)+tx(il2)*third
!$OMP ATOMIC
          tmor(ig3) = tmor(ig3)+tx(il3)*third
!$OMP ATOMIC
          tmor(ig4) = tmor(ig4)+tx(il4)*third

!.........for nonconforming faces
          if(nnje.eq.2) then       
            call r_init(temp,lx1*lx1*2,0.d0)

!...........nonconforming faces have four pieces of mortar, first map tx to
!           two intermediate mortars stored in temp

            do ije2 = 1, nnje
              shift = ije2-1
              do col=1,lx1
!...............For mortar points on face edge (top and bottom), copy the 
!               value from tx to temp
                il=idel(col,v_end(ije2),iface,ie)
                temp(col,v_end(ije2),ije2)=tx(il)

!...............For mortar points on face edge (top and bottom), calculate 
!               the interior points' contribution to them, i.e. top()
                j = v_end(ije2)
                tmp=0.d0
                do i=2,lx1-1 
                  il=idel(col,i,iface,ie)
                  tmp = tmp + qbnew(i-1,j,ije2)*tx(il)
                end do

                top(col,ije2)=tmp

!...............Use mapping matrices qbnew to map the value from tx to temp 
!               for mortar points not on the top bottom face edge.
                do j=2-shift,lx1-shift
                  tmp=0.d0
                  do i=2,lx1-1 
                    il=idel(col,i,iface,ie)
                    tmp = tmp + qbnew(i-1,j,ije2)*tx(il)
                  end do
                  temp(col,j,ije2) = tmp + temp(col,j,ije2)
                end do
              end do
            end do

!...........mapping from temp to tmor

            do ije1=1, nnje
              shift = ije1-1
              do ije2=1,nnje

!...............for each column of collocation points on a piece of mortar
                do col=2-shift,lx1-shift

!.................For the end point, which is on an edge (local edge 2,4), 
!                 the contribution is halved since there will be duplicated 
!                 contribution from another face sharing this edge.

                  ig=idmo(v_end(ije2),col,ije1,ije2,iface,ie)
!$OMP ATOMIC
                  tmor(ig)=tmor(ig)+temp(v_end(ije2),col,ije1)*0.5d0

!.................In each row of collocation points on a piece of mortar, 
!                 sum the contributions from interior collocation points 
!                 (i=2,lx1-1)

                  do  j=1,lx1
                    tmp=0.d0
                    do i=2,lx1-1
                      tmp = tmp + qbnew(i-1,j,ije2) * temp(i,col,ije1)
                    end do
                    ig=idmo(j,col,ije1,ije2,iface,ie)
!$OMP ATOMIC
                    tmor(ig)=tmor(ig)+tmp
                  end do
                end do

!...............For tmor on local edge 1 and 3, tmp is the contribution from
!               an edge, so it is halved because of duplicated contribution
!               from another face sharing this edge. tmp1 is contribution 
!               from face interior. 

                col = v_end(ije1)
                ig=idmo(v_end(ije2),col,ije1,ije2,iface,ie)
!$OMP ATOMIC
                tmor(ig)=tmor(ig)+top(v_end(ije2),ije1)*0.5d0
                do  j=1,lx1
                  tmp=0.d0
                  tmp1=0.d0
                  do i=2,lx1-1
                    tmp  = tmp  + qbnew(i-1,j,ije2) * temp(i,col,ije1)
                    tmp1 = tmp1 + qbnew(i-1,j,ije2) * top(i,ije1)
                  end do
                  ig=idmo(j,col,ije1,ije2,iface,ie)
!$OMP ATOMIC
                  tmor(ig)=tmor(ig)+tmp*0.5d0+tmp1 
                end do
              end do
            end do

!.........for conforming faces
          else

!.........face interior
            do col=2,lx1-1
              do j=2,lx1-1
                il=idel(j,col,iface,ie)
                ig=idmo(j,col,1,1,iface,ie)
!$OMP ATOMIC
                tmor(ig)=tmor(ig)+tx(il)
              end do
            end do

!...........edges of conforming faces

!...........if local edge 1 is a nonconforming edge
            if(idmo(lx1,1,1,1,iface,ie).ne.0)then
              do ije=1,2
                do j=1,lx1
                  tmp=0.d0
                  do i=2,lx1-1
                    il=idel(i,1,iface,ie)
                    tmp= tmp + qbnew(i-1,j,ije)*tx(il)
                  end do
                  ig=idmo(j,1,1,ije,iface,ie)
!$OMP ATOMIC
                  tmor(ig)=tmor(ig)+tmp*0.5d0
                end do
              end do

!...........if local edge 1 is a conforming edge
            else
              do j=2,lx1-1
                il=idel(j,1,iface,ie)
                ig=idmo(j,1,1,1,iface,ie)
!$OMP ATOMIC
                tmor(ig)=tmor(ig)+tx(il)*0.5d0
              end do
            end if 

!...........if local edge 2 is a nonconforming edge
            if(idmo(lx1,2,1,2,iface,ie).ne.0)then
              do ije=1,2
                do j=1,lx1
                  tmp=0.d0
                  do i=2,lx1-1
                    il=idel(lx1,i,iface,ie)
                    tmp = tmp + qbnew(i-1,j,ije)*tx(il)
                  end do
                  ig=idmo(lx1,j,ije,2,iface,ie)
!$OMP ATOMIC
                  tmor(ig)=tmor(ig)+tmp*0.5d0
                end do
              end do

!...........if local edge 2 is a conforming edge
            else
              do j=2,lx1-1
                il=idel(lx1,j,iface,ie)
                ig=idmo(lx1,j,1,1,iface,ie)
!$OMP ATOMIC
                tmor(ig)=tmor(ig)+tx(il)*0.5d0
              end do
            end if 

!...........if local edge 3 is a nonconforming edge
            if(idmo(2,lx1,2,1,iface,ie).ne.0)then
              do ije=1,2
                do j=1,lx1
                  tmp=0.d0
                  do i=2,lx1-1
                    il=idel(i,lx1,iface,ie)
                    tmp = tmp + qbnew(i-1,j,ije)*tx(il)
                  end do
                  ig=idmo(j,lx1,2,ije,iface,ie)
!$OMP ATOMIC
                  tmor(ig)=tmor(ig)+tmp*0.5d0
                end do
              end do

!...........if local edge 3 is a conforming edge
            else
              do j=2,lx1-1
                il=idel(j,lx1,iface,ie)
                ig=idmo(j,lx1,1,1,iface,ie)
!$OMP ATOMIC
                tmor(ig)=tmor(ig)+tx(il)*0.5d0
              end do
            end if 

!...........if local edge 4 is a nonconforming edge
            if(idmo(1,lx1,1,1,iface,ie).ne.0)then
              do ije=1,2
                do j=1,lx1
                  tmp=0.d0
                  do i=2,lx1-1
                    il=idel(1,i,iface,ie)
                    tmp = tmp + qbnew(i-1,j,ije)*tx(il)
                  end do
                  ig=idmo(1,j,ije,1,iface,ie)
!$OMP ATOMIC
                  tmor(ig)=tmor(ig)+tmp*0.5d0
                end do
              end do

!...........if local edge 4 is a conforming edge
            else
              do j=2,lx1-1
                il=idel(1,j,iface,ie)
                ig=idmo(1,j,1,1,iface,ie)
!$OMP ATOMIC
                tmor(ig)=tmor(ig)+tx(il)*0.5d0
              end do
            end if 
          end if
        end do
      end do
!$OMP END DO NOWAIT
!$OMP END PARALLEL 

      return
      end


!--------------------------------------------------------------
      subroutine transfb_cor_e(n,tmor,tx)
!--------------------------------------------------------------
!     This subroutine performs the edge to mortar mapping and
!     calculates the mapping result on the mortar point at a vertex
!     under situation 1,2, or 3.
!     n refers to the configuration of three edges sharing a vertex, 
!     n = 1: only one edge is nonconforming
!     n = 2: two edges are nonconforming 
!     n = 3: three edges are nonconforming 
!-------------------------------------------------------------------

      use ua_data
      implicit none

      double precision tmor,tx(lx1,lx1,lx1),tmp
      integer i,n

      tmor=tx(1,1,1)

      do i=2,lx1-1
        tmor= tmor + qbnew(i-1,1,1)*tx(i,1,1)
      end do

      if(n.gt.1)then
        do i=2,lx1-1
          tmor= tmor + qbnew(i-1,1,1)*tx(1,i,1)
        end do
      end if

      if(n.eq.3)then
        do i=2,lx1-1
          tmor= tmor + qbnew(i-1,1,1)*tx(1,1,i)
        end do
      end if

      return
      end

!--------------------------------------------------------------
      subroutine transfb_cor_f(n,tmor,tx)
!--------------------------------------------------------------
!     This subroutine performs the mapping from face to mortar.
!     Output tmor is the mapping result on a mortar vertex
!     of situations of three edges and three faces sharing a vertex:
!     n=4: only one face is nonconforming 
!     n=5: one face and one edge are nonconforming
!     n=6: two faces are nonconforming 
!     n=7: three faces are nonconforming 
!--------------------------------------------------------------

      use ua_data
      implicit none

      double precision tx(lx1,lx1,lx1),tmor,temp(lx1)
      integer col,i,n

      call r_init(temp,lx1,0.d0)

      do col=1,lx1
        temp(col)=tx(col,1,1)
        do i=2,lx1-1
          temp(col) = temp(col) + qbnew(i-1,1,1)*tx(col,i,1)
        end do
      end do
      tmor=temp(1)

      do i=2,lx1-1
        tmor = tmor + qbnew(i-1,1,1) *temp(i)
      end do

      if(n.eq.5)then
        do i=2,lx1-1
          tmor = tmor + qbnew(i-1,1,1) *tx(1,1,i)
        end do
      end if
 
      if(n.ge.6)then
        call r_init(temp,lx1,0.d0)
        do col=1,lx1
          do i=2,lx1-1
            temp(col) = temp(col) + qbnew(i-1,1,1)*tx(col,1,i)
          end do
        end do
        tmor=tmor+temp(1)
        do i=2,lx1-1
          tmor = tmor +qbnew(i-1,1,1) *temp(i)
        end do
      end if
        
      if(n.eq.7)then
        call r_init(temp,lx1,0.d0)
        do col=2,lx1-1
          do i=2,lx1-1
            temp(col) = temp(col) + qbnew(i-1,1,1)*tx(1,col,i)
          end do
        end do
        do i=2,lx1-1
          tmor = tmor + qbnew(i-1,1,1) *temp(i)
        end do
      end if

      return
      end


!-------------------------------------------------------------------------
      subroutine transf_nc(tmor,tx)
!------------------------------------------------------------------------
!     Perform mortar to element mapping on a nonconforming face. 
!     This subroutin is used when all entries in tmor are zero except
!     one tmor(i,j)=1. So this routine is simplified. Only one piece of 
!     mortar  (tmor only has two indices) and one piece of intermediate 
!     mortar (tmp) are involved.
!------------------------------------------------------------------------

      use ua_data
      implicit none

      double precision tmor(lx1,lx1), tx(lx1,lx1), tmp(lx1,lx1)
      integer col,i,j

      call r_init(tmp,lx1*lx1,0.d0)
      do col=1,lx1
        i = 1
        tmp(i,col)=tmor(i,col)                           
        do i=2,lx1-1
          do j=1,lx1
            tmp(i,col) = tmp(i,col) + qbnew(i-1,j,1)*tmor(j,col)
          end do
        end do
      end do

      do col=1,lx1
        i = 1
        tx(col,i)   = tx(col,i)   + tmp(col,i)
        do i=2,lx1-1
          do j=1,lx1
            tx(col,i) = tx(col,i) + qbnew(i-1,j,1)*tmp(col,j)
          end do
        end do
      end do

      return                                                  
      end                                                     

!------------------------------------------------------------------------
      subroutine transfb_nc0(tmor,tx)
!------------------------------------------------------------------------
!     Performs mapping from element to mortar when the nonconforming 
!     edges are shared by two conforming faces of an element.
!------------------------------------------------------------------------

      use ua_data
      implicit none

      double precision tmor(lx1,lx1),tx(lx1,lx1,lx1)
      integer i,j

      call r_init(tmor,lx1*lx1,0.d0)
      do j=1,lx1
        do i=2,lx1-1
          tmor(j,1)= tmor(j,1) + qbnew(i-1,j  ,1)*tx(i,1,1)
        end do
      end do

      return
      end 

!------------------------------------------------------------------------
      subroutine transfb_nc2(tmor,tx)
!------------------------------------------------------------------------
!     Maps values from element to mortar when the nonconforming edges are
!     shared by two nonconforming faces of an element.
!     Although each face shall have four pieces of mortar, only value in
!     one piece (location (1,1)) is used in the calling routine so only
!     the value in the first mortar is calculated in this subroutine.
!------------------------------------------------------------------------

      use ua_data
      implicit none

      double precision tx(lx1,lx1),tmor(lx1,lx1),bottom(lx1),  &
     &                 temp(lx1,lx1)
      integer col,j,i

      call r_init(tmor,lx1*lx1,0.d0)
      call r_init(temp,lx1*lx1,0.d0)
      tmor(1,1)=tx(1,1)

!.....mapping from tx to intermediate mortar temp + bottom
      do col=1,lx1
        temp(col,1)=tx(col,1)
        j=1
        bottom(col)= 0.d0
        do i=2,lx1-1 
          bottom(col) = bottom(col) + qbnew(i-1,j,1)*tx(col,i)
        end do

        do j=2,lx1
          do i=2,lx1-1 
            temp(col,j) = temp(col,j) + qbnew(i-1,j,1)*tx(col,i)
          end do
        end do
      end do

!.....from intermediate mortar to mortar

!.....On the nonconforming edge, temp is divided by 2 as there will be
!     a duplicate contribution from another face sharing this edge
      col=1
      do j=1,lx1
        do i=2,lx1-1
          tmor(j,col)=tmor(j,col)+ qbnew(i-1,j,1) * bottom(i) +  &
     &                             qbnew(i-1,j,1) * temp(i,col) * 0.5d0 
        end do
      end do

      do col=2,lx1
        tmor(1,col)=tmor(1,col)+temp(1,col)
        do j=1,lx1
          do i=2,lx1-1
            tmor(j,col) = tmor(j,col) + qbnew(i-1,j,1) *temp(i,col)
          end do
        end do
      end do

      return
      end 


!------------------------------------------------------------------------
      subroutine transfb_nc1(tmor,tx)
!------------------------------------------------------------------------
!     Maps values from element to mortar when the nonconforming edges are
!     shared by a nonconforming face and a conforming face of an element
!------------------------------------------------------------------------

      use ua_data
      implicit none

      double precision tx(lx1,lx1),tmor(lx1,lx1),bottom(lx1),  &
     &                 temp(lx1,lx1)
      integer col,j,i

      call r_init(tmor,lx1*lx1,0.d0)
      call r_init(temp,lx1*lx1,0.d0)

      tmor(1,1)=tx(1,1)
!.....Contribution from the nonconforming faces
!     Since the calling subroutine is only interested in the value on the
!     mortar (location (1,1)), only this piece of mortar is calculated.

      do col=1,lx1
        temp(col,1)=tx(col,1)
        j = 1
        bottom(col)= 0.d0
        do i=2,lx1-1 
          bottom(col)=bottom(col) + qbnew(i-1,j,1)*tx(col,i)
        end do

        do j=2,lx1
          do i=2,lx1-1 
            temp(col,j) = temp(col,j) + qbnew(i-1,j,1)*tx(col,i)
          end do

        end do
      end do

      col=1
      tmor(1,col)=tmor(1,col)+bottom(1)
      do j=1,lx1
        do i=2,lx1-1

!.........temp is not divided by 2 here. It includes the contribution
!         from the other conforming face.

          tmor(j,col)=tmor(j,col) + qbnew(i-1,j,1) *bottom(i) +  &
     &                              qbnew(i-1,j,1) *temp(i,col) 
        end do
      end do

      do col=2,lx1
        tmor(1,col)=tmor(1,col)+temp(1,col)
        do j=1,lx1
          do i=2,lx1-1
            tmor(j,col) = tmor(j,col) + qbnew(i-1,j,1) *temp(i,col)
          end do
        end do
      end do

      return
      end


!-------------------------------------------------------------------
      subroutine transfb_c(tx)
!-------------------------------------------------------------------
!     Prepare initial guess for cg. All values from conforming 
!     boundary are copied and summed on tmor.
!-------------------------------------------------------------------

      use ua_data
      implicit none

      double precision third
      parameter (third = 1.d0/3.d0)
      double precision tx(*)
      integer il1,il2,il3,il4,ig1,ig2,ig3,ig4,ie,iface,col,j,ig,il

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(IE,IFACE,IL1,IL2,  &
!$OMP& IL3,IL4,IG1,IG2,IG3,IG4,COL,J,IG,IL) 

!$OMP DO
      do j=1,nmor
        tmort(j)=0.d0
      end do
!$OMP END DO

!$OMP DO
      do ie=1,nelt
        do iface=1,nsides
          if(cbc(iface,ie).ne.3)then
            il1 = idel(1,1,iface,ie)
            il2 = idel(lx1,1,iface,ie)
            il3 = idel(1,lx1,iface,ie)
            il4 = idel(lx1,lx1,iface,ie)
            ig1 = idmo(1,  1,  1,1,iface,ie)
            ig2 = idmo(lx1,1,  1,2,iface,ie)
            ig3 = idmo(1,  lx1,2,1,iface,ie)
            ig4 = idmo(lx1,lx1,2,2,iface,ie)

!$OMP ATOMIC
            tmort(ig1) = tmort(ig1)+tx(il1)*third
!$OMP ATOMIC
            tmort(ig2) = tmort(ig2)+tx(il2)*third
!$OMP ATOMIC
            tmort(ig3) = tmort(ig3)+tx(il3)*third
!$OMP ATOMIC
            tmort(ig4) = tmort(ig4)+tx(il4)*third

            do  col=2,lx1-1
              do j=2,lx1-1
                il=idel(j,col,iface,ie)
                ig=idmo(j,col,1,1,iface,ie)
!$OMP ATOMIC
                tmort(ig)=tmort(ig)+tx(il)
              end do
            end do

            if(idmo(lx1,1,1,1,iface,ie).eq.0)then
              do j=2,lx1-1
                il=idel(j,1,iface,ie)
                ig=idmo(j,1,1,1,iface,ie)
!$OMP ATOMIC
                tmort(ig)=tmort(ig)+tx(il)*0.5d0
              end do
            end if

            if(idmo(lx1,2,1,2,iface,ie).eq.0)then
              do j=2,lx1-1
                il=idel(lx1,j,iface,ie)
                ig=idmo(lx1,j,1,1,iface,ie)
!$OMP ATOMIC
                tmort(ig)=tmort(ig)+tx(il)*0.5d0
              end do
            end if

            if(idmo(2,lx1,2,1,iface,ie).eq.0)then
              do j=2,lx1-1
                il=idel(j,lx1,iface,ie)
                ig=idmo(j,lx1,1,1,iface,ie)
!$OMP ATOMIC
                tmort(ig)=tmort(ig)+tx(il)*0.5d0
              end do
            end if

            if(idmo(1,lx1,1,1,iface,ie).eq.0)then
              do j=2,lx1-1
                il=idel(1,j,iface,ie)
                ig=idmo(1,j,1,1,iface,ie)
!$OMP ATOMIC
                tmort(ig)=tmort(ig)+tx(il)*0.5d0
              end do
            end if
          end if!
        end do
      end do
!$OMP END DO NOWAIT
!$OMP END PARALLEL
      return
      end

!-------------------------------------------------------------------
      subroutine transfb_c_2(tx)
!-------------------------------------------------------------------
!     Prepare initial guess for CG. All values from conforming 
!     boundary are copied and summed in tmort. 
!     mormult is multiplicity, which is used to average tmort.
!-------------------------------------------------------------------

      use ua_data
      implicit none

      double precision third
      parameter (third = 1.d0/3.d0)
      double precision tx(*)
      integer il1,il2,il3,il4,ig1,ig2,ig3,ig4,ie,iface,col,j,ig,il

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(IE,IFACE,IL1,IL2,  &
!$OMP& IL3,IL4,IG1,IG2,IG3,IG4,COL,J,IG,IL)

!$OMP DO     
      do j=1,nmor
        tmort(j)=0.d0
      end do
!$OMP END DO nowait
!$OMP DO
      do j=1,nmor
        mormult(j)=0.d0
      end do
!$OMP END DO

!$OMP DO 
      do ie=1,nelt
        do iface=1,nsides
          
          if(cbc(iface,ie).ne.3)then
            il1 = idel(1,  1,  iface,ie)
            il2 = idel(lx1,1,  iface,ie)
            il3 = idel(1,  lx1,iface,ie)
            il4 = idel(lx1,lx1,iface,ie)
            ig1 = idmo(1,  1,  1,1,iface,ie)
            ig2 = idmo(lx1,1,  1,2,iface,ie)
            ig3 = idmo(1,  lx1,2,1,iface,ie)
            ig4 = idmo(lx1,lx1,2,2,iface,ie)

!$OMP ATOMIC
            tmort(ig1) = tmort(ig1)+tx(il1)*third
!$OMP ATOMIC
            tmort(ig2) = tmort(ig2)+tx(il2)*third
!$OMP ATOMIC
            tmort(ig3) = tmort(ig3)+tx(il3)*third
!$OMP ATOMIC
            tmort(ig4) = tmort(ig4)+tx(il4)*third
!$OMP ATOMIC
            mormult(ig1) = mormult(ig1)+third
!$OMP ATOMIC
            mormult(ig2) = mormult(ig2)+third
!$OMP ATOMIC
            mormult(ig3) = mormult(ig3)+third
!$OMP ATOMIC
            mormult(ig4) = mormult(ig4)+third

            do  col=2,lx1-1
              do j=2,lx1-1
                il=idel(j,col,iface,ie)
                ig=idmo(j,col,1,1,iface,ie)
!$OMP ATOMIC
                tmort(ig)=tmort(ig)+tx(il)
!$OMP ATOMIC
                mormult(ig)=mormult(ig)+1.d0
              end do
            end do

            if(idmo(lx1,1,1,1,iface,ie).eq.0)then
              do j=2,lx1-1
                il=idel(j,1,iface,ie)
                ig=idmo(j,1,1,1,iface,ie)
!$OMP ATOMIC
                tmort(ig)=tmort(ig)+tx(il)*0.5d0
!$OMP ATOMIC
                mormult(ig)=mormult(ig)+0.5d0
              end do
            end if

            if(idmo(lx1,2,1,2,iface,ie).eq.0)then
              do j=2,lx1-1
                il=idel(lx1,j,iface,ie)
                ig=idmo(lx1,j,1,1,iface,ie)
!$OMP ATOMIC
                tmort(ig)=tmort(ig)+tx(il)*0.5d0
!$OMP ATOMIC
                mormult(ig)=mormult(ig)+0.5d0
              end do
            end if

            if(idmo(2,lx1,2,1,iface,ie).eq.0)then
              do j=2,lx1-1
                il=idel(j,lx1,iface,ie)
                ig=idmo(j,lx1,1,1,iface,ie)
!$OMP ATOMIC
                tmort(ig)=tmort(ig)+tx(il)*0.5d0
!$OMP ATOMIC
                mormult(ig)=mormult(ig)+0.5d0
               end do
            end if

            if(idmo(1,lx1,1,1,iface,ie).eq.0)then
              do j=2,lx1-1
                il=idel(1,j,iface,ie)
                ig=idmo(1,j,1,1,iface,ie)
!$OMP ATOMIC
                tmort(ig)=tmort(ig)+tx(il)*0.5d0
!$OMP ATOMIC
                mormult(ig)=mormult(ig)+0.5d0
              end do
            end if
          end if!nnje=1
        end do
      end do
!$OMP END DO NOWAIT
!$OMP END PARALLEL

      return
      end

      subroutine verify(class, verified)

      use, intrinsic :: ieee_arithmetic, only : ieee_is_nan

      use ua_data

      implicit none

      double precision norm, calc_norm, epsilon, norm_dif, norm_ref
      external         calc_norm
      character        class
      logical          verified
       
!.....tolerance level
      epsilon = 1.0d-08

!.....compute the temperature integral over the whole domain
      norm = calc_norm()

      verified = .true.
      if     ( class .eq. 'S' ) then
        norm_ref = 0.1890013110962D-02
      elseif ( class .eq. 'W' ) then
        norm_ref = 0.2569794837076D-04
      elseif ( class .eq. 'A' ) then
        norm_ref = 0.8939996281443D-04
      elseif ( class .eq. 'B' ) then
        norm_ref = 0.4507561922901D-04
      elseif ( class .eq. 'C' ) then
        norm_ref = 0.1544736587100D-04
      elseif ( class .eq. 'D' ) then
        norm_ref = 0.1577586272355D-05
      else
        class = 'U'
        norm_ref = 1.d0
        verified = .false.
      endif         

      norm_dif = dabs((norm - norm_ref)/norm_ref)

!---------------------------------------------------------------------
!    Output the comparison of computed results to known cases.
!---------------------------------------------------------------------

      print *

      if (class .ne. 'U') then
         write(*, 1990) class
 1990    format(' Verification being performed for class ', a)
         write (*,2000) epsilon
 2000    format(' accuracy setting for epsilon = ', E20.13)
      else 
         write(*, 1995)
 1995    format(' Unknown class')
      endif

      if (class .ne. 'U') then
         write (*,2001) 
      else
         write (*, 2005)
      endif

 2001 format(' Comparison of temperature integrals')
 2005 format(' Temperature integral')
      if (class .eq. 'U') then
         write(*, 2015) norm
      else if ((.not.ieee_is_nan(norm_dif)) .and.  &
     &         norm_dif .le. epsilon) then
         write (*,2011) norm, norm_ref, norm_dif
      else 
         verified = .false.
         write (*,2010) norm, norm_ref, norm_dif
      endif

 2010 format(' FAILURE: ', E20.13, E20.13, E20.13)
 2011 format('          ', E20.13, E20.13, E20.13)
 2015 format('          ', E20.13)
        
      if (class .eq. 'U') then
        write(*, 2022)
        write(*, 2023)
 2022   format(' No reference values provided')
 2023   format(' No verification performed')
      else if (verified) then
        write(*, 2020)
 2020   format(' Verification Successful')
      else
        write(*, 2021)
 2021   format(' Verification failed')
      endif

      return
      end

!---------------------------------------------------------------------
      subroutine diffusion(ifmortar)      
!---------------------------------------------------------------------
!     advance the diffusion term using CG iterations
!---------------------------------------------------------------------

      use ua_data
      implicit none

      double precision  rho_aux, rho1, rho2, beta, cona
      logical ifmortar
      integer iter,ie, im,iside,i,j,k

      if (timeron) call timer_start(t_diffusion)
!.....set up diagonal preconditioner
      if (ifmortar) then
        call setuppc
        call setpcmo
      end if

!.....arrays t and umor are accumlators of (am pm) in the CG algorithm
!     (see the specification)

      call r_init_omp(t,ntot,0.d0)
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
      do i=1,nmor
        umor(i)=0.d0
      end do
!$OMP END PARALLEL DO

!.....calculate initial am (see specification) in CG algorithm

!.....trhs and rmor are combined to generate r0 in CG algorithm.
!     pdiff and pmorx are combined to generate q0 in the CG algorithm.
!     rho1 is  (qm,rm) in the CG algorithm.

      rho1 = 0.d0
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(im,ie,i,j,k) REDUCTION(+:rho1)
!$OMP DO
       do ie=1,nelt
         do k=1,lx1
           do j=1,lx1
             do i=1,lx1
               pdiff(i,j,k,ie) = dpcelm(i,j,k,ie)*trhs(i,j,k,ie)
               rho1            = rho1 + trhs(i,j,k,ie)*pdiff(i,j,k,ie)*  &
     &                                          tmult(i,j,k,ie)
             end do
           end do
         end do
       end do
!$OMP END DO nowait

!$OMP DO
      do im = 1, nmor
        pmorx(im) = dpcmor(im)*rmor(im)
        rho1      = rho1 + rmor(im)*pmorx(im)
      end do
!$OMP END DO nowait
!$OMP END PARALLEL

!.................................................................
!     commence conjugate gradient iteration
!.................................................................

      do iter=1, nmxh
        if(iter.gt.1) then 
          rho_aux = 0.d0
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(im,ie,i,j,k) REDUCTION(+:rho_aux)
!$OMP DO
!.........pdiffp and ppmor are combined to generate q_m+1 in the specification
!         rho_aux is (q_m+1,r_m+1)
          do ie = 1, nelt
            do k=1,lx1
              do j=1,lx1
                do i=1,lx1
                  pdiffp(i,j,k,ie) = dpcelm(i,j,k,ie)*trhs(i,j,k,ie)
                  rho_aux =rho_aux+trhs(i,j,k,ie)*pdiffp(i,j,k,ie)*  &
     &                                            tmult(i,j,k,ie)
                end do
              end do
            end do
          end do
!$OMP END DO nowait
!$OMP DO
          do im = 1, nmor
            ppmor(im) = dpcmor(im)*rmor(im)
            rho_aux = rho_aux + rmor(im)*ppmor(im)
          end do
!$OMP END DO nowait
!$OMP END PARALLEL

!.........compute bm (beta) in the specification
          rho2 = rho1
          rho1 = rho_aux
          beta = rho1/rho2
!.........update p_m+1 in the specification
          call adds1m1(pdiff, pdiffp, beta,ntot)
          call adds1m1(pmorx, ppmor,  beta, nmor)  
        end if
 
!.......compute matrix vector product: (theta pm) in the specification

        if (timeron) call timer_start(t_transf)
        call transf(pmorx,pdiff) 
        if (timeron) call timer_stop(t_transf)

!.......compute pdiffp which is (A theta pm) in the specification
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ie) 
        do ie=1, nelt
          call laplacian(pdiffp(1,1,1,ie),pdiff(1,1,1,ie),size_e(ie))
        end do
!$OMP END PARALLEL DO

!.......compute ppmor which will be used to compute (thetaT A theta pm) 
!       in the specification
        if (timeron) call timer_start(t_transfb)
        call transfb(ppmor,pdiffp) 
        if (timeron) call timer_stop(t_transfb)
 
!.......apply boundary condition
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ie,iside)
        do ie=1,nelt
          do iside=1,nsides
            if(cbc(iside,ie).eq.0)then
              call facev(pdiffp(1,1,1,ie),iside,0.d0)
            end if
          end do
        end do
!$OMP END PARALLEL DO

!.......compute cona which is (pm,theta T A theta pm)
        cona = 0.d0
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(im,ie,i,j,k) REDUCTION(+:cona)
!$OMP DO
        do ie = 1, nelt
          do k=1,lx1
            do j=1,lx1
              do i=1,lx1
                cona = cona +  &
     &          pdiff(i,j,k,ie)*pdiffp(i,j,k,ie)*tmult(i,j,k,ie)
              end do 
             end do 
          end do 
        end do 
!$OMP END DO nowait
!$OMP DO
        do im = 1, nmor
          ppmor(im) = ppmor(im)*tmmor(im)
          cona = cona + pmorx(im)*ppmor(im)
        end do
!$OMP END DO nowait
!$OMP END PARALLEL

!.......compute am
        cona = rho1/cona
!.......compute (am pm)
        call adds2m1(t,    pdiff,   cona, ntot)
        call adds2m1(umor, pmorx,   cona, nmor) 
!.......compute r_m+1
        call adds2m1(trhs, pdiffp, -cona, ntot)
        call adds2m1(rmor, ppmor,  -cona, nmor) 
 
      end do

      if (timeron) call timer_start(t_transf)
      call transf(umor,t)  
      if (timeron) call timer_stop(t_transf)
      if (timeron) call timer_stop(t_diffusion)

      return
      end


!------------------------------------------------------------------
      subroutine laplacian(r,u,sizei)
!------------------------------------------------------------------
!     compute  r = visc*[A]x +[B]x on a given element.
!------------------------------------------------------------------

      use ua_data
      implicit none

      double precision r(lx1,lx1,lx1), u(lx1,lx1,lx1), rdtime
      integer i,j,k, ix,iz, sizei

      double precision tm1(lx1,lx1,lx1),tm2(lx1,lx1,lx1)                     

      rdtime = 1.d0/dtime

      call r_init(tm1,nxyz,0.d0)
      do iz=1,lx1                     
        do k = 1, lx1
          do j = 1, lx1
            do i = 1, lx1
              tm1(i,j,iz) = tm1(i,j,iz)+wdtdr(i,k)*u(k,j,iz)
            end do
          end do
        end do                           
      end do
              
      call r_init(tm2,nxyz,0.d0)                                                   
      do iz=1,lx1                                            
        do k = 1, lx1
          do j = 1, lx1
            do i = 1, lx1
              tm2(i,j,iz) = tm2(i,j,iz)+u(i,k,iz)*wdtdr(k,j)
            end do
          end do
        end do
      end do
                                                            
      call r_init(r,nxyz,0.d0)   
      do k = 1, lx1
        do iz=1, lx1    
          do j = 1, lx1
            do i = 1, lx1
              r(i,j,iz) = r(i,j,iz)+u(i,j,k)*wdtdr(k,iz)
            end do
          end do
        end do
      end do

!.....collocate with remaining weights and sum to complete factorization.                   
                                                      
!      do ix=1,nxyz                                            
!         r(ix,1,1)=visc*(tm1(ix,1,1)*g4m1_s(ix,1,1,sizei)+
!     &                   tm2(ix,1,1)*g5m1_s(ix,1,1,sizei)+
!     &                     r(ix,1,1)*g6m1_s(ix,1,1,sizei))+
!     &               bm1_s(ix,1,1,sizei)*rdtime*u(ix,1,1)             
!      end do
      do k=1,lx1
        do j=1,lx1
          do i=1,lx1
            r(i,j,k)=visc*(tm1(i,j,k)*g4m1_s(i,j,k,sizei)+  &
     &                   tm2(i,j,k)*g5m1_s(i,j,k,sizei)+  &
     &                    r(i,j,k)*g6m1_s(i,j,k,sizei))+  &
     &               bm1_s(i,j,k,sizei)*rdtime*u(i,j,k)             
          end do
        end do
      end do

      return                                                  
      end                                                    


 

!-----------------------------------------------------------------
      subroutine mortar
!-----------------------------------------------------------------
!     generate mortar point index number 
!-----------------------------------------------------------------

      use ua_data
      implicit none

      integer count, iel, jface, ntemp, i, ii, jj, ntemp1,  &
     &        iii, jjj, face2, ne, ie, edge_g, ie2,  &
     &        mor_v(3), cb, cb1, cb2, cb3, cb4, cb5, cb6,  &
     &        space, sumcb, ij1, ij2, n1, n2, n3, n4, n5

      n1=lx1*lx1*6*4*nelt
      n2=8*nelt
      n3=2*64*nelt
      n4=12*nelt
      n5=2*12*nelt

      call nr_init_omp(idmo,n1,0)
      call nr_init_omp(nemo,n2,0)
      call nr_init_omp(vassign,n2,0)
      call nr_init_omp(emo,n3,0)
      call  l_init_omp(if_1_edge,n4,.false.)
      call nr_init_omp(diagn,n5,0)
!.....Mortar points indices are generated in two steps: first generate 
!     them for all element vertices (corner points), then for conforming 
!     edge and conforming face interiors. Each time a new mortar index 
!     is generated for a mortar point, it is broadcast to all elements 
!     sharing this mortar point. 

!.....VERTICES
      count=0

!.....assign mortar point indices to element vertices
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(iel,sumcb,ij1,ij2,  &
!$OMP& cb,cb1,cb2,ntemp,ntemp1)

      do iel=1,nelt

!.......first calculate how many new mortar indices will be generated for 
!       each element.

!.......For each element, at least one vertex (vertex 8) will be new mortar
!       point. All possible new mortar points will be on face 2,4 or 6. By
!       checking the type of these three faces, we are able to tell
!       how many new mortar vertex points will be generated in each element.

        cb=cbc(6,iel)
        cb1=cbc(4,iel)
        cb2=cbc(2,iel)

!.......For different combinations of the type of these three faces,
!       we group them into 27 configurations.
!       For different face types we assign the following integers:
!              1 for type 2 or 3
!              2 for type 0
!              5 for type 1
!       By summing these integers for faces 2,4 and 6, sumcb will have 
!       10 different numbers indicating 10 different combinations. 

        sumcb=0
        if(cb.eq.2.or.cb.eq.3)then
          sumcb=sumcb+1
        elseif(cb.eq.0)then
          sumcb=sumcb+2
        elseif(cb.eq.1)then
          sumcb=sumcb+5
        end if
        if(cb1.eq.2.or.cb1.eq.3)then
          sumcb=sumcb+1
        elseif(cb1.eq.0)then
          sumcb=sumcb+2
        elseif(cb1.eq.1)then
          sumcb=sumcb+5
        end if
        if(cb2.eq.2.or.cb2.eq.3)then
          sumcb=sumcb+1
        elseif(cb2.eq.0)then
          sumcb=sumcb+2
        elseif(cb2.eq.1)then
          sumcb=sumcb+5
        end if

!.......compute newc(iel)
!       newc(iel) records how many new mortar indices will be generated
!                 for element iel
!       vassign(i,iel) records the element vertex of the i'th new mortar 
!                 vertex point for element iel. e.g. vassign(2,iel)=8 means
!                 the 2nd new mortar vertex point generated on element
!                 iel is iel's 8th vertex.
 
        if(sumcb.eq.3)then
!.......the three face types for face 2,4, and 6 are 2 2 2
          newc(iel)=1
          vassign(1,iel)=8
          
        elseif(sumcb.eq.4)then
!.......the three face types for face 2,4 and 6 are 2 2 0 (not 
!       necessarily in this order)
          newc(iel)=2
          if(cb.eq.0)then
            vassign(1,iel)=4
          elseif(cb1.eq.0)then
            vassign(1,iel)=6
          elseif(cb2.eq.0)then
            vassign(1,iel)=7
          end if
          vassign(2,iel)=8

        elseif(sumcb.eq.7)then
!.......the three face types for face 2,4 and 6 are 2 2 1 (not 
!       necessarily in this order)
          if(cb.eq.1)then
            ij1=ijel(1,6,iel)
            ij2=ijel(2,6,iel)
            if(ij1.eq.1.and.ij2.eq.1)then
              newc(iel)=2
              vassign(1,iel)=4
              vassign(2,iel)=8
            elseif(ij1.eq.1.and.ij2.eq.2)then
              ntemp=sje(1,1,6,iel)
              if(cbc(1,ntemp).eq.3.and.sje(1,1,1,ntemp).lt.iel)then
                newc(iel)=1
                vassign(1,iel)=8
              else
                newc(iel)=2
                vassign(1,iel)=4
                vassign(2,iel)=8
              end if
            elseif(ij1.eq.2.and.ij2.eq.1)then
              ntemp=sje(1,1,6,iel)
              if(cbc(3,ntemp).eq.3.and.sje(1,1,3,ntemp).lt.iel)then
                newc(iel)=1
                vassign(1,iel)=8
              else
                newc(iel)=2
                vassign(1,iel)=4
                vassign(2,iel)=8
              endif
            else
              newc(iel)=1
              vassign(1,iel)=8
            end if
          elseif(cb1.eq.1)then
            ij1=ijel(1,4,iel)
            ij2=ijel(2,4,iel)
            if(ij1.eq.1.and.ij2.eq.1)then
              newc(iel)=2
              vassign(1,iel)=6
              vassign(2,iel)=8
            elseif(ij1.eq.1.and.ij2.eq.2)then
              ntemp=sje(1,1,4,iel)
              if(cbc(1,ntemp).eq.3.and.sje(1,1,1,ntemp).lt.iel)then
                newc(iel)=1
                vassign(1,iel)=8
              else
                newc(iel)=2
                vassign(1,iel)=6
                vassign(2,iel)=8
              endif
            elseif(ij1.eq.2.and.ij2.eq.1)then
              ntemp=sje(1,1,4,iel)
              if(cbc(5,ntemp).eq.3.and.sje(1,1,5,ntemp).lt.iel)then
                newc(iel)=1
                vassign(1,iel)=8
              else
                newc(iel)=2
                vassign(1,iel)=6
                vassign(2,iel)=8
              endif
            else
              newc(iel)=1
              vassign(1,iel)=8
            end if

          elseif(cb2.eq.1)then
            ij1=ijel(1,2,iel)
            ij2=ijel(2,2,iel)
            if(ij1.eq.1.and.ij2.eq.1)then
              newc(iel)=2
              vassign(1,iel)=7
              vassign(2,iel)=8
            elseif(ij1.eq.1.and.ij2.eq.2)then
              ntemp=sje(1,1,2,iel)
              if(cbc(3,ntemp).eq.3.and.sje(1,1,3,ntemp).lt.iel)then
                newc(iel)=1
                vassign(1,iel)=8
              else
                newc(iel)=2
                vassign(1,iel)=7
                vassign(2,iel)=8
              end if

            elseif(ij1.eq.2.and.ij2.eq.1)then
              ntemp=sje(1,1,2,iel)
              if(cbc(5,ntemp).eq.3.and.sje(1,1,5,ntemp).lt.iel)then
                newc(iel)=1
                vassign(1,iel)=8
              else
                newc(iel)=2
                vassign(1,iel)=7
                vassign(2,iel)=8
              end if
            else
              newc(iel)=1
              vassign(1,iel)=8
            end if
          end if

        elseif(sumcb.eq.5)then
!.......the three face types for face 2,4 and 6 are 2/3 0 0 (not 
!       necessarily in this order)
          newc(iel)=4
          if(cb.eq.2.or.cb.eq.3)then
            vassign(1,iel)=5
            vassign(2,iel)=6
            vassign(3,iel)=7
            vassign(4,iel)=8
          elseif(cb1.eq.2.or.cb1.eq.3)then
            vassign(1,iel)=3
            vassign(2,iel)=4
            vassign(3,iel)=7
            vassign(4,iel)=8
          elseif(cb2.eq.2.or.cb2.eq.3)then
            vassign(1,iel)=2
            vassign(2,iel)=4
            vassign(3,iel)=6
            vassign(4,iel)=8
          end if

        elseif(sumcb.eq.8)then
!.......the three face types for face 2,4 and 6 are 2 0 1 (not 
!       necessarily in this order)

!.........if face 2 of type 1
          if(cb.eq.1)then
            if(cb1.eq.2.or.cb1.eq.3)then
              ij1=ijel(1,6,iel)
              if(ij1.eq.1)then
                newc(iel)=4
                vassign(1,iel)=3
                vassign(2,iel)=4
                vassign(3,iel)=7
                vassign(4,iel)=8
              else 
                ntemp=sje(1,1,6,iel)
                if(cbc(3,ntemp).eq.3.and.sje(1,1,3,ntemp).lt.iel)then
                  newc(iel)=2
                  vassign(1,iel)=7
                  vassign(2,iel)=8
                else
                  newc(iel)=3
                  vassign(1,iel)=4
                  vassign(2,iel)=7
                  vassign(3,iel)=8
                end if
              end if

            elseif(cb2.eq.2.or.cb2.eq.3)then
              if(ijel(2,6,iel).eq.1)then
                newc(iel)=4
                vassign(1,iel)=2
                vassign(2,iel)=4
                vassign(3,iel)=6
                vassign(4,iel)=8
              else
                ntemp=sje(1,1,6,iel)
                if(cbc(1,ntemp).eq.3.and.sje(1,1,1,ntemp).lt.iel)then
                  newc(iel)=2
                  vassign(1,iel)=6
                  vassign(2,iel)=8
                else
                  newc(iel)=3
                  vassign(1,iel)=4
                  vassign(2,iel)=6
                  vassign(3,iel)=8
                end if
              end if
            end if

!.........if face 4 of type 1
          elseif(cb1.eq.1)then
            if(cb.eq.2.or.cb.eq.3)then
              ij1=ijel(1,4,iel)
              ij2=ijel(2,4,iel)

              if(ij1.eq.1.and.ij2.eq.1)then
                ntemp=sje(1,1,4,iel)
                if(cbc(2,ntemp).eq.3.and.sje(1,1,2,ntemp).lt.iel)then
                  newc(iel)=3
                  vassign(1,iel)=6
                  vassign(2,iel)=7
                  vassign(3,iel)=8
                else
                  newc(iel)=4
                  vassign(1,iel)=5
                  vassign(2,iel)=6
                  vassign(3,iel)=7
                  vassign(4,iel)=8
                end if
              elseif(ij1.eq.1.and.ij2.eq.2)then
                ntemp=sje(1,1,4,iel)
                if(cbc(1,ntemp).eq.3.and.sje(1,1,1,ntemp).lt.iel)then
                  newc(iel)=3
                  vassign(1,iel)=5
                  vassign(2,iel)=7
                  vassign(3,iel)=8
                else
                  newc(iel)=4
                  vassign(1,iel)=5
                  vassign(2,iel)=6
                  vassign(3,iel)=7
                  vassign(4,iel)=8
                end if
              elseif(ij1.eq.2.and.ij2.eq.1)then
                ntemp=sje(1,1,4,iel)
                if(cbc(5,ntemp).eq.3.and.sje(1,1,5,ntemp).lt.iel)then
                  newc(iel)=2
                  vassign(1,iel)=7
                  vassign(2,iel)=8
                else
                  newc(iel)=3
                  vassign(1,iel)=6
                  vassign(2,iel)=7
                  vassign(3,iel)=8
                end if
              elseif(ij1.eq.2.and.ij2.eq.2)then
                ntemp=sje(1,1,4,iel)
                if(cbc(5,ntemp).eq.3.and.sje(1,1,5,ntemp).lt.iel)then
                  newc(iel)=2
                  vassign(1,iel)=7
                  vassign(2,iel)=8
                else
                  newc(iel)=3
                  vassign(1,iel)=5
                  vassign(2,iel)=7
                  vassign(3,iel)=8
                end if
              end if
            else 
              if(ijel(2,4,iel).eq.1)then
                newc(iel)=4
                vassign(1,iel)=2
                vassign(2,iel)=4
                vassign(3,iel)=6
                vassign(4,iel)=8
              else
                ntemp=sje(1,1,4,iel)
                if(cbc(1,ntemp).eq.3.and.sje(1,1,1,ntemp).lt.iel)then
                  newc(iel)=2
                  vassign(1,iel)=4
                  vassign(2,iel)=8
                else
                  newc(iel)=3
                  vassign(1,iel)=4
                  vassign(2,iel)=6
                  vassign(3,iel)=8
                end if
              end if
            endif
!.........if face 6 of type 1
          elseif(cb2.eq.1)then
            if(cb.eq.2.or.cb.eq.3)then
              if(ijel(1,2,iel).eq.1)then
                newc(iel)=4
                vassign(1,iel)=5
                vassign(2,iel)=6
                vassign(3,iel)=7
                vassign(4,iel)=8
              else
                ntemp=sje(1,1,2,iel)
                if(cbc(5,ntemp).eq.3.and.sje(1,1,5,ntemp).lt.iel)then
                  newc(iel)=2
                  vassign(1,iel)=6
                  vassign(2,iel)=8
                else
                  newc(iel)=3
                  vassign(1,iel)=6
                  vassign(2,iel)=7
                  vassign(3,iel)=8
                end if
              end if
            else 
              if(ijel(2,2,iel).eq.1)then
                newc(iel)=4
                vassign(1,iel)=3
                vassign(2,iel)=4
                vassign(3,iel)=7
                vassign(4,iel)=8
              else
                ntemp=sje(1,1,2,iel)
                if(cbc(3,ntemp).eq.3.and.sje(1,1,3,ntemp).lt.iel)then
                  newc(iel)=2
                  vassign(1,iel)=4
                  vassign(2,iel)=8
                else
                  newc(iel)=3
                  vassign(1,iel)=4
                  vassign(2,iel)=7
                  vassign(3,iel)=8
                end if
              end if
            end if
          end if

        elseif(sumcb.eq.11)then
!.......the three face type for face 2,4 and 6 are 2 1 1(not 
!       necessarily in this order)
          if(cb.eq.2.or.cb.eq.3)then
            if(ijel(1,4,iel).eq.1)then
              ntemp=sje(1,1,4,iel)
              if(cbc(2,ntemp).eq.3.and.sje(1,1,2,ntemp).lt.iel)then
                newc(iel)=3
                vassign(1,iel)=6
                vassign(2,iel)=7
                vassign(3,iel)=8
              else
                newc(iel)=4
                vassign(1,iel)=5
                vassign(2,iel)=6
                vassign(3,iel)=7
                vassign(4,iel)=8
              end if

!...........if ijel(1,4,iel)=2
            else
              ntemp=sje(1,1,2,iel)
              if(cbc(5,ntemp).eq.3.and.sje(1,1,5,ntemp).lt.iel)then
                ntemp1=sje(1,1,4,iel)
                if(cbc(5,ntemp1).eq.3.and.  &
     &             sje(1,1,5,ntemp1).lt.iel)then
                  newc(iel)=1
                  vassign(1,iel)=8
                else
                  newc(iel)=2
                  vassign(1,iel)=6
                  vassign(2,iel)=8
                end if
              else
                ntemp1=sje(1,1,4,iel)
                if(cbc(5,ntemp1).eq.3.and.  &
     &             sje(1,1,5,ntemp1).lt.iel)then
                  newc(iel)=2
                  vassign(1,iel)=7
                  vassign(2,iel)=8
                else
                  newc(iel)=3
                  vassign(1,iel)=6
                  vassign(2,iel)=7
                  vassign(3,iel)=8
                end if
              end if
            end if
          elseif(cb1.eq.2.or.cb1.eq.3)then
            if(ijel(2,2,iel).eq.1)then
              ntemp=sje(1,1,2,iel)
              if(cbc(6,ntemp).eq.3.and.sje(1,1,6,ntemp).lt.iel)then
                newc(iel)=3
                vassign(1,iel)=4
                vassign(2,iel)=7
                vassign(3,iel)=8
              else
                newc(iel)=4
                vassign(1,iel)=3
                vassign(2,iel)=4
                vassign(3,iel)=7
                vassign(4,iel)=8
              end if
!...........if ijel(2,2,iel)=2
            else
              ntemp=sje(1,1,2,iel)
              if(cbc(3,ntemp).eq.3.and.sje(1,1,3,ntemp).lt.iel)then
                ntemp1=sje(1,1,6,iel)
                if(cbc(3,ntemp1).eq.3.and.  &
     &            sje(1,1,3,ntemp1).lt.iel)then
                  newc(iel)=1
                  vassign(1,iel)=8
                else
                  newc(iel)=2
                  vassign(1,iel)=4
                  vassign(2,iel)=8
                end if
              else
                ntemp1=sje(1,1,6,iel)
                if(cbc(3,ntemp1).eq.3.and.  &
     &            sje(1,1,3,ntemp1).lt.iel)then
                  newc(iel)=2
                  vassign(1,iel)=7
                  vassign(2,iel)=8
                else
                  newc(iel)=3
                  vassign(1,iel)=4
                  vassign(2,iel)=7
                  vassign(3,iel)=8
                end if
              end if
            end if
          elseif(cb2.eq.2.or.cb2.eq.3)then
            if(ijel(2,6,iel).eq.1)then
              ntemp=sje(1,1,4,iel)
              if(cbc(6,ntemp).eq.3.and.sje(1,1,6,ntemp).lt.iel)then
                newc(iel)=3
                vassign(1,iel)=4
                vassign(2,iel)=6
                vassign(3,iel)=8
              else
                newc(iel)=4
                vassign(1,iel)=2
                vassign(2,iel)=4
                vassign(3,iel)=6
                vassign(4,iel)=8
              end if
!...........if ijel(2,6,iel)=2
            else
              ntemp=sje(1,1,4,iel)
              if(cbc(1,ntemp).eq.3.and.sje(1,1,1,ntemp).lt.iel)then
                ntemp1=sje(1,1,6,iel)
                if(cbc(1,ntemp1).eq.3.and.  &
     &            sje(1,1,1,ntemp1).lt.iel)then
                  newc(iel)=1
                  vassign(1,iel)=8
                else
                  newc(iel)=2
                  vassign(1,iel)=4
                  vassign(2,iel)=8
                end if
              else
                ntemp1=sje(1,1,6,iel)
                if(cbc(1,ntemp1).eq.3.and.  &
     &              sje(1,1,1,ntemp1).lt.iel)then
                  newc(iel)=2
                  vassign(1,iel)=6
                  vassign(2,iel)=8
                else
                  newc(iel)=3
                  vassign(1,iel)=4
                  vassign(2,iel)=6
                  vassign(3,iel)=8
                end if
              end if
            end if

          end if
          
        elseif(sumcb.eq.6)then
!.......the three face type for face 2,4 and 6 are 0 0 0(not 
!       necessarily in this order)
          newc(iel)=8
          vassign(1,iel)=1
          vassign(2,iel)=2
          vassign(3,iel)=3
          vassign(4,iel)=4
          vassign(5,iel)=5
          vassign(6,iel)=6
          vassign(7,iel)=7
          vassign(8,iel)=8

        elseif(sumcb.eq.9)then
!.......the three face type for face 2,4 and 6 are 0 0 1(not 
!       necessarily in this order)
          newc(iel)=7
          vassign(1,iel)=2
          vassign(2,iel)=3
          vassign(3,iel)=4
          vassign(4,iel)=5
          vassign(5,iel)=6
          vassign(6,iel)=7
          vassign(7,iel)=8

        elseif(sumcb.eq.12)then
!.......the three face type for face 2,4 and 6 are 0 1 1(not 
!       necessarily in this order)
          if(cb.eq.0)then
            ntemp=sje(1,1,2,iel)
            if(cbc(4,ntemp).eq.3.and.sje(1,1,4,ntemp).lt.iel)then
              newc(iel)=6
              vassign(1,iel)=2
              vassign(2,iel)=3
              vassign(3,iel)=4
              vassign(4,iel)=6
              vassign(5,iel)=7
              vassign(6,iel)=8
            else
              newc(iel)=7
              vassign(1,iel)=2
              vassign(2,iel)=3
              vassign(3,iel)=4
              vassign(4,iel)=5
              vassign(5,iel)=6
              vassign(6,iel)=7
              vassign(7,iel)=8
            end if
          elseif(cb1.eq.0)then
            newc(iel)=7
            vassign(1,iel)=2
            vassign(2,iel)=3
            vassign(3,iel)=4
            vassign(4,iel)=5
            vassign(5,iel)=6
            vassign(6,iel)=7
            vassign(7,iel)=8
          elseif(cb2.eq.0)then
            ntemp=sje(1,1,4,iel)
            if(cbc(6,ntemp).eq.3.and.sje(1,1,6,ntemp).lt.iel)then
              newc(iel)=6
              vassign(1,iel)=3
              vassign(2,iel)=4
              vassign(3,iel)=5
              vassign(4,iel)=6
              vassign(5,iel)=7
              vassign(6,iel)=8
            else
              newc(iel)=7
              vassign(1,iel)=2
              vassign(2,iel)=3
              vassign(3,iel)=4
              vassign(4,iel)=5
              vassign(5,iel)=6
              vassign(6,iel)=7
              vassign(7,iel)=8
            end if
          end if
        
        elseif(sumcb.eq.15)then
!.......the three face type for face 2,4 and 6 are 1 1 1(not 
!       necessarily in this order)
          ntemp=sje(1,1,4,iel)
          ntemp1=sje(1,1,2,iel)
          if(cbc(6,ntemp).eq.3.and.sje(1,1,6,ntemp).lt.iel)then
            if(cbc(2,ntemp).eq.3.and.sje(1,1,2,ntemp).lt.iel)then
              if(cbc(6,ntemp1).eq.3.and.sje(1,1,6,ntemp1).lt.iel)then
                newc(iel)=4
                vassign(1,iel)=4
                vassign(2,iel)=6
                vassign(3,iel)=7
                vassign(4,iel)=8
              else
                newc(iel)=5
                vassign(1,iel)=3
                vassign(2,iel)=4
                vassign(3,iel)=6
                vassign(4,iel)=7
                vassign(5,iel)=8
              end if
            else
              if(cbc(6,ntemp1).eq.3.and.sje(1,1,6,ntemp1).lt.iel)then
                newc(iel)=5
                vassign(1,iel)=4
                vassign(2,iel)=5
                vassign(3,iel)=6
                vassign(4,iel)=7
                vassign(5,iel)=8
              else
                newc(iel)=6
                vassign(1,iel)=3
                vassign(2,iel)=4
                vassign(3,iel)=5
                vassign(4,iel)=6
                vassign(5,iel)=7
                vassign(6,iel)=8
              end if
            end if
          else
            if(cbc(2,ntemp).eq.3.and.sje(1,1,2,ntemp).lt.iel)then
              if(cbc(6,ntemp1).eq.3.and.sje(1,1,6,ntemp1).lt.iel)then
                newc(iel)=5
                vassign(1,iel)=2
                vassign(2,iel)=4
                vassign(3,iel)=6
                vassign(4,iel)=7
                vassign(5,iel)=8
              else
                newc(iel)=6
                vassign(1,iel)=2
                vassign(2,iel)=3
                vassign(3,iel)=4
                vassign(4,iel)=6
                vassign(5,iel)=7
                vassign(6,iel)=8
              end if
            else
              if(cbc(6,ntemp1).eq.3.and.sje(1,1,6,ntemp1).lt.iel)then
                newc(iel)=6
                vassign(1,iel)=2
                vassign(2,iel)=4
                vassign(3,iel)=5
                vassign(4,iel)=6
                vassign(5,iel)=7
                vassign(6,iel)=8

              else
                newc(iel)=7
                vassign(1,iel)=2 
                vassign(2,iel)=3 
                vassign(3,iel)=4 
                vassign(4,iel)=5
                vassign(5,iel)=6
                vassign(6,iel)=7
                vassign(7,iel)=8
              end if
            end if
          end if
        end if
      end do
!$OMP END PARALLEL DO
!.....end computing how many new mortar vertex points will be generated
!     on each element.

!.....Compute (potentially in parallel) front(iel), which records how many 
!     new mortar point indices are to be generated from element 1 to iel.
!     front(iel)=newc(1)+newc(2)+...+newc(iel)

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(iel)
      do iel=1,nelt
        front(iel)=newc(iel)
      end do
!$OMP END PARALLEL DO

      call parallel_add(front)

!.....On each element, generate new mortar point indices and assign them
!     to all elements sharing this mortar point. Note, if a mortar point 
!     is shared by several elements, the mortar point index of it will only
!     be generated on the element with the lowest element index. 

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(iel,i,count)
      do iel=1,nelt

!.......compute the starting vertex mortar point index in element iel
        front(iel)=front(iel)-newc(iel)

        do i=1,newc(iel)
!.........count is the new mortar index number, which will be assigned
!         to a vertex of iel and broadcast to all other elements sharing
!         this vertex point.
          count=front(iel)+i
          call mortar_vertex(vassign(i,iel),iel,count) 
        end do
      end do
!$OMP END PARALLEL DO

!.....nvertex records how many mortar indices are for element vertices.
!     It is used in the computation of the preconditioner.
      count=front(nelt)+newc(nelt)
      nvertex=count

!.....CONFORMING EDGE AND FACE INTERIOR

!.....find out how many new mortar point indices will be assigned to all
!.....conforming edges and all conforming face interiors on each element

      n1=12*nelt
      n2=6*nelt

!.....eassign(i,iel)=.true.   indicates that the i'th edge on iel will 
!                             generate new mortar points. 
!     ncon_edge(i,iel)=.true. indicates that the i'th edge on iel is 
!                             nonconforming
      call l_init_omp(ncon_edge,n1,.false.)
      call l_init_omp(eassign,n1,.false.)
!.....fassign(i,iel)=.true. indicates that the i'th face of iel will 
!                           generate new mortar points
      call l_init_omp(fassign,n2,.false.)

!.....newe records how many new edges are to be assigned
!     diagn(1,n,iel) records the element index of neighbor element of iel,
!                    that shares edge n of iel
!     diagn(2,n,iel) records the neighbor element diagn(1,n,iel) shares which
!                    part of edge n of iel. diagn(2,n,iel)=1 refers to left
!                    or bottom half of the edge n, diagn(2,n,iel)=2 refers
!                    to the right or top part of edge n.
!     if_1_edge(n,iel)=.true. indicates that the size of iel is smaller than 
!                    that of its neighbor connected, neighbored by edge n only

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(iel,cb1,cb2,cb3,cb4,cb5  &
!$OMP& ,cb6,ntemp)

      do iel=1,nelt
        newc(iel)=0
        newe(iel)=0
        newi(iel)=0
        cb1=cbc(1,iel)
        cb2=cbc(2,iel)
        cb3=cbc(3,iel)
        cb4=cbc(4,iel)
        cb5=cbc(5,iel)
        cb6=cbc(6,iel)

!.......on face 6

        if(cb6.eq.0)then
          if(cb4.eq.0.or.cb4.eq.1)then
!...........if face 6 is of type 0 and face 4 is of type 0 or type 1, the edge
!           shared by face 4 and 6 (edge 11) will generate new mortar point
!           indices.
            newe(iel)=newe(iel)+1
            eassign(11,iel)=.true.
          end if
          if(cb1.ne.3)then
!...........if face 1 is of type 3, the edge shared by face 6 and 1 (edge 1)
!           will generate new mortar points indices.
            newe(iel)=newe(iel)+1
            eassign(1,iel)=.true.
          end if
          if(cb3.ne.3)then
            newe(iel)=newe(iel)+1
            eassign(9,iel)=.true.
          end if
          if(cb2.eq.0.or.cb2.eq.1)then
            newe(iel)=newe(iel)+1
            eassign(5,iel)=.true.
          end if
        elseif(cb6.eq.1)then
          if(cb4.eq.0)then
            newe(iel)=newe(iel)+1
            eassign(11,iel)=.true.
          elseif(cb4.eq.1)then

!...........If face 6 and face 4 both are of type 1, ntemp is the neighbor
!           element on face 4.
            ntemp=sje(1,1,4,iel)

!...........if ntemp's face 6 is not noncoforming or the neighbor element
!           of ntemp on face 6 has an element index larger than iel, the 
!           edge shared by face 6 and 4 (edge 11) will generate new mortar
!           point indices.
            if(cbc(6,ntemp).ne.3.or.sje(1,1,6,ntemp).gt.iel)then

              newe(iel)=newe(iel)+1
              eassign(11,iel)=.true.
!.............if the face 6 of ntemp is of type 2
              if(cbc(6,ntemp).eq.2)then
!...............The neighbor element of iel, neighbored by edge 11, is 
!               sje(1,1,6,ntemp) (the neighbor element of ntemp on ntemp's
!               face 6).
                diagn(1,11,iel)=sje(1,1,6,ntemp)
!...............The neighbor element of iel, neighbored by edge 11 shares
!               the ijel(2,6,iel) part of edge 11 of iel
                diagn(2,11,iel)=ijel(2,6,iel)
!...............edge 10 of element sje(1,1,6,ntemp) (the neighbor element of 
!               ntemp on ntemp's face 6) is a nonconforming edge
                ncon_edge(10,sje(1,1,6,ntemp))=.true.
!...............if_1_edge(n,iel)=.true. indicates that iel is of a smaller
!               size than its neighbor element, neighbored by edge n of iel only.
                if_1_edge(11,iel)=.true.
              endif
              if(cbc(6,ntemp).eq.3.and.  &
     &          sje(1,1,6,ntemp).gt.iel)then
                diagn(1,11,iel)=sje(2,ijel(2,6,iel),6,ntemp)
              endif
            end if
          endif

          if(cb1.eq.0)then
            newe(iel)=newe(iel)+1
            eassign(1,iel)=.true.
          elseif(cb1.eq.1)then
            ntemp=sje(1,1,1,iel)
            if(cbc(6,ntemp).ne.3.or.sje(1,1,6,ntemp).gt.iel)then
              newe(iel)=newe(iel)+1
              eassign(1,iel)=.true.
              if(cbc(6,ntemp).eq.2)then
                diagn(1,1,iel)=sje(1,1,6,ntemp)
                diagn(2,1,iel)=ijel(1,6,iel)
                ncon_edge(7,sje(1,1,6,ntemp))=.true.
                if_1_edge(1,iel)=.true.
              endif
              if(cbc(6,ntemp).eq.3.and.  &
     &          sje(1,1,6,ntemp).gt.iel)then
                diagn(1,1,iel)=sje(ijel(1,6,iel),1,6,ntemp)
              endif
            end if
          elseif(cb1.eq.2)then
            if(ijel(2,6,iel).eq.2)then
              ntemp=sje(1,1,1,iel)
              if(cbc(6,ntemp).eq.1)then
                newe(iel)=newe(iel)+1
                eassign(1,iel)=.true.
!.............if cbc(6,ntemp)=2
              else
                if(sje(1,1,6,ntemp).gt.iel)then
                  newe(iel)=newe(iel)+1
                  eassign(1,iel)=.true.
                  diagn(1,1,iel)=sje(1,1,6,ntemp)
                end if
              end if
            else
              newe(iel)=newe(iel)+1
              eassign(1,iel)=.true.
            end if
          end if

          if(cb3.eq.0)then
            newe(iel)=newe(iel)+1
            eassign(9,iel)=.true.
          elseif(cb3.eq.1)then
            ntemp=sje(1,1,3,iel)
            if(cbc(6,ntemp).ne.3.or.sje(1,1,6,ntemp).gt.iel)then
              newe(iel)=newe(iel)+1
              eassign(9,iel)=.true.
              if(cbc(6,ntemp).eq.2)then
                diagn(1,9,iel)=sje(1,1,6,ntemp)
                diagn(2,9,iel)=ijel(2,6,iel)
                ncon_edge(12,sje(1,1,6,ntemp))=.true.
                if_1_edge(9,iel)=.true.
              endif
              if(cbc(6,ntemp).eq.3.and.  &
     &           sje(1,1,6,ntemp).gt.iel)then
                diagn(1,9,iel)=sje(2,ijel(2,6,iel),6,ntemp)
              endif
            end if
          elseif(cb3.eq.2)then
            if(ijel(1,6,iel).eq.2)then
              ntemp=sje(1,1,3,iel)
              if(cbc(6,ntemp).eq.1)then
                newe(iel)=newe(iel)+1
                eassign(9,iel)=.true.
!.............if cbc(6,ntemp)=2
              else
                if(sje(1,1,6,ntemp).gt.iel)then
                  newe(iel)=newe(iel)+1
                  eassign(9,iel)=.true.
                  diagn(1,9,iel)=sje(1,1,6,ntemp)
                end if
              end if
            else
              newe(iel)=newe(iel)+1
              eassign(9,iel)=.true.
            end if
          end if

          if(cb2.eq.0)then
            newe(iel)=newe(iel)+1
            eassign(5,iel)=.true.
          elseif(cb2.eq.1)then
            ntemp=sje(1,1,2,iel)
            if(cbc(6,ntemp).ne.3.or.sje(1,1,6,ntemp).gt.iel)then
              newe(iel)=newe(iel)+1
              eassign(5,iel)=.true.
              if(cbc(6,ntemp).eq.2)then
                diagn(1,5,iel)=sje(1,1,6,ntemp)
                diagn(2,5,iel)=ijel(1,6,iel)
                ncon_edge(3,sje(1,1,6,ntemp))=.true.
                if_1_edge(5,iel)=.true.
              endif
              if(cbc(6,ntemp).eq.3.and.  &
     &          sje(1,1,6,ntemp).gt.iel)then
                diagn(1,9,iel)=sje(2,ijel(2,6,iel),6,ntemp)
              endif
            endif
          end if
        end if

!.......one face 4
        if(cb4.eq.0)then
          if(cb1.ne.3)then
            newe(iel)=newe(iel)+1
            eassign(4,iel)=.true.
          endif
          if(cb5.ne.3)then
            newe(iel)=newe(iel)+1
            eassign(12,iel)=.true.
          endif
          if(cb2.eq.0.or.cb2.eq.1)then
            newe(iel)=newe(iel)+1
            eassign(8,iel)=.true.
          end if 
           
        elseif(cb4.eq.1)then
          if(cb1.eq.2)then
            if(ijel(2,4,iel).eq.1)then
              newe(iel)=newe(iel)+1
              eassign(4,iel)=.true.
            else
              ntemp=sje(1,1,4,iel)
              if(cbc(1,ntemp).ne.3.or.sje(1,1,1,ntemp).gt.iel)then
                newe(iel)=newe(iel)+1
                eassign(4,iel)=.true.
                if(cbc(1,ntemp).eq.3.and.  &
     &            sje(1,1,1,ntemp).gt.iel)then
                  diagn(1,4,iel)=sje(ijel(1,4,iel),2,1,ntemp) 
                endif
              endif
            end if
          elseif(cb1.eq.0)then
            newe(iel)=newe(iel)+1
            eassign(4,iel)=.true.
          elseif(cb1.eq.1)then
            ntemp=sje(1,1,4,iel)
            if(cbc(1,ntemp).ne.3.or.sje(1,1,1,ntemp).gt.iel)then
              newe(iel)=newe(iel)+1
              eassign(4,iel)=.true.
              if(cbc(1,ntemp).eq.2)then
                diagn(1,4,iel)=sje(1,1,1,ntemp)
                diagn(2,4,iel)=ijel(1,4,iel)
                ncon_edge(6,sje(1,1,1,ntemp))=.true.
                if_1_edge(4,iel)=.true.
              endif
              if(cbc(1,ntemp).eq.3.and.  &
     &          sje(1,1,1,ntemp).gt.iel)then
                diagn(1,4,iel)=sje(ijel(1,4,iel),2,1,ntemp)
              endif
            end if
          end if
          if(cb5.eq.2)then
            if(ijel(1,4,iel).eq.1)then
              newe(iel)=newe(iel)+1
              eassign(12,iel)=.true.
            else
              ntemp=sje(1,1,4,iel)
              if(cbc(5,ntemp).ne.3.or.sje(1,1,5,ntemp).gt.iel)then
                newe(iel)=newe(iel)+1
                eassign(12,iel)=.true.
                if(cbc(5,ntemp).eq.3.and.  &
     &            sje(1,1,5,ntemp).gt.iel)then
                  diagn(1,12,iel)=sje(2,ijel(2,4,iel),5,ntemp)
                endif
              endif
            end if
          elseif(cb5.eq.0)then
            newe(iel)=newe(iel)+1
            eassign(12,iel)=.true.
          elseif(cb5.eq.1)then
            ntemp=sje(1,1,4,iel)
            if(cbc(5,ntemp).ne.3.or.sje(1,1,5,ntemp).gt.iel)then
              newe(iel)=newe(iel)+1
              eassign(12,iel)=.true.
              if(cbc(5,ntemp).eq.2)then
                diagn(1,12,iel)=sje(1,1,5,ntemp)
                diagn(2,12,iel)=ijel(2,4,iel)
                ncon_edge(9,sje(1,1,5,ntemp))=.true.
                if_1_edge(12,iel)=.true.
              endif
              if(cbc(5,ntemp).eq.3.and.  &
     &          sje(1,1,5,ntemp).gt.iel)then
                diagn(1,12,iel)=sje(2,ijel(2,4,iel),5,ntemp)
              endif
            end if
          end if
          if(cb2.eq.0)then
            newe(iel)=newe(iel)+1
            eassign(8,iel)=.true.
          elseif(cb2.eq.1)then
            ntemp=sje(1,1,4,iel)
            if(cbc(2,ntemp).ne.3.or.sje(1,1,2,ntemp).gt.iel)then
              newe(iel)=newe(iel)+1
              eassign(8,iel)=.true.
              if(cbc(2,ntemp).eq.2)then
                diagn(1,8,iel)=sje(1,1,2,ntemp)
                diagn(2,8,iel)=ijel(1,4,iel)
                ncon_edge(2,sje(1,1,2,ntemp))=.true.
                if_1_edge(8,iel)=.true.
              endif
              if(cbc(2,ntemp).eq.3.and.  &
     &          sje(1,1,2,ntemp).gt.iel)then
                diagn(1,8,iel)=sje(ijel(1,4,iel),2,3,ntemp)
              endif
            endif
          end if
        end if

!.......on face 2
        if(cb2.eq.0)then
          if(cb3.ne.3)then
            newe(iel)=newe(iel)+1
            eassign(6,iel)=.true.
          endif
          if(cb5.ne.3)then
            newe(iel)=newe(iel)+1
            eassign(7,iel)=.true.
          endif
        elseif(cb2.eq.1)then
          if(cb3.eq.2)then
            if(ijel(2,2,iel).eq.1)then
              newe(iel)=newe(iel)+1
              eassign(6,iel)=.true.
            else
              ntemp=sje(1,1,2,iel)
              if(cbc(3,ntemp).ne.3.or.  &
     &          sje(1,1,3,ntemp).gt.iel)then
                newe(iel)=newe(iel)+1
                eassign(6,iel)=.true.
                if(cbc(3,ntemp).eq.3.and.  &
     &            sje(1,1,3,ntemp).gt.iel)then
                  diagn(1,6,iel)=sje(ijel(1,2,iel),2,3,ntemp)
                endif
              endif
            endif
          elseif(cb3.eq.0)then
            newe(iel)=newe(iel)+1
            eassign(6,iel)=.true.
          elseif(cb3.eq.1)then
            ntemp=sje(1,1,2,iel)
            if(cbc(3,ntemp).ne.3.or.sje(1,1,3,ntemp).gt.iel)then
              newe(iel)=newe(iel)+1
              eassign(6,iel)=.true.
              if(cbc(3,ntemp).eq.2)then
                diagn(1,6,iel)=sje(1,1,3,ntemp)
                diagn(2,6,iel)=ijel(1,2,iel)
                ncon_edge(4,sje(1,1,3,ntemp))=.true.
                if_1_edge(6,iel)=.true.
              endif
              if(cbc(3,ntemp).eq.3.and.  &
     &          sje(1,1,3,ntemp).gt.iel)then
                diagn(1,6,iel)=sje(ijel(1,4,iel),2,3,ntemp)
              endif
            endif
          endif
          if(cb5.eq.2)then
            if(ijel(1,2,iel).eq.1)then
              newe(iel)=newe(iel)+1
              eassign(7,iel)=.true.
            else
              ntemp=sje(1,1,2,iel)
              if(cbc(5,ntemp).ne.3.or.sje(1,1,5,ntemp).gt.iel)then
                newe(iel)=newe(iel)+1
                eassign(7,iel)=.true.
                if(cbc(5,ntemp).eq.3.and.  &
     &            sje(1,1,5,ntemp).gt.iel)then
                  diagn(1,7,iel)=sje(ijel(2,2,iel),2,5,ntemp)
                endif
              endif
            endif
          elseif(cb5.eq.0)then
            newe(iel)=newe(iel)+1
            eassign(7,iel)=.true.
          elseif(cb5.eq.1)then
            ntemp=sje(1,1,2,iel)
            if(cbc(5,ntemp).ne.3.or.sje(1,1,5,ntemp).gt.iel)then
              newe(iel)=newe(iel)+1
              eassign(7,iel)=.true.
              if(cbc(5,ntemp).eq.2)then
                diagn(1,7,iel)=sje(1,1,5,ntemp)
                diagn(2,7,iel)=ijel(2,2,iel)
                ncon_edge(1,sje(1,1,5,ntemp))=.true.
                if_1_edge(7,iel)=.true.
              endif
              if(cbc(5,ntemp).eq.3.and.  &
     &          sje(1,1,5,ntemp).gt.iel)then
                diagn(1,7,iel)=sje(2,ijel(2,4,iel),5,ntemp)
              endif
            endif
          endif
        end if

!.......on face 1
        if(cb1.eq.1)then
          newe(iel)=newe(iel)+2
          eassign(2,iel)=.true.
          if(cb3.eq.1)then
            ntemp=sje(1,1,1,iel)
            if(cbc(3,ntemp).eq.2)then
              diagn(1,2,iel)=sje(1,1,3,ntemp)
              diagn(2,2,iel)=ijel(1,1,iel)
              ncon_edge(8,sje(1,1,3,ntemp))=.true.
              if_1_edge(2,iel)=.true.
            elseif(cbc(3,ntemp).eq.3)then
              diagn(1,2,iel)=sje(ijel(1,1,iel),1,3,ntemp)
            endif
          elseif(cb3.eq.2)then
            ntemp=sje(1,1,3,iel)
            if(ijel(2,1,iel).eq.2)then
              if(cbc(1,ntemp).eq.2)then
                diagn(1,2,iel)=sje(1,1,1,ntemp)
              end if
            endif
          end if

          eassign(3,iel)=.true.
          if(cb5.eq.1)then
            ntemp=sje(1,1,1,iel)
            if(cbc(5,ntemp).eq.2)then
              diagn(1,3,iel)=sje(1,1,5,ntemp)
              diagn(2,3,iel)=ijel(2,1,iel)
              ncon_edge(5,sje(1,1,5,ntemp))=.true.
              if_1_edge(3,iel)=.true.
            elseif(cbc(5,ntemp).eq.3)then
              diagn(1,3,iel)=sje(ijel(2,1,iel),1,5,ntemp)
            endif
          elseif(cb5.eq.2)then
            ntemp=sje(1,1,5,iel)
            if(ijel(1,1,iel).eq.2)then
              if(cbc(1,ntemp).eq.2)then
                diagn(1,3,iel)=sje(1,1,1,ntemp)
              end if
            endif
            
          end if
        elseif(cb1.eq.2)then
          if(cb3.eq.2)then
            ntemp=sje(1,1,1,iel)
            if(cbc(3,ntemp).ne.3)then
              newe(iel)=newe(iel)+1
              eassign(2,iel)=.true.
              if(cbc(3,ntemp).eq.2)then
                diagn(1,2,iel)=sje(1,1,3,ntemp)
              endif 
            endif
          elseif(cb3.eq.0.or.cb3.eq.1)then
            newe(iel)=newe(iel)+1
            eassign(2,iel)=.true.
            if(cb3.eq.1)then
              ntemp=sje(1,1,1,iel)
              if(cbc(3,ntemp).eq.2)then
                diagn(1,2,iel)=sje(1,1,3,ntemp)
              endif
            endif
          end if
          if(cb5.eq.2)then
            ntemp=sje(1,1,1,iel)
            if(cbc(5,ntemp).ne.3)then
              newe(iel)=newe(iel)+1
              eassign(3,iel)=.true.
              if(cbc(5,ntemp).eq.2)then
                diagn(1,3,iel)=sje(1,1,5,ntemp)
              endif
            endif
          elseif(cb5.eq.0.or.cb5.eq.1)then
            newe(iel)=newe(iel)+1
            eassign(3,iel)=.true.
            if(cb5.eq.1)then
              ntemp=sje(1,1,1,iel)
              if(cbc(5,ntemp).eq.2)then
                diagn(1,3,iel)=sje(1,1,5,ntemp)
              endif
            endif
          end if
        elseif(cb1.eq.0)then
          if(cb3.ne.3)then
            newe(iel)=newe(iel)+1
            eassign(2,iel)=.true.
          endif
          if(cb5.ne.3)then
            newe(iel)=newe(iel)+1
            eassign(3,iel)=.true.
          endif
        endif

!.......on face 3
        if(cb3.eq.1)then
          newe(iel)=newe(iel)+1
          eassign(10,iel)=.true.
          if(cb5.eq.1)then
            ntemp=sje(1,1,3,iel)
            if(cbc(5,ntemp).eq.2)then
              diagn(1,10,iel)=sje(1,1,5,ntemp)
              diagn(2,10,iel)=ijel(2,3,iel)
              ncon_edge(11,sje(1,1,5,ntemp))=.true.
              if_1_edge(10,iel)=.true.
            endif
          endif
          if(ijel(1,3,iel).eq.2)then
            ntemp=sje(1,1,3,iel)
            if(cbc(5,ntemp).eq.3)then
              diagn(1,10,iel)=sje(1,ijel(2,3,iel),5,ntemp)
            endif
          endif
        elseif(cb3.eq.2)then
          if(cb5.eq.2)then
            ntemp=sje(1,1,3,iel)
            if(cbc(5,ntemp).ne.3)then
              newe(iel)=newe(iel)+1
              eassign(10,iel)=.true.
              if(cbc(5,ntemp).eq.2)then
                diagn(1,10,iel)=sje(1,1,5,ntemp)
              endif
            endif
          elseif(cb5.eq.0.or.cb5.eq.1)then
            newe(iel)=newe(iel)+1
            eassign(10,iel)=.true.
            if(cb5.eq.1)then
              ntemp=sje(1,1,3,iel)
              if(cbc(5,ntemp).eq.2)then
                diagn(1,10,iel)=sje(1,1,5,ntemp)
              endif 
            endif
          end if
        elseif(cb3.eq.0)then
          if(cb5.ne.3)then
            newe(iel)=newe(iel)+1
            eassign(10,iel)=.true.
          endif
        endif

!       CONFORMING FACE INTERIOR

!.......find how many new mortar point indices will be assigned
!       to face interiors on all faces on each element

!.......newi record how many new face interior points will be assigned

!.......on face 6
        if(cb6.eq.1.or.cb6.eq.0)then
          newi(iel)=newi(iel)+9
          fassign(6,iel)=.true.
        end if
!.......on face 4
        if(cb4.eq.1.or.cb4.eq.0)then
          newi(iel)=newi(iel)+9
          fassign(4,iel)=.true.
        end if
!.......on face 2
        if(cb2.eq.1.or.cb2.eq.0)then
          newi(iel)=newi(iel)+9
          fassign(2,iel)=.true.
        end if
!.......on face 1
        if(cb1.ne.3)then
          newi(iel)=newi(iel)+9
          fassign(1,iel)=.true.
        end if
!.......on face 3
        if(cb3.ne.3)then
          newi(iel)=newi(iel)+9
          fassign(3,iel)=.true.
        endif
!.......on face 5
        if(cb5.ne.3)then
          newi(iel)=newi(iel)+9
          fassign(5,iel)=.true.
        endif

!.......newc is the total number of new mortar point indices
!       to be assigned to each element.
        newc(iel)=newe(iel)*3+newi(iel)
      end do
!$OMP END PARALLEL DO

!.....Compute (potentially in parallel) front(iel), which records how 
!     many new mortar point indices are to be assigned (to conforming 
!     edges and conforming face interiors) from element 1 to iel.
!     front(iel)=newc(1)+newc(2)+...+newc(iel)

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(iel)
      do iel=1,nelt
        front(iel)=newc(iel)
      end do
!$OMP END PARALLEL DO

      call parallel_add(front)

!.....nmor is the total number or mortar points
      nmor=nvertex+front(nelt)

!.....Generate (potentially in parallel) new mortar point indices on 
!     each conforming element face. On each face, first visit all 
!     conforming edges, and then the face interior.

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(iel,count,i,cb1,ne,  &
!$OMP& space,ie,edge_g,face2,ie2,ntemp,ii,jj,jface,cb,mor_v)
      do iel=1,nelt
        front(iel)=front(iel)-newc(iel)
        count=nvertex+front(iel)
        do i=1,6
          cb1=cbc(i,iel)
          if (i.le.2) then
            ne=4
            space=1
          elseif (i.le.4)then
            ne=3
            space=2

!.........i loops over faces. Only 4 faces need to be examed for edge visit.
!         On face 1, edge 1,2,3 and 4 will be visited. On face 2, edge 5,6,7
!         and 8 will be visited. On face 3, edge 9 and 10 will be visited and
!         on face 4, edge 11 and 12 will be visited. The 12 edges can be 
!         covered by four faces, there is no need to visit edges on face
!         5 and 6.  So ne is set to be 0. 
!         However, i still needs to loop over 5 and 6, since the interiors
!         of face 5 and 6 still need to be visited.

          else
            ne=0
            space=1
          end if

          do ie=1,ne,space
            edge_g=edgenumber(ie,i)
            if(eassign(edge_g,iel))then
!.............generate the new mortar points index, mor_v
              call mor_assign(mor_v,count)
!.............assign mor_v to local edge ie of face i on element iel
              call mor_edge(ie,i,iel,mor_v)

!.............Since this edge is shared by another face of element 
!             iel, assign mor_v to the corresponding edge on the other 
!             face also.

!.............find the other face
              face2=f_e_ef(ie,i)
!.............find the local edge index of this edge on the other face
              ie2=localedgenumber(face2,edge_g)
!.............asssign mor_v  to local edge ie2 of face face2 on element iel
              call mor_edge(ie2,face2,iel,mor_v)

!.............There are some neighbor elements also sharing this edge. Assign
!             mor_v to neighbor element, neighbored by face i.
              if (cbc(i,iel).eq.2)then
                ntemp=sje(1,1,i,iel)
                call mor_edge(ie,jjface(i),ntemp,mor_v)
                call mor_edge(op(ie2),face2,ntemp,mor_v)
              end if

!.............assign mor_v  to neighbor element neighbored by face face2
              if (cbc(face2,iel).eq.2)then
                ntemp=sje(1,1,face2,iel)
                call mor_edge(ie2,jjface(face2),ntemp,mor_v)
                call mor_edge(op(ie),i,ntemp,mor_v)
              end if

!.............assign mor_v to neighbor element sharing this edge

!.............if the neighbor is of the same size of iel
              if(.not.if_1_edge(edgenumber(ie,i),iel))then
                if(diagn(1,edgenumber(ie,i),iel).ne.0)then
                  ntemp=diagn(1,edgenumber(ie,i),iel)
                  call mor_edge(op(ie2),jjface(face2),ntemp,mor_v)
                  call mor_edge(op(ie),jjface(i),ntemp,mor_v)
                endif

!.............if the neighbor has a size larger than iel's
              else
                if(diagn(1,edgenumber(ie,i),iel).ne.0)then
                  ntemp=diagn(1,edgenumber(ie,i),iel)
                  call mor_ne(mor_v,diagn(2,edgenumber(ie,i),iel),  &
     &            ie,i,ie2,face2,iel,ntemp)
                end if
              endif
 
            endif
          end do 

          if(fassign(i,iel))then
!...........generate new mortar points index in face interior. 
!           if face i is of type 2 or iel doesn't have a neighbor element,
!           assign new mortar point indices to interior mortar points
!           of face i of iel.
            cb=cbc(i,iel)
            if (cb.eq.1.or.cb.eq.0) then
              do jj =2,lx1-1
                do ii=2,lx1-1
                  count=count+1
                  idmo(ii,jj,1,1,i,iel)=count
                end do
              end do

!...........if face i is of type 2, assign new mortar point indices
!           to iel as well as to the neighboring element on face i
            elseif (cb.eq.2) then
              if (idmo(2,2,1,1,i,iel).eq.0) then
                ntemp=sje(1,1,i,iel)
                jface = jjface(i)
                do jj =2,lx1-1
                  do ii=2,lx1-1
                    count=count+1
                    idmo(ii,jj,1,1,i,iel)=count
                    idmo(ii,jj,1,1,jface,ntemp)=count
                  end do
                end do
              end if 
            end if
          end if
        end do
      end do 
!$OMP END  PARALLEL DO

 
!.....for edges on nonconforming faces, copy the mortar points indices
!     from neighbors.
!$OMP PARALLEL DO DEFAULT(SHARED)  &
!$OMP& PRIVATE(iel,i,cb,jface,iii,jjj,ntemp,ii,jj)
      do iel=1,nelt
        do i=1,6
          cb=cbc(i,iel)
          if (cb.eq.3) then
!...........edges 
            call edgecopy_s(i,iel)
          end if 

!.........face interior 

          jface = jjface(i)
          if (cb.eq.3) then
            do iii=1,2
              do jjj=1,2
                ntemp=sje(iii,jjj,i,iel) 
                do jj =1,lx1
                  do ii=1,lx1
                    idmo(ii,jj,iii,jjj,i,iel)=  &
     &                         idmo(ii,jj,1,1,jface,ntemp)
                  end do
                end do
                idmo(1,1,iii,jjj,i,iel)=idmo(1,1,1,1,jface,ntemp)
                idmo(lx1,1,iii,jjj,i,iel)=idmo(lx1,1,1,2,jface,ntemp)
                idmo(1,lx1,iii,jjj,i,iel)=idmo(1,lx1,2,1,jface,ntemp)
                idmo(lx1,lx1,iii,jjj,i,iel)=  &
     &                         idmo(lx1,lx1,2,2,jface,ntemp)
              end do
            end do
          end if
        end do
      end do
!$OMP END PARALLEL DO
      return
      end
       
!-----------------------------------------------------------------
       subroutine get_emo(ie,n,ng)
!-----------------------------------------------------------------
!      This subroutine fills array emo.
!      emo  records all elements sharing the same mortar point 
!                 (only applies to element vertices) .
!      emo(1,i,n) gives the element ID of the i'th element sharing
!                 mortar point n. (emo(1,i,n)=ie), ie is element
!                 index.
!      emo(2,i,n) gives the vertex index of mortar point n on this
!                 element (emo(2,i,n)=ng), ng is the vertex index.
!      nemo(n) records the total number of elements sharing mortar 
!                 point n.
!-----------------------------------------------------------------
 
       use ua_data
       implicit none

       integer ie, n, ntemp, i,ng

       do i=1,nemo(n)
         if (emo(1,i,n).eq.ie) return
       end do

!$     call omp_set_lock(tlock(n))
       ntemp=nemo(n)+1
       nemo(n)=ntemp
       emo(1,ntemp,n)=ie
       emo(2,ntemp,n)=ng
!$     call omp_unset_lock(tlock(n))

       return
       end 

!-----------------------------------------------------------------
      logical function ifsame(ntemp,j,iel,i)
!-----------------------------------------------------------------
!     Check whether the i's vertex of element iel is at the same
!     location as j's vertex of element ntemp.
!-----------------------------------------------------------------

      use ua_data
      implicit none

      integer iel, i, ntemp, j

      ifsame=.false.
      if (ntemp.eq.0 .or. iel.eq.0) return
      if (xc(i,iel).eq.xc(j,ntemp).and.  &
     &    yc(i,iel).eq.yc(j,ntemp).and.  &
     &    zc(i,iel).eq.zc(j,ntemp)) then
        ifsame=.true.
      end if

      return
      end

!-----------------------------------------------------------------
      subroutine mor_assign(mor_v,count)
!-----------------------------------------------------------------
!     Assign three consecutive numbers for mor_v, which will
!     be assigned to the three interior points of an edge as the 
!     mortar point indices.
!-----------------------------------------------------------------
      
      implicit none
      integer mor_v(3),count,i
   
      do i=1,3 
        count=count+1
        mor_v(i)=count
      end do

      return
      end  
     
!-----------------------------------------------------------------
      subroutine mor_edge(ie,face,iel,mor_v)
!-----------------------------------------------------------------
!     Copy the mortar points index from mor_v to local 
!     edge ie of the face'th face on element iel.
!     The edge is conforming.
!-----------------------------------------------------------------

      use ua_data
      implicit none

      integer ie,i,iel,mor_v(3),j,nn,face

      if (ie.eq.1) then
        j=1
        do nn=2,lx1-1
          idmo(nn,j,1,1,face,iel)=mor_v(nn-1)
        end do
      elseif (ie.eq.2) then 
        i=lx1
        do nn=2,lx1-1
          idmo(i,nn,1,1,face,iel)=mor_v(nn-1)
        end do
      elseif (ie.eq.3) then 
        j=lx1
        do nn=2,lx1-1
          idmo(nn,j,1,1,face,iel)=mor_v(nn-1)
        end do
      elseif (ie.eq.4) then 
        i=1
        do nn=2,lx1-1
          idmo(i,nn,1,1,face,iel)=mor_v(nn-1)
        end do
      end if

      return
      end 

!------------------------------------------------------------
      subroutine edgecopy_s(face,iel)
!------------------------------------------------------------
!     Copy mortar points index on edges from neighbor elements 
!     to an element face of the 3rd type.
!------------------------------------------------------------

       use ua_data
       implicit none

       integer face, iel, ntemp1, ntemp2, ntemp3, ntemp4,  &
     &         edge_g, edge_l, face2, mor_s_v(4,2), i

!......find four neighbors on this face (3rd type)
       ntemp1=sje(1,1,face,iel)
       ntemp2=sje(1,2,face,iel)
       ntemp3=sje(2,1,face,iel)
       ntemp4=sje(2,2,face,iel)

!......local edge 1

!......mor_s_v is the array of mortar indices to  be copied.
       call nrzero(mor_s_v,4*2)
       do i=2,lx1-1
          mor_s_v(i-1,1)=idmo(i,1,1,1,jjface(face),ntemp1)
       end do
       mor_s_v(lx1-1,1)=idmo(lx1,1,1,2,jjface(face),ntemp1)
       do i=1,lx1-1
          mor_s_v(i,2)=idmo(i,1,1,1,jjface(face),ntemp2)
       end do

!......copy mor_s_v to local edge 1 on this face
       call mor_s_e(1,face,iel,mor_s_v)

!......copy mor_s_v to the corresponding edge on the other face sharing
!      local edge 1
       face2=f_e_ef(1,face)
       edge_g=edgenumber(1,face)
       edge_l=localedgenumber(face2,edge_g)
       call mor_s_e(edge_l,face2,iel,mor_s_v)

!......local edge 2
       do i=2,lx1-1
          mor_s_v(i-1,1)=idmo(lx1,i,1,1,jjface(face),ntemp2)
       end do
       mor_s_v(lx1-1,1)=idmo(lx1,lx1,2,2,jjface(face),ntemp2)

       mor_s_v(1,2)=idmo(lx1,1,1,2,jjface(face),ntemp4)
       do i=2,lx1-1
          mor_s_v(i,2)=idmo(lx1,i,1,1,jjface(face),ntemp4)
       end do

       call mor_s_e(2,face,iel,mor_s_v)
       face2=f_e_ef(2,face)
       edge_g=edgenumber(2,face)
       edge_l=localedgenumber(face2,edge_g)
       call mor_s_e(edge_l,face2,iel,mor_s_v)

!......local edge 3
       do i=2,lx1-1
          mor_s_v(i-1,1)=idmo(i,lx1,1,1,jjface(face),ntemp3)
       end do
       mor_s_v(lx1-1,1)=idmo(lx1,lx1,2,2,jjface(face),ntemp3)

       mor_s_v(1,2)=idmo(1,lx1,2,1,jjface(face),ntemp4)
       do i=2,lx1-1
          mor_s_v(i,2)=idmo(i,lx1,1,1,jjface(face),ntemp4)
       end do

       call mor_s_e(3,face,iel,mor_s_v)
       face2=f_e_ef(3,face)
       edge_g=edgenumber(3,face)
       edge_l=localedgenumber(face2,edge_g)
       call mor_s_e(edge_l,face2,iel,mor_s_v)

!......local edge 4
       do i=2,lx1-1
          mor_s_v(i-1,1)=idmo(1,i,1,1,jjface(face),ntemp1)
       end do
       mor_s_v(lx1-1,1)=idmo(1,lx1,2,1,jjface(face),ntemp1)

       do i=1,lx1-1
          mor_s_v(i,2)=idmo(1,i,1,1,jjface(face),ntemp3)
       end do

       call mor_s_e(4,face,iel,mor_s_v)
       face2=f_e_ef(4,face)
       edge_g=edgenumber(4,face)
       edge_l=localedgenumber(face2,edge_g)
       call mor_s_e(edge_l,face2,iel,mor_s_v)

       return
       end

!------------------------------------------------------------
       subroutine mor_s_e(n,face,iel,mor_s_v)
!------------------------------------------------------------
!      Copy mortar points index from mor_s_v to local edge n
!      on face "face" of element iel. The edge is nonconforming. 
!------------------------------------------------------------

       use ua_data
       implicit none

       integer n,face,iel,mor_s_v(4,2), i

       if (n.eq.1) then
         do i=2,lx1
           idmo(i,1,1,1,face,iel)=mor_s_v(i-1,1)
         end do
         do i=1,lx1-1
           idmo(i,1,1,2,face,iel)=mor_s_v(i,2)
         end do
       else if (n.eq.2) then
         do i=2,lx1
          idmo(lx1,i,1,2,face,iel)=mor_s_v(i-1,1)
         end do
         do i=1,lx1-1
          idmo(lx1,i,2,2,face,iel)=mor_s_v(i,2)
         end do
       else if (n.eq.3) then
         do i=2,lx1
           idmo(i,lx1,2,1,face,iel)=mor_s_v(i-1,1)
         end do
         do i=1,lx1-1
           idmo(i,lx1,2,2,face,iel)=mor_s_v(i,2)
         end do
       else if (n.eq.4) then
         do i=2,lx1
           idmo(1,i,1,1,face,iel)=mor_s_v(i-1,1)
         end do
         do i=1,lx1-1
           idmo(1,i,2,1,face,iel)=mor_s_v(i,2)
         end do
       end if
       return
       end

!------------------------------------------------------------
       subroutine mor_s_e_nn(n,face,iel,mor_s_v,nn)
!------------------------------------------------------------
!      Copy mortar point indices from mor_s_v to local edge n
!      on face "face" of element iel. nn is the edge mortar index,
!      which indicates that mor_s_v  corresponds to left/bottom or 
!      right/top part of the edge.
!------------------------------------------------------------

       use ua_data
       implicit none

       integer n,face,iel,mor_s_v(4), i,nn

       if (n.eq.1) then
         if(nn.eq.1)then
            do i=2,lx1
              idmo(i,1,1,1,face,iel)=mor_s_v(i-1)
            end do
         else
           do i=1,lx1-1
             idmo(i,1,1,2,face,iel)=mor_s_v(i)
           end do
         endif
       else if (n.eq.2) then
         if(nn.eq.1)then
           do i=2,lx1
            idmo(lx1,i,1,2,face,iel)=mor_s_v(i-1)
           end do
         else
           do i=1,lx1-1
            idmo(lx1,i,2,2,face,iel)=mor_s_v(i)
           end do
         endif
       else if (n.eq.3) then
         if(nn.eq.1)then
           do i=2,lx1
             idmo(i,lx1,2,1,face,iel)=mor_s_v(i-1)
           end do
         else
           do i=1,lx1-1
            idmo(i,lx1,2,2,face,iel)=mor_s_v(i)
           end do
         endif
       else if (n.eq.4) then
         if(nn.eq.1)then
           do i=2,lx1
            idmo(1,i,1,1,face,iel)=mor_s_v(i-1)
           end do
         else
           do i=1,lx1-1
            idmo(1,i,2,1,face,iel)=mor_s_v(i)
           end do
         endif
       end if
       return
       end


!---------------------------------------------------------------
      subroutine mortar_vertex(i,iel,count)
!---------------------------------------------------------------
!     Assign mortar point index "count" to iel's i'th vertex
!     and also to all elements sharing this vertex.
!---------------------------------------------------------------

      use ua_data
      implicit none

      integer i,iel,count,ntempx(8),ifntempx(8),lc_a(3),nnb(3),  &
     &        face_a(3),itemp,ntemp,ii, jj,j(3),  &
     &        iintempx(3),l,nbe, lc, temp
      logical ifsame,if_temp

      do l= 1,8
        ntempx(l)=0
        ifntempx(l)=0
      end do

!.....face_a records the three faces sharing this vertex on iel.
!     lc_a gives the local corner number of this vertex on each 
!     face in face_a.

      do l=1,3
        face_a(l)=f_c(l,i)
        lc_a(l)=local_corner(i,face_a(l))
      end do

!.....each vertex is shared by at most 8 elements. 
!     ntempx(j) gives the element index of a POSSIBLE element with its 
!               j'th  vertex is iel's i'th vertex
!     ifntempx(i)=ntempx(i) means  ntempx(i) exists 
!     ifntempx(i)=0 means ntempx(i) does not exist.

      ntempx(9-i)=iel
      ifntempx(9-i)=iel

!.....first find all elements sharing this vertex, ifntempx

!.....find the three possible neighbors of iel, neighbored by faces 
!     listed in array face_a

      do itemp= 1, 3

!.......j(itemp) is the local corner number of this vertex on the 
!       neighbor element on the corresponding face.
        j(itemp)=c_f(lc_a(itemp),jjface(face_a(itemp)))

!.......iitempx(itemp) records the vertex index of i on the
!       neighbor element, neighborned by face_a(itemp)
        iintempx(itemp)=cal_intempx(lc_a(itemp),face_a(itemp))

!.......ntemp refers the neighbor element 
        ntemp=0

!.......if the face is nonconforming, find out in which piece of the 
!       mortar the vertex is located
        ii=cal_iijj(1,lc_a(itemp))
        jj=cal_iijj(2,lc_a(itemp))
        ntemp=sje(ii,jj,face_a(itemp),iel)

!.......if the face is conforming
        if(ntemp.eq.0)then
          ntemp=sje(1,1,face_a(itemp),iel)
!.........find the possible neighbor        
          ntempx(iintempx(itemp))=ntemp
!.........check whether this possible neighbor is a real neighbor or not
          if(ntemp.ne.0)then
            if(ifsame(ntemp,j(itemp),iel,i))then
              ifntempx(iintempx(itemp))=ntemp
            end if
          end if

!.......if the face is nonconforming
        else
          if(ntemp.ne.0)then
            if(ifsame(ntemp,j(itemp),iel,i))then
              ifntempx(iintempx(itemp))=ntemp
              ntempx(iintempx(itemp))=ntemp
            end if
          end if
        end if 
      end do 

!.....find the possible three neighbors, neighbored by an edge only
      do l=1,3

!.....find first existing neighbor of any of the faces in array face_a
        if_temp=.false.
        if(l.eq.1)then
          if_temp=.true.
        elseif(l.eq.2)then
          if(ifntempx(iintempx(l-1)).eq.0)then
            if_temp=.true.
          end if
        elseif(l.eq.3)then
          if(ifntempx(iintempx(l-1)).eq.0  &
     &       .and.ifntempx(iintempx(l-2)).eq.0) then
            if_temp=.true.
          end if
        end if
           
        if(if_temp)then
          if (ifntempx(iintempx(l)).ne.0) then
            nbe=ifntempx(iintempx(l))
!...........if 1st neighor exists, check the neighbor's two neighbors in
!           the other two directions. 
!           e.g. if l=1, check directions 2 and 3,i.e. itemp=2,3,1
!           if l=2, itemp=3,1,-2
!           if l=3, itemp=1,2,1
!
            do itemp=face_l1(l),face_l2(l),face_ld(l)
!.............lc is the local corner number of this vertex on face face_a(itemp)
!             on the neighbor element of iel, neighbored by a face face_a(l)
              lc=local_corner(j(l),face_a(itemp))
!.............temp is the vertex index of this vertex on the neighbor element
!             neighbored by an edge
              temp=cal_intempx(lc,face_a(itemp))
              ii=cal_iijj(1,lc)
              jj=cal_iijj(2,lc)
              ntemp=sje(ii,jj,face_a(itemp),nbe)

!.............if the face face_a(itemp) is conforming
              if(ntemp.eq.0)then
                ntemp=sje(1,1,face_a(itemp),nbe)
                if(ntemp.ne.0)then
                  if(ifsame(ntemp,c_f(lc,jjface(face_a(itemp))),  &
     &            nbe,j(l)))then
                    ntempx(temp)=ntemp
                    ifntempx(temp)=ntemp
!...................nnb(itemp) records the neighbor element neighbored by an
!                   edge only
                    nnb(itemp)=ntemp
                  end if
                end if

!.............if the face face_a(itemp) is nonconforming
              else
                if(ntemp.ne.0)then
                  if(ifsame(ntemp,c_f(lc,jjface(face_a(itemp))),  &
     &              nbe,j(l)))then
                    ntempx(temp)=ntemp
                    ifntempx(temp)=ntemp
                    nnb(itemp)=ntemp
                  end if
                end if
              end if
            end do

!...........check the last neighbor element, neighbored by an edge

!...........ifntempx(iintempx(l)) has been visited in the above, now 
!           check another neighbor element(nbe) neighbored by a face 

!...........if the neighbor element is neighbored by face 
!           face_a(face_l1(l)) exists
            if(ifntempx(iintempx(face_l1(l))).ne.0)then
              nbe=ifntempx(iintempx(face_l1(l)))
!.............itemp is the last direction other than l and face_l1(l)
              itemp=face_l2(l)
              lc=local_corner(j(face_l1(l)),face_a(itemp))
              temp=cal_intempx(lc,face_a(itemp))
              ii=cal_iijj(1,lc)
              jj=cal_iijj(2,lc)

!.............ntemp records the last neighbor element neighbored by an edge
!             with element iel
              ntemp=sje(ii,jj,face_a(itemp),nbe)
!.............if conforming
              if(ntemp.eq.0)then
                ntemp=sje(1,1,face_a(itemp),nbe)
                if(ntemp.ne.0)then
                  if(ifsame(ntemp,c_f(lc,jjface(face_a(itemp))),  &
     &              nbe,j(face_l1(l))))then
                    ntempx(temp)=ntemp
                    ifntempx(temp)=ntemp
                    nnb(l)=ntemp
                  end if
                end if
!.............if nonconforming
              else
                if(ntemp.ne.0)then
                  if(ifsame(ntemp,c_f(lc,jjface(face_a(itemp))),  &
     &            nbe,j(face_l1(l))))then
                    ntempx(temp)=ntemp
                    ifntempx(temp)=ntemp
                    nnb(l)=ntemp
                  end if
                end if
              end if

!...........if the neighbor element neighbored by face face_a(face_l2(l)) 
!           does not exist
            elseif(ifntempx(iintempx(face_l2(l))).ne.0)then
              nbe=ifntempx(iintempx(face_l2(l)))
              itemp=face_l1(l)
              lc=local_corner(j(face_l2(l)),face_a(itemp))
              temp=cal_intempx(lc,face_a(itemp))
              ii=cal_iijj(1,lc)
              jj=cal_iijj(2,lc)
              ntemp=sje(ii,jj,face_a(itemp),nbe)
              if(ntemp.eq.0)then
                ntemp=sje(1,1,face_a(itemp),nbe)
                if(ntemp.ne.0)then
                  if(ifsame(ntemp,c_f(lc,jjface(face_a(itemp))),  &
     &            nbe,j(face_l2(l))))then
                    ntempx(temp)=ntemp
                    ifntempx(temp)=ntemp
                    nnb(l)=ntemp
                  end if
                end if
              else
                if(ntemp.ne.0.)then
                  if(ifsame(ntemp,c_f(lc,jjface(face_a(itemp))),  &
     &            nbe,j(face_l2(l))))then
                    ntempx(temp)=ntemp
                    ifntempx(temp)=ntemp
                    nnb(l)=ntemp
                  end if
                end if
              end if
            endif
          endif
        end if
      end do

!.....check the neighbor element, neighbored by a vertex only

!.....nnb are the three possible neighbor elements neighbored by an edge

      nnb(1)=ifntempx(cal_nnb(1,i))
      nnb(2)=ifntempx(cal_nnb(2,i))
      nnb(3)=ifntempx(cal_nnb(3,i))
      ntemp=0

!.....the neighbor element neighbored by a vertex must be a neighbor of
!     a valid(nonzero) nnb(i), neighbored by a face 

      if(nnb(1).ne.0)then
        lc=oplc(local_corner(i,face_a(3)))
        ii=cal_iijj(1,lc)
        jj=cal_iijj(2,lc)
!.......ntemp records the neighbor of iel, neighbored by vertex i 
        ntemp=sje(ii,jj,face_a(3),nnb(1))
!.......temp is the vertex index of i on ntemp
        temp=cal_intempx(lc,face_a(3))
        if(ntemp.eq.0)then
          ntemp=sje(1,1,face_a(3),nnb(1))
          if(ntemp.ne.0)then
            if(ifsame(ntemp,c_f(lc,jjface(face_a(3))),  &
     &         iel,i))then
              ntempx(temp)=ntemp
              ifntempx(temp)=ntemp
            end if
          end if
        else
          if(ntemp.ne.0)then
            if(ifsame(ntemp,c_f(lc,jjface(face_a(3))),  &
     &         iel,i))then
              ntempx(temp)=ntemp
              ifntempx(temp)=ntemp
            end if
          end if
        end if
      elseif(nnb(2).ne.0)then
        lc=oplc(local_corner(i,face_a(1)))
        ii=cal_iijj(1,lc)
        jj=cal_iijj(2,lc)
        ntemp=sje(ii,jj,face_a(1),nnb(2))
        temp=cal_intempx(lc,face_a(1))
        if(ntemp.eq.0)then
          ntemp=sje(1,1,face_a(1),nnb(2))
          if(ntemp.ne.0)then
            if(ifsame(ntemp,  &
     &        c_f(lc,jjface(face_a(1))),iel,i))then
              ntempx(temp)=ntemp
              ifntempx(temp)=ntemp
            end if
          end if
        else
          if(ntemp.ne.0)then
            if(ifsame(ntemp,  &
     &      c_f(lc,jjface(face_a(1))),iel,i))then
              ntempx(temp)=ntemp
              ifntempx(temp)=ntemp
            end if
          end if
        end if
      elseif(nnb(3).ne.0)then
        lc=oplc(local_corner(i,face_a(2)))
        ii=cal_iijj(1,lc)
        jj=cal_iijj(2,lc)
        ntemp=sje(ii,jj,face_a(2),nnb(3))
        temp=cal_intempx(lc, face_a(2))
        if(ntemp.eq.0)then
          ntemp=sje(1,1,face_a(2),nnb(3))
          if(ntemp.ne.0)then
            if(ifsame(ntemp,  &
     &         c_f(lc,jjface(face_a(2))),iel,i))then
              ifntempx(temp)=ntemp
              ntempx(temp)=ntemp
            end if
          end if
        else
          if(ntemp.ne.0)then
            if(ifsame(ntemp,  &
     &        c_f(lc,jjface(face_a(2))),iel,i))then
              ifntempx(temp)=ntemp
              ntempx(temp)=ntemp
            end if
          end if
        end if
      end if

!.....ifntempx records all elements sharing this vertex, assign count
!     to all these elements.

      if (ifntempx(1).ne.0) then
        idmo(lx1,lx1,2,2,1,ntempx(1))=count
        idmo(lx1,lx1,2,2,3,ntempx(1))=count
        idmo(lx1,lx1,2,2,5,ntempx(1))=count
        call get_emo(ntempx(1),count,8)
      end if

      if (ifntempx(2).ne.0) then
        idmo(lx1,lx1,2,2,2,ntempx(2))=count
        idmo(1,lx1,2,1,3,ntempx(2))=count
        idmo(1,lx1,2,1,5,ntempx(2))=count
        call get_emo(ntempx(2),count,7)
      end if

      if (ifntempx(3).ne.0) then
        idmo(1,lx1,2,1,1,ntempx(3))=count
        idmo(lx1,lx1,2,2,4,ntempx(3))=count
        idmo(lx1,1,1,2,5,ntempx(3))=count
        call get_emo(ntempx(3),count,6)
      end if
      if (ifntempx(4).ne.0) then
        idmo(1,lx1,2,1,2,ntempx(4))=count
        idmo(1,lx1,2,1,4,ntempx(4))=count
        idmo(1,1,1,1,5,ntempx(4))=count
        call get_emo(ntempx(4),count,5)
      end if

      if (ifntempx(5).ne.0) then
        idmo(lx1,1,1,2,1,ntempx(5))=count
        idmo(lx1,1,1,2,3,ntempx(5))=count
        idmo(lx1,lx1,2,2,6,ntempx(5))=count
        call get_emo(ntempx(5),count,4)
      end if


      if (ifntempx(6).ne.0) then
        idmo(lx1,1,1,2,2,ntempx(6))=count
        idmo(1,1,1,1,3,ntempx(6))=count
        idmo(1,lx1,2,1,6,ntempx(6))=count
        call get_emo(ntempx(6),count,3)
      end if

      if (ifntempx(7).ne.0) then
        idmo(1,1,1,1,1,ntempx(7))=count
        idmo(lx1,1,1,2,4,ntempx(7))=count
        idmo(lx1,1,1,2,6,ntempx(7))=count
        call get_emo(ntempx(7),count,2)
      end if

      if (ifntempx(8).ne.0) then
        idmo(1,1,1,1,2,ntempx(8))=count
        idmo(1,1,1,1,4,ntempx(8))=count
        idmo(1,1,1,1,6,ntempx(8))=count
        call get_emo(ntempx(8),count,1)
      end if

      return
      end

     
!---------------------------------------------------------------
      subroutine mor_ne(mor_v,nn,edge,face,edge2,face2,ntemp,iel)
!---------------------------------------------------------------
!     Copy the mortar points index  (mor_v + vertex mortar point) from
!     edge'th local edge on face'th face on element ntemp to iel.
!     ntemp is iel's neighbor, neighbored by this edge only. 
!     This subroutine is for the situation that iel is of larger
!     size than ntemp.  
!     face, face2 are face indices
!     edge and edge2 are local edge numbers of this edge on face and face2
!     nn is edge motar index, which indicate whether this edge
!     corresponds to the left/bottom or right/top part of the edge
!     on iel.
!---------------------------------------------------------------

      use ua_data
      implicit none

      integer mor_v(3),nn,edge,face,edge2,face2,ntemp,iel, i,  &
     &mor_s_v(4)

!.....get mor_s_v which is the mor_v + vertex mortar
      if (edge.eq.3) then
        if(nn.eq.1)then
          do i=2,lx1-1
            mor_s_v(i-1)=mor_v(i-1)
          end do
          mor_s_v(4)=idmo(lx1,lx1,2,2,face,ntemp)
        else
          mor_s_v(1)=idmo(1,lx1,2,1,face,ntemp)
          do i=2,lx1-1
            mor_s_v(i)=mor_v(i-1)
          end do
        endif
      
      elseif (edge.eq.4) then
        if(nn.eq.1)then
          do i=2,lx1-1
            mor_s_v(i-1)=mor_v(i-1)
          end do
          mor_s_v(4)=idmo(1,lx1,2,1,face,ntemp)
        else
          mor_s_v(1)=idmo(1,1,1,1,face,ntemp)
          do i=2,lx1-1
            mor_s_v(i)=mor_v(i-1)
          end do
        endif

      elseif (edge.eq.1) then
        if(nn.eq.1)then
          do i=2,lx1-1
            mor_s_v(i-1)=mor_v(i-1)
          end do
          mor_s_v(4)=idmo(lx1,1,1,2,face,ntemp)
        else
          mor_s_v(1)=idmo(1,1,1,1,face,ntemp)
          do i=2,lx1-1
            mor_s_v(i)=mor_v(i-1)
          end do
         endif

      else if (edge.eq.2) then
        if(nn.eq.1)then
          do i=2,lx1-1
             mor_s_v(i-1)=mor_v(i-1)
          end do
          mor_s_v(4)=idmo(lx1,lx1,2,2,face,ntemp)
        else
          mor_s_v(1)=idmo(lx1,1,1,2,face,ntemp)
          do i=2,lx1-1
             mor_s_v(i)=mor_v(i-1)
          end do
        endif
      end if

!.....copy mor_s_v to iel's local edge(op(edge)), on face jjface(face)
      call mor_s_e_nn(op(edge),jjface(face),iel,mor_s_v,nn)
!.....copy mor_s_v to iel's local edge(op(edge2)), on face jjface(face2)
!     since this edge is shared by two faces on iel
      call mor_s_e_nn(op(edge2),jjface(face2),iel,mor_s_v,nn)

      return
      end

!---------------------------------------------------------------------
!---------------------------------------------------------------------

       subroutine error_norm(rms)

!---------------------------------------------------------------------
!---------------------------------------------------------------------

!---------------------------------------------------------------------
! this function computes the norm of the difference between the
! computed solution and the exact solution
!---------------------------------------------------------------------

       use sp_data
       implicit none

       integer i, j, k, m, d
       double precision xi, eta, zeta, u_exact(5), rms(5), add

       do m = 1, 5
          rms(m) = 0.0d0
       enddo

!$omp parallel do default(shared)  &
!$omp&   private(i,j,k,m,zeta,eta,xi,add,u_exact)  &
!$omp&   reduction(+:rms)  &
!$omp&   schedule(static) collapse(2)
       do   k = 0, grid_points(3)-1
          do   j = 0, grid_points(2)-1
             zeta = dble(k) * dnzm1
             eta = dble(j) * dnym1
             do   i = 0, grid_points(1)-1
                xi = dble(i) * dnxm1
                call exact_solution(xi, eta, zeta, u_exact)

                do   m = 1, 5
                   add = u(m,i,j,k)-u_exact(m)
                   rms(m) = rms(m) + add*add
                end do
             end do
          end do
       end do
!$omp end parallel do

       do    m = 1, 5
          do    d = 1, 3
             rms(m) = rms(m) / dble(grid_points(d)-2)
          end do
          rms(m) = dsqrt(rms(m))
       end do

       return
       end



       subroutine rhs_norm(rms)

       use sp_data
       implicit none

       integer i, j, k, d, m
       double precision rms(5), add

       do m = 1, 5
          rms(m) = 0.0d0
       enddo

!$omp parallel do default(shared) private(i,j,k,m,add)  &
!$omp&   reduction(+:rms)  &
!$omp&   schedule(static) collapse(2)
       do k = 1, nz2
          do j = 1, ny2
             do i = 1, nx2
                do m = 1, 5
                   add = rhs(m,i,j,k)
                   rms(m) = rms(m) + add*add
                end do 
             end do 
          end do 
       end do 
!$omp end parallel do

       do   m = 1, 5
          do   d = 1, 3
             rms(m) = rms(m) / dble(grid_points(d)-2)
          end do
          rms(m) = dsqrt(rms(m))
       end do

       return
       end

      subroutine print_results(name, class, n1, n2, n3, niter,  &
     &               t, mops, optype, verified, npbversion,  &
     &               compiletime, cs1, cs2, cs3, cs4, cs5, cs6, cs7)
      
      implicit none
      character(len=*) name
      character class
      integer   n1, n2, n3, niter, j
      double precision t, mops
      character optype*24, size*15
      logical   verified
      character(len=*) npbversion, compiletime,  &
     &              cs1, cs2, cs3, cs4, cs5, cs6, cs7
      integer   num_threads, max_threads
!$    integer omp_get_num_threads, omp_get_max_threads
!$    external omp_get_num_threads, omp_get_max_threads


      max_threads = 0
!$    max_threads = omp_get_max_threads()

!     figure out number of threads used
      num_threads = 0
!$omp parallel shared(num_threads)
!$omp master
!$    num_threads = omp_get_num_threads()
!$omp end master
!$omp end parallel


         write (*, 2) name
 2       format(//, ' ', A, ' Benchmark Completed.')

         write (*, 3) Class
 3       format(' Class           = ', 12x, a12)

!   If this is not a grid-based problem (EP, FT, CG), then
!   we only print n1, which contains some measure of the
!   problem size. In that case, n2 and n3 are both zero.
!   Otherwise, we print the grid size n1xn2xn3

         if ((n2 .eq. 0) .and. (n3 .eq. 0)) then
            if (name(1:2) .eq. 'EP') then
               write(size, '(f15.0)' ) 2.d0**n1
               j = 15
               if (size(j:j) .eq. '.') j = j - 1
               write (*,42) size(1:j)
 42            format(' Size            = ',9x, a15)
            else
               write (*,44) n1
 44            format(' Size            = ',12x, i12)
            endif
         else
            write (*, 4) n1,n2,n3
 4          format(' Size            =  ',9x, i4,'x',i4,'x',i4)
         endif

         write (*, 5) niter
 5       format(' Iterations      = ', 12x, i12)
         
         write (*, 6) t
 6       format(' Time in seconds = ',12x, f12.2)

         if (num_threads .gt. 0) write (*,7) num_threads
 7       format(' Total threads   = ', 12x, i12)
         
         if (max_threads .gt. 0) write (*,8) max_threads
 8       format(' Avail threads   = ', 12x, i12)

         if (num_threads .ne. max_threads) write (*,88) 
 88      format(' Warning: Threads used differ from threads available')

         write (*,9) mops
 9       format(' Mop/s total     = ',12x, f12.2)

         if (num_threads .gt. 0) write (*,10) mops/float( num_threads )
 10      format(' Mop/s/thread    = ', 12x, f12.2)        

         write(*, 11) optype
 11      format(' Operation type  = ', a24)

         if (verified) then 
            write(*,12) '  SUCCESSFUL'
         else
            write(*,12) 'UNSUCCESSFUL'
         endif
 12      format(' Verification    = ', 12x, a)

         write(*,13) npbversion
 13      format(' Version         = ', 12x, a12)

         write(*,14) compiletime
 14      format(' Compile date    = ', 12x, a12)


         write (*,121) cs1
 121     format(/, ' Compile options:', /,  &
     &          '    FC           = ', A)

         write (*,122) cs2
 122     format('    FLINK        = ', A)

         write (*,123) cs3
 123     format('    F_LIB        = ', A)

         write (*,124) cs4
 124     format('    F_INC        = ', A)

         write (*,125) cs5
 125     format('    FFLAGS       = ', A)

         write (*,126) cs6
 126     format('    FLINKFLAGS   = ', A)

         write(*, 127) cs7
 127     format('    RAND         = ', A)
        
         write (*,130)
 130     format(//' Please send all errors/feedbacks to:'//  &
     &            ' NPB Development Team'/  &
     &            ' npb@nas.nasa.gov'//)
! 130     format(//' Please send the results of this run to:'//
!     >            ' NPB Development Team '/
!     >            ' Internet: npb@nas.nasa.gov'/
!     >            ' '/
!     >            ' If email is not available, send this to:'//
!     >            ' MS T27A-1'/
!     >            ' NASA Ames Research Center'/
!     >            ' Moffett Field, CA  94035-1000'//
!     >            ' Fax: 650-604-3957'//)


         return
         end

BEGIN { SMAKE = "make" } {
  if ($1 !~ /^#/ &&  NF > 1) {
    printf "cd `echo %s|tr '[a-z]' '[A-Z]'`; %s clean;", $1, SMAKE;
    printf "%s CLASS=%s", SMAKE, $2;
    if (NF > 2) {
      printf " VERSION=%s", $3;
    }
    printf "; cd ..\n";
  }
}
